//
//  FieldView.m
//  Awars III
//
//  Created by Killery on 2013/02/22.
//  Copyright (c) 2013年 Killery. All rights reserved.
//

#import "FieldView.h"
#import "FieldScene.h"

@implementation FieldView
-(BOOL)isFlipped{
    return YES;
}

- (id)initWithFrame:(NSRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        
        fieldView = self;
        
        time  = [NSTimer
                 scheduledTimerWithTimeInterval:1.0/30
                 target:self
                 selector:@selector(EventLoopFV:)
                 userInfo:nil
                 repeats:YES
                 ];
        chip = [[self LoadImage:@"マス.png"] retain];
        chipSelect = [[self LoadImage:@"セレクター.png"] retain];
        chipMove = [[self LoadImage:@"セレクター（移動）.png"] retain];
        chipAttack = [[self LoadImage:@"セレクター（攻撃）.png"] retain];
        chipTarget = [[self LoadImage:@"セレクター（選択）.png"] retain];
        chipSummon = [[self LoadImage:@"セレクター（攻撃）.png"] retain];
        chipTeam0 = [[self LoadImage:@"ハイライト（青）.png"] retain];
        chipTeam1 = [[self LoadImage:@"ハイライト（黄）.png"] retain];
        chipTeam2 = [[self LoadImage:@"ハイライト（赤）.png"] retain];
        chipUtarg = [[self LoadImage:@"ターゲット（目標）.png"] retain];
        
        n1 = [[self LoadImage:@"num1"] retain];
        n2 = [[self LoadImage:@"num2"] retain];
        n3 = [[self LoadImage:@"num3"] retain];
        n4 = [[self LoadImage:@"num4"] retain];
        n5 = [[self LoadImage:@"num5"] retain];
        n6 = [[self LoadImage:@"num6"] retain];
        n7 = [[self LoadImage:@"num7"] retain];
        n8 = [[self LoadImage:@"num8"] retain];
        n9 = [[self LoadImage:@"num9"] retain];
        n10 = [[self LoadImage:@"num10"] retain];
        n11 = [[self LoadImage:@"num11"] retain];
        n12 = [[self LoadImage:@"num12"] retain];
        n13 = [[self LoadImage:@"num13"] retain];
        n14 = [[self LoadImage:@"num14"] retain];
        n15 = [[self LoadImage:@"num15"] retain];
        n16 = [[self LoadImage:@"num16"] retain];
        n17 = [[self LoadImage:@"num17"] retain];
        n18 = [[self LoadImage:@"num18"] retain];
        n19 = [[self LoadImage:@"num19"] retain];
        n20 = [[self LoadImage:@"num20"] retain];
        
        g_shallowDepth = 1002;
        
    }
    
    return self;
}


-(void)EventLoopFV:(NSTimer*)timer{
    
    //if(unitBreak) NSLog(@"unitBreakAtkrange %d", unitBreak->atkRange);
    
    if(mouseClickedFlag){
        mouseDoubleClickedCnt++;
        
        if(mouseDoubleClickedCnt > 10){
            mouseDoubleClickedCnt = 0;
            mouseClickedFlag = false;
        }
    }
    
    if(evInitMap) {evInitMap = false;

        NSRect seRect = NSMakeRect(0, 0, chipWidth*32, chipHeight*32);
        [self setFrame:seRect];
        chipNum[0][0] = 0;
        
    }
    static int i0 = 0;
    static int movePlus = 0;
    static int cPosX;
    static int cPosY;
    
    static int chipTargetCnt = 0;
    
    if(endGameCondition){
        i0 = 0;
        unitMoveBugFixFlag = false;
        unitMoveEndFlag = false;
        submitFlag = true;
        stanbyFlag = false;
    }
    
    chipTargetCnt++;
    
    if(chipTargetCnt > 60){
        
        if(!chipTargetFlag) chipTargetFlag = true;
        else chipTargetFlag = false;
        chipTargetCnt = 0;
    }
    
    if(!Uselected)
        Uselected = unitBreak;
    
    if(stanbyFlag){
        
        
        if(!submitFlag) movePlus += 1;
        if( i0 < g_shallowDepth && movePlus >= 3 && !submitFlag)
        {
            cPosX = g_moveRoute[i0][1]*32;
            cPosY = g_moveRoute[i0][0]*32;
            i0++;
            movePlus = 0;
            currentPosX = cPosX;
            currentPosY = cPosY;
            unitMoveBugFixFlag = true;
            
            if(i0 == 2) {
                unitNum[g_moveRoute[0][1]][g_moveRoute[0][0]] = -1;
                unitTeam[g_moveRoute[0][1]][g_moveRoute[0][0]] = -1;
                loadNum[g_moveRoute[0][1]][g_moveRoute[0][0]] = -1;
            }
        }
        if(i0 >= g_shallowDepth) {i0--;
            
            unitNum[g_moveRoute[i0][1]][g_moveRoute[i0][0]] = Uselected->C.chipNumb;
            loadNum[g_moveRoute[i0][1]][g_moveRoute[i0][0]] = Uselected->CL.chipNumb;
            if(Uselected->team == 0){
                if(Uselected->joinArmyFromNext){
                    unitTeam[g_moveRoute[i0][1]][g_moveRoute[i0][0]] = 1;
                }else{
                    unitTeam[g_moveRoute[i0][1]][g_moveRoute[i0][0]] = 0;
                }
            }else if(Uselected->team == 1){
                if(Uselected->joinArmyFromNext){
                    unitTeam[g_moveRoute[i0][1]][g_moveRoute[i0][0]] = 5;
                }else{
                    unitTeam[g_moveRoute[i0][1]][g_moveRoute[i0][0]] = 4;
                }
            }else if(Uselected->team == 2){
                if(Uselected->joinArmyFromNext){
                    unitTeam[g_moveRoute[i0][1]][g_moveRoute[i0][0]] = 3;
                }else{
                    unitTeam[g_moveRoute[i0][1]][g_moveRoute[i0][0]] = 2;
                }
            }
            
            submitFlag = true;
            unitMoveEndFlag = true;
            unitMoveBugFixFlag = false;
            pussyLoopFlag = false;
            if(Utarget)
                cpuIsAttackingFlag = true;
            i0 = 0;
            
            U = UTop;
            while(U){
                if(g_moveRoute[0][1] == U->x && g_moveRoute[0][0] == U->y){
                    U->x = g_moveRoute[g_shallowDepth-1][1];
                    U->y = g_moveRoute[g_shallowDepth-1][0];
                    break;
                }
                U = U->next;
            }
            
            if(U) unitBreak = U;
            
            U = UTop;
        }
    }else{
        submitFlag = false;
        i0 = 0;
        unitMoveBugFixFlag = false;
        
        for(int j = 0;j < g_shallowDepth;j++){
            g_moveRoute[j][0] = -1;
            g_moveRoute[j][1] = -1;
        }
    }
    
    U = UTop;
    if(initStatusFlag)
        while (U) {
            
            if(U->dead || (U->chipNumber >= 0 && U->C.S_C.HP <= 0)){
                U->dead = true;
                unitNum[U->x][U->y] = -1;
                unitTeam[U->x][U->y] = -1;
                U->x = -1;
                U->y = -1;
            }
            U = U->next;
        }
    U = UTop;
    
    U = UTop;
    if(initStatusFlag)
        while (U) {
            
            if(U->dead || (U->chipNumberL >= 0 && U->CL.S_C.HP <= 0)){
                U->dead = true;
                loadNum[U->x][U->y] = -1;
                unitTeam[U->x][U->y] = -1;
                U->x = -1;
                U->y = -1;
            }
            U = U->next;
        }
    U = UTop;
    
    ////////////バグフィクス///////////////////
    if(UTop && initStatusFlag)
        for (int i = 1;i <= chipWidth;i++) {
            for (int k = 1;k <= chipHeight;k++) {
                
                bool noFixFlag = false;
                U = UTop;
                while(U){
                    
                    if((U->x == i && U->y == k)){
                        noFixFlag = true;
                        break;
                    }
                    
                    U = U->next;
                }U = UTop;
                
                if(!noFixFlag){
                    unitNum[i][k] = -1;
                    loadNum[i][k] = -1;
                    unitTeam[i][k] = -1;
                }
            }
        }
    
    if(1){
        U = UTop;
        slctedUnitNum = 0;
        while(U != NULL){
            if(U->x == possionX && U->y == possionY){
                break;
            }
            slctedUnitNum++;
            U = U->next;
        }
        if(!U) slctedUnitNum = -1;
        U = UTop;
        
    }
    
    if(dcRdy){
        U = UTop;
        for (int i = 0; i < slctedUnitNum; i++) {
            U = U->next;
        }
        if(U->chipNumberL < 0){
            U = UTop;
            
            while(U && !(possionX == U->x && possionY == U->y)){
                U = U->next;
            }
            
            [self LookupAttackRange:possionY startY:possionX aPiece:&U->C turnSide:YES];
            U = UTop;
        }else {
            U = UTop;
            [self LookupAttackRange2:possionY startY:possionX aPiece:&LC[loadNum[possionX][possionY]] turnSide:YES];
        }
        U = UTop;
        
        dcRdy = false;
    }else if(dcRdy2){
        U = UTop;
        int i = 1;
        while(U && AUN[1] > i){i++;
            U = U->next;
        }
        attackExceptNumber = U->number;
        if(U->chipNumberL < 0){
            
            [self LookupAttackRangeExtent:possionY startY:possionX aPiece:&U->C turnSide:YES];
            U = UTop;
        }else {
            
            [self LookupAttackRangeExtent2:possionY startY:possionX aPiece:&U->CL turnSide:YES];
        }
        U = UTop;
        
        dcRdy2 = false;
    }
    
    
    
    if(bclRdy){
        U = UTop;
        
        while(U->number != AUN[1]){
            U = U->next;
        }
       
        
        if(U)
            buildNum[possionX][possionY] = U->C.S->list[crBCL]-1;
        
        U = UTop;
        bclRdy = false;
        
        createFlag = false;
    }
    
    if(Uselected)
        if(Uselected->dead){
            Uselected = NULL;
        }
    
    if(cslRdy){
        [self LookupSummonRange:possionY startY:possionX aPiece:&UC[unitNum[possionX][possionY]] turnSide:YES];
        cslRdy = false;
    }
    
    if(buildCaptureFlag && unitMoveEndFlag){
        
        B = BTop;
        while (B) {
            if(B->x == Uselected->x && B->y == Uselected->y){
                if(Uselected->team == 0) B->team = 0;
                if(Uselected->team == 1) B->team = 1;
                if(Uselected->team == 2) B->team = 2;
                unitColorInitFlag = true;
            }
            B = B->next;
        }B = BTop;
        
        buildCaptureFlag = false;
    }
    
    if(unitColorInitFlag){
        U = UTop;
        while(U){
            if(!U->CL.nameID){
                if(U->team == 0)
                    U->img = [self SetImageColor:U->C.img color:0];
                if(U->team == 1)
                    U->img = [self SetImageColor:U->C.img color:1];
                if(U->team == 2)
                    U->img = [self SetImageColor:U->C.img color:2];
            }else{
                if(U->team == 0)
                    U->img = [self SetImageColor:U->CL.img color:0];
                if(U->team == 1)
                    U->img = [self SetImageColor:U->CL.img color:1];
                if(U->team == 2)
                    U->img = [self SetImageColor:U->CL.img color:2];
            }
            
 
            
            U = U->next;
        }U = UTop;
        
        B = BTop;
        while(B){
            if(B->team < 0) B->img = B->C.img;
            if(B->team == 0)
                B->img = [self SetImageColor:B->C.img color:0];
            if(B->team == 1)
                B->img = [self SetImageColor:B->C.img color:1];
            if(B->team == 2)
                B->img = [self SetImageColor:B->C.img color:2];
            B = B->next;
        }B = BTop;
        
        unitColorInitFlag = false;
        
    }
    
    
    if(fieldViewBattleInitFlag){
        
    }
    
    
    
    if(waitSwtichFlag){
        static int wcnt = 0;
        wcnt++;
        if(wcnt >= waitinTime*100){
            waitAllOverFlag = true;
            wcnt = 0;
        }
    }
    
    chipNum[0][0]= 0;
    [self setNeedsDisplay:YES];
    
    if(initStatusFlag)
        battleBegin = true;
    
    
    
    if(unitBreak){
        
        if(unitBreak->dead && unitBreak->C.S_C.WT == 999999){
            wtRdy = false;
            wtRdy2 = false;
            wtRdy3 = false;
            stanbyFlag = true;
            cpuOMFGmoveATKfixFlag = true;
        }
        
        if(unitBreak->dead && unitBreak->C.S_C.WT != 999999){
            unitNum[unitBreak->x][unitBreak->y] = -1;
            unitBreak->C.S_C.WT = 999999;
            wtRdy = false;
            wtRdy2 = false;
            wtRdy3 = false;
            stanbyFlag = true;
            cpuOMFGmoveATKfixFlag = true;
        }
        
    }
    
}

-(NSImage*)SetImageColor:(NSImage*)image color:(int)c{
    NSImage *maskBlue, *maskRed, *maskYellow;
    
    maskBlue = [NSImage imageNamed:@"ハイライト（青）"];
    maskRed = [NSImage imageNamed:@"ハイライト（赤）"];
    maskYellow = [NSImage imageNamed:@"ハイライト（黄）"];
    
    NSImage *img = [NSImage alloc];
    img = [image copy];
    
    if(c == 0){
        [img lockFocus];
        //[image drawInRect:NSMakeRect(0, 0, image.size.width, image.size.height) fromRect:NSMakeRect(0, 0, maskBlue.size.width, maskBlue.size.height) operation:NSCompositeClear fraction:1.0];
        
        [maskBlue drawInRect:NSMakeRect(0, 0, image.size.width, image.size.height) fromRect:NSMakeRect(0, 0, maskBlue.size.width, maskBlue.size.height) operation:NSCompositeXOR fraction:1.0];
        
        [maskBlue drawInRect:NSMakeRect(0, 0, image.size.width, image.size.height) fromRect:NSMakeRect(0, 0, maskBlue.size.width, maskBlue.size.height) operation:NSCompositeXOR fraction:1.0];
        
        [img drawInRect:NSMakeRect(0, 0, image.size.width, image.size.height) fromRect:NSMakeRect(0, 0, image.size.width, image.size.height) operation:NSCompositeSourceOver fraction:0.6];
        
        [img unlockFocus];
        
    }
    
    if(c == 1){
        [img lockFocus];
        
        [maskYellow drawInRect:NSMakeRect(0, 0, image.size.width, image.size.height) fromRect:NSMakeRect(0, 0, maskBlue.size.width, maskBlue.size.height) operation:NSCompositeXOR fraction:1.0];
        
        [maskYellow drawInRect:NSMakeRect(0, 0, image.size.width, image.size.height) fromRect:NSMakeRect(0, 0, maskBlue.size.width, maskBlue.size.height) operation:NSCompositeXOR fraction:1.0];
        
        [img drawInRect:NSMakeRect(0, 0, image.size.width, image.size.height) fromRect:NSMakeRect(0, 0, image.size.width, image.size.height) operation:NSCompositeSourceOver fraction:0.6];
        
        [img unlockFocus];
    }
    
    if(c == 2){
        [img lockFocus];
        
        [maskRed drawInRect:NSMakeRect(0, 0, image.size.width, image.size.height) fromRect:NSMakeRect(0, 0, maskBlue.size.width, maskBlue.size.height) operation:NSCompositeXOR fraction:1.0];
        
        [maskRed drawInRect:NSMakeRect(0, 0, image.size.width, image.size.height) fromRect:NSMakeRect(0, 0, maskBlue.size.width, maskBlue.size.height) operation:NSCompositeXOR fraction:1.0];
        
        [img drawInRect:NSMakeRect(0, 0, image.size.width, image.size.height) fromRect:NSMakeRect(0, 0, image.size.width, image.size.height) operation:NSCompositeSourceOver fraction:0.6];
        
        [img unlockFocus];
    }
    
    return img;
}

-(NSImage*)LoadImage:(NSString*)name{
    NSImage *image = [NSImage imageNamed:name];
    if(image == nil) return nil;
    //[image setFlipped:[self isFlipped]];
    
    return image;
}

-(void)DrawImage:(NSImage*)image x:(float)x y:(float)y cx:(int)cx cy:(int)cy f:(float)frac{
    NSRect frRect;
    frRect.size.height = image.size.height;
    frRect.size.width = image.size.width;
    
    frRect.origin.x = 0;
    frRect.origin.y = 0;
    
    NSRect drRect;
    drRect.origin.x = x;
    drRect.origin.y = y;
    drRect.size.height = 32;
    drRect.size.width = 32;
    
    [image drawInRect:drRect fromRect:frRect operation:NSCompositeSourceOver fraction:frac respectFlipped:YES hints:nil];
    
}

-(void)mouseDown:(NSEvent *)theEvent{
    
    mouseClickedFlag = true;
    if(mouseDoubleClickedCnt > 0){
        mouseDoubleClickedFlag = true;
        mouseClickedFlag = false;
        mouseDoubleClickedCnt = 0;
    }else{
        mouseDoubleClickedFlag = false;
    }
    
    
    if(stopByFSVmenuFlag)
        return;
    
    //if(cpuOMFGmoveATKfixFlag) return;
    
    if(!battleBegin) return;
    
    if(setBattleModeFlag) return;
    
    if(endGameCondition) return;
    
    if(waitSwtichFlag) return;
    
    if(CPUturn && !messageDialog) return;
    
    if(messageDialog && textInstantBugFixFlag){
        
        
        if(msgCnt >= msgMax){
            msgLvl++;
            msgCnt = 0;
            messageEndFlag = true;
        }else{
            msgCnt = msgMax-1;
        }
        
        
        return;
    }
    
    if(coolTime)
        return;
    
    /*
    if(cpuAImodeflag)
        return;*/
    
    if(P[1].type == 1){
        
        U = UTop;
        while (U) {
            if(unitBreak->team == 2){
                U = UTop;
                return;
            }
            U = U->next;
        }
        U = UTop;
    }
    
    drugPoint = [self convertPoint:[theEvent locationInWindow] fromView:nil];
    
    possionX = (int)drugPoint.x/32+1;
    possionY = (int)drugPoint.y/32+1;
    
    NSPoint drugPoint2 = [self convertPoint:[theEvent locationInWindow] fromView:self];
    
    possionLocalX = (int)drugPoint2.x/32+1;
    possionLocalY = (int)drugPoint2.y/32+1;
    
    menuDisplayFlag = false;
    
    cpuOMFGmoveATKfixFlag = true;
    
    U = UTop;
    
    if(attackExtentFlag2 && g_attackRangeExtent[possionX][possionY] > 0){
        attackExtentFlag2 = false;
        attackFlag = false;
        extentBattleFlag = true;
        wtAttackedFlag = true;
        
        for (int i = 0;i < 255;i++) {
            DUN[i] = -1;
        }
        
        int Unum = 0;
        
        
        while (U) {
            Unum++;
            U = U->next;
        }U = UTop;
        
        while(U->number != AUN[1]){
            U = U->next;
        }
        UNIT *AUNU = U;
        
        U = UTop;
        int z = 0;
        static bool okflag = true;
        while(U){
            for (int i = 0;i < 1002;i++) {
                for (int k = 0;k < 1002;k++) {
                    objeR[i][k] = 0;
                }
            }
            if(U->chipNumberL < 0){
                [self checkAttackRangeExtent:possionY startY:possionX leftPow:AUNU->C.A->extent+1 pieceType:1 aMap:g_attackRangeExtent aPiece:&AUNU->C];
            }else {
                [self checkAttackRangeExtent:possionY startY:possionX leftPow:AUNU->C.A->extent+1 pieceType:1 aMap:g_attackRangeExtent aPiece:&AUNU->C];
            }
            
            int Cnum = 0;
            
            for(int bx=1;bx<=chipWidth;bx++){
                for(int by=1;by<=chipHeight;by++){
                    if(g_attackRangeExtent[bx][by] != 999 && g_attackRangeExtent[bx][by] > 0){
                        
                        if(g_attackRangeExtent[U->x][U->y] > 0 && attackExceptNumber != U-> number){
                            Cnum++;
                            if(Unum < Cnum) goto lolzOMFG;
                            
                            
                            
                            
                            
                            if(UP)
                            {
                                if(!UPT){
                                    UPT = UP;
                                }
                                
                                UP = UPT;
                                while (UP) {
                                    if(UP->x == U->x && UP->y == U->y){
                                        
                                        break;
                                    }else{
                                        okflag = true;
                                    }
                                    
                                    UP = UP->next;
                                }
                                
                            }
                            UP = UPT;
                            
                            if(!UP) UP = calloc(1, sizeof(UNITPOINT));
                            else if(UP){
                                while(UP->next) UP = UP->next;
                            }
                            if(okflag){
                                z++;
                                UP->x = U->x;
                                UP->y = U->y;
                                UP->next = calloc(1, sizeof(UNITPOINT));
                                okflag = false;
                                DUN[z] = U->number;
                                
                            }
                        }
                        
                    }
                }
            }
            
        lolzOMFG:
            UP = NULL;
            UPT = NULL;
            
            U = U->next;
        }U = UTop;
        okflag = true;
        attackingWait = false;
        //NSLog(@"%d", DUN[0]);
        return;
    }else if(attackExtentFlag2){
        attackExtentFlag2 = false;
        attackFlag = false;
        extentBattleFlag = false;
    }
    
    
    if(attackFlag && g_attackRange[possionX][possionY] <= 0){
        dcRdy2 = false;
        attackExtentFlag2 = false;
        attackExtentFlag = false;
        attackFlag = false;
    }
    
    if(attackFlag && g_attackRange[possionX][possionY] > 0){
        if(atkExtentFlag){
            
            dcRdy2 = true;
            attackExtentFlag2 = true;
            attackExtentFlag = true;
            attackFlag = false;
        }else if(unitNum[possionX][possionY] >= 0){
            attackFlag = false;
            battleWindowFlag = true;
            
            U = UTop;
            while (AUN[1] != U->number) {
                U = U->next;
            }
            ATTACK *aTop = U->C.A;
            ATTACK *aTop2 = U->CL.A;
            if(U->chipNumberL < 0){
                for(int i = 0;i < crCAL;i++){
                    U->C.A = U->C.A->next;
                }
            }else{
                for(int i = 0;i < crCAL;i++){
                    U->CL.A = U->CL.A->next;
                }
            }
            
            if(U->chipNumberL < 0)
                U->atkRange = U->C.A->rangeB - g_attackRange[possionX][possionY] + 1;
            else U->atkRange = U->CL.A->rangeB - g_attackRange[possionX][possionY] + 1;
            
            U->atkRange = U->atkRange;
            U->C.A = aTop;
            U->CL.A = aTop2;
            
            U = UTop;
            while (!(U->x == possionX && U->y == possionY) && U) {
                U = U->next;
            }
            DUN[1] = U->number;
            U = UTop;
            
            wtAttackedFlag = true;
            attackingWait = true;
            return;
        }
    }U = UTop;
    
    if(summonFlag && g_summonRange[possionX][possionY] > 0 && unitNum[possionX][possionY] < 0){
        
        summonRdyFlag = true;
        summonFlag = false;
        
    }
    
    
    
    if(unitNum[possionX][possionY] >= 0){
        
        if(!attackFlag && !attackExtentFlag2) atkExtentFlag = false;
        
        if(atkExtentFlag) return;
        
        moveFlag = false;
        attackFlag = false;
        stanbyFlag = false;
        menuDisplayFlag = true;
        unitMoveEndFlag = false;
        g_cursol_x = 1+(int)drugPoint.y/32;
        g_cursol_y = 1+(int)drugPoint.x/32;
        currentPosX = g_cursol_y*32;
        currentPosY = g_cursol_x*32;
        
        UCselected = UC[unitNum[possionX][possionY]];
        LCselected = LC[loadNum[possionX][possionY]];
        
        U = UTop;
        while (U) {
            if(U->x == possionX && U->y == possionY) break;
            U = U->next;
        }
        
        
        //NSLog(@"%@, %@", U->C.name, U->C.A->name);
        if(U){
            AUN[1] = U->number;
            Uselected = U;
        }else{
            ///////////////////////////バグフィクス//////////////////////////
            
            unitNum[possionX][possionY] = -1;
            loadNum[possionX][possionY] = -1;
            U = UTop;
            return;
        }
        
        if(!wtMovedFlag){
        if(U->chipNumber >= 0) [self LookupMovableRange:possionY startY:possionX aPiece:&UC[unitNum[possionX][possionY]] turnSide:YES];
        if(U->chipNumberL >= 0) [self LookupMovableRange2:possionY startY:possionX aPiece:&LC[loadNum[possionX][possionY]] turnSide:YES];
        }
        U = UTop;
        
        //return;
    }
    
    if(buildNum[possionX][possionY] >= 0 && unitNum[possionX][possionY] < 0 && !moveFlag){
        
        if(!mouseDoubleClickedFlag)
            return;
        
        //NSLog(@"くりとりすとおちんちん");
        B = BTop;
        while (B) {
            if(B->x == possionX && B->y == possionY){
                researchTeam = -1;
                if(B->team == 0){
                    researchTeam = 0;
                    break;
                }
                if(B->team == 2){
                    researchTeam = 2;
                    break;
                }
            }
            B = B->next;
        }B = BTop;
        
        if (researchTeam < 0) {
            
        }else if(MF[MFselectedRow+1].MS.employAllowedFlag){
            stanbyFlag = false;
            buildSelectedFlag = true;
        }
    }
    
    if(moveFlag && g_selectRange[possionX][possionY] > 0){
        g_target_y = possionX;
        g_target_x = possionY;
        
        [self searchRoute];
        
        for(int i = 0;i<=chipWidth;i++){
            for(int j = 0;j<=chipHeight;j++){
                g_map[i][j] = chipNum[i][j];
                g_selectRange[i][j] = 0;
            }
        }
        moveFlag = false;
        stanbyFlag = true;
        wtPx = possionX;
        wtPy = possionY;
        wtMovedFlag = true;
        B = BTop;
        while (B) {
            if(B->x == possionX && B->y == possionY && B->C.capture){
                buildCaptureFlag = true;
            }
            B = B->next;
        }B = BTop;
        
    }
    
    summonFlag = false;
    
    pushStanbyFlag = false;
}




//-----------------------------------------------------------LookupMovableRange
//
// 与えられた位置からの移動可能範囲をg_range配列内に収める
//
//-----------------------------------------------------------------------------
-(void)LookupMovableRange:(int)startX startY:(int)startY aPiece:(UNITCHIP*)aPiece turnSide:(BOOL)turnSide
{
    if(!aPiece->nameID) return;
    
    for(int i = 0;i<=chipWidth;i++){
        for(int j = 0;j<=chipHeight;j++){
            g_map[i][j] = -1;
            g_selectRange[i][j] = 999;
        }
    }
    
    for(int i = 1;i<=chipWidth;i++){
        for(int j = 1;j<=chipHeight;j++){
            g_map[i][j] = chipNum[i][j];
            g_selectRange[i][j] = 0;
        }
    }
    
    //0 リク　1宙 2海 3空
    //0 草原 1荒地
    enum{
        MOVETYPE_RIKU,
        MOVETYPE_CHU,
        MOVETYPE_UMI,
        MOVETYPE_SORA,
    };
    for(int chipType = 0;chipType < 128;chipType++){
        g_moveCost[MOVETYPE_RIKU][chipType] = MC[chipType].riku;
        g_moveCost[MOVETYPE_CHU][chipType] = MC[chipType].chu;
        g_moveCost[MOVETYPE_UMI][chipType] = MC[chipType].umi;
        g_moveCost[MOVETYPE_SORA][chipType] = MC[chipType].sora;
    }
    
    g_selectRange[startY][startX] = aPiece->S_C.MOV+1;
    //[self excludePiece:turnSide fillInt:99];
    // 敵方のコマを迂回させるため、マップ移動最大値を詰め込む
    //[self excludePiece:turnSide fillInt:0];
    [self checkRange:startX startY:startY leftPow:aPiece->S_C.MOV+1 pieceType:aPiece->S_C.typeMOVE aMap:g_selectRange];
    //  [self excludePiece:turnSide fillInt:0];
    // 敵方のコマの位置を移動可能範囲から除外する
    //[self excludePiece:turnSide fillInt:0];
    
    
}

-(void)LookupMovableRange2:(int)startX startY:(int)startY aPiece:(LOADCHIP*)aPiece turnSide:(BOOL)turnSide
{
    if(!aPiece->nameID) return;
    
    for(int i = 0;i<=chipWidth;i++){
        for(int j = 0;j<=chipHeight;j++){
            g_map[i][j] = -1;
            g_selectRange[i][j] = 999;
        }
    }
    
    for(int i = 1;i<=chipWidth;i++){
        for(int j = 1;j<=chipHeight;j++){
            g_map[i][j] = chipNum[i][j];
            g_selectRange[i][j] = 0;
        }
    }
    
    //0 リク　1宙 2海 3空
    //0 草原 1荒地
    enum{
        MOVETYPE_RIKU,
        MOVETYPE_CHU,
        MOVETYPE_UMI,
        MOVETYPE_SORA,
    };
    for(int chipType = 0;chipType < 128;chipType++){
        g_moveCost[MOVETYPE_RIKU][chipType] = MC[chipType].riku;
        g_moveCost[MOVETYPE_CHU][chipType] = MC[chipType].chu;
        g_moveCost[MOVETYPE_UMI][chipType] = MC[chipType].umi;
        g_moveCost[MOVETYPE_SORA][chipType] = MC[chipType].sora;
    }
    
    g_selectRange[startY][startX] = aPiece->S_C.MOV+1;
    //[self excludePiece:turnSide fillInt:99];
    // 敵方のコマを迂回させるため、マップ移動最大値を詰め込む
    [self checkRange2:startX startY:startY leftPow:aPiece->S_C.MOV+1 pieceType:aPiece->S_C.typeMOVE aMap:g_selectRange];
    //[self excludePiece:turnSide fillInt:0];
    // 敵方のコマの位置を移動可能範囲から除外する
    
}

//-----------------------------------------------------------------excludePiece
// 選択範囲からコマを除外する
-(void)excludePiece:(BOOL)turnSide fillInt:(int)fillInt
{
    UNIT *UN = U;
    
    
    U = UTop;
    
    while(U){
        for(int x = 1;x <= chipWidth;x++){
            for(int y = 1;y <= chipHeight;y++){
                if(g_selectRange[U->x][U->y] > 0 && U->x == y && U->y == x){
                    g_selectRange[U->x][U->y] = fillInt;
                }
            }
        }
        U = U->next;
    }U = UN;
    g_selectRange[Uselected->x][Uselected->y] = 999;
    
}

//-------------------------------------------------------------------checkRange
// 再帰法で移動可能範囲をチェックする
// 配列の添え字と関数の引数が逆になっていることに要注意
-(void)checkRange:(int)startX startY:(int)startY leftPow:(int)leftPow pieceType:(int)pieceType aMap:(int[1002][1002])aMap{
    int  i0;
    
    
    int chipTeam;
    if(Uselected) chipTeam = Uselected->team;
    
    if(startX < 0) startX = 0;
    if(startY < 0) startY = 0;
    
    aMap[startY][startX] = leftPow;// 残り移動力
    
    
    i0 = leftPow - g_moveCost[pieceType][g_map[startY-1][startX]];  // 上
    
    
    if(unitNum[startY-1][startX] > -1 && (unitTeam[startY-1][startX] == 1 || unitTeam[startY-1][startX] == 4 || unitTeam[startY-1][startX] == 5) && chipTeam == 0){
    }else if(unitNum[startY-1][startX] > -1 && (unitTeam[startY-1][startX] == 0  || unitTeam[startY-1][startX] == 4 || unitTeam[startY-1][startX] == 5) && chipTeam == 1){
    }else if(unitNum[startY-1][startX] > -1 && (unitTeam[startY-1][startX] == 3) && chipTeam == 2){
    }else if(unitNum[startY-1][startX] > -1 && unitTeam[startY-1][startX] != chipTeam){
        i0 = 0;
    }
    if( aMap[startY-1][startX] < i0 ){
        [self checkRange:startX startY:startY - 1 leftPow:i0 pieceType:pieceType aMap:aMap];
    }
    
    
    i0 = leftPow - g_moveCost[pieceType][g_map[startY+1][startX]];  // 下
    
    
    if(unitNum[startY+1][startX] > -1 && (unitTeam[startY+1][startX] == 1 || unitTeam[startY+1][startX] == 4 || unitTeam[startY+1][startX] == 5) && chipTeam == 0){
    }else if(unitNum[startY+1][startX] > -1 && (unitTeam[startY+1][startX] == 0  || unitTeam[startY+1][startX] == 4 || unitTeam[startY+1][startX] == 5) && chipTeam == 1){
    }else if(unitNum[startY+1][startX] > -1 && (unitTeam[startY+1][startX] == 3) && chipTeam == 2){
    }else if(unitNum[startY+1][startX] > -1 && unitTeam[startY+1][startX] != chipTeam){
        i0 = 0;
    }
    if( aMap[startY+1][startX] < i0 ){
        [self checkRange:startX startY:startY + 1 leftPow:i0 pieceType:pieceType aMap:aMap];
    }
    
    
    i0 = leftPow - g_moveCost[pieceType][g_map[startY][startX-1]];  // 右
    
    
    if(unitNum[startY][startX-1] > -1 && (unitTeam[startY][startX-1] == 1 || unitTeam[startY][startX-1] == 4 || unitTeam[startY][startX-1] == 5) && chipTeam == 0){
    }else if(unitNum[startY][startX-1] > -1 && (unitTeam[startY][startX-1] == 0  || unitTeam[startY][startX-1] == 4 || unitTeam[startY][startX-1] == 5) && chipTeam == 1){
    }else if(unitNum[startY][startX-1] > -1 && (unitTeam[startY][startX-1] == 3) && chipTeam == 2){
    }else if(unitNum[startY][startX-1] > -1 && unitTeam[startY][startX-1] != chipTeam){
        i0 = 0;
    }
    if( aMap[startY][startX-1] < i0 ){
        [self checkRange:startX - 1 startY:startY leftPow:i0 pieceType:pieceType aMap:aMap];
    }
    
    
    i0 = leftPow - g_moveCost[pieceType][g_map[startY][startX+1]];  // 左
    if(unitNum[startY][startX+1] > -1 && (unitTeam[startY][startX+1] == 1 || unitTeam[startY][startX+1] == 4 || unitTeam[startY][startX+1] == 5) && chipTeam == 0){
    }else if(unitNum[startY][startX+1] > -1 && (unitTeam[startY][startX+1] == 0  || unitTeam[startY][startX+1] == 4 || unitTeam[startY][startX+1] == 5) && chipTeam == 1){
    }else if(unitNum[startY][startX+1] > -1 && (unitTeam[startY][startX+1] == 3) && chipTeam == 2){
    }else if(unitNum[startY][startX+1] > -1 && unitTeam[startY][startX+1] != chipTeam){
        i0 = 0;
    }
    if( aMap[startY][startX+1] < i0 ){
        [self checkRange:startX + 1 startY:startY leftPow:i0 pieceType:pieceType aMap:aMap];
    }
    
}

-(void)checkRange2:(int)startX startY:(int)startY leftPow:(int)leftPow pieceType:(int)pieceType aMap:(int[1002][1002])aMap{
    int  i0;
    
    
    int chipTeam;
    if(Uselected) chipTeam = Uselected->team;
    
    if(startX < 0) startX = 0;
    if(startY < 0) startY = 0;
    
    aMap[startY][startX] = leftPow;// 残り移動力
    
    
    i0 = leftPow - g_moveCost[pieceType][g_map[startY-1][startX]];  // 上
    
    if(loadNum[startY-1][startX] > -1 && (unitTeam[startY-1][startX] == 1 || unitTeam[startY-1][startX] == 4 || unitTeam[startY-1][startX] == 5) && chipTeam == 0){
    }else if(loadNum[startY-1][startX] > -1 && (unitTeam[startY-1][startX] == 0  || unitTeam[startY-1][startX] == 4 || unitTeam[startY-1][startX] == 5) && chipTeam == 1){
    }else if(loadNum[startY-1][startX] > -1 && (unitTeam[startY-1][startX] == 3) && chipTeam == 2){
    }else if(loadNum[startY-1][startX] > -1 && unitTeam[startY-1][startX] != chipTeam){
        i0 = 0;
    }
    if( aMap[startY-1][startX] < i0 ){
        [self checkRange:startX startY:startY - 1 leftPow:i0 pieceType:pieceType aMap:aMap];
    }
    
    
    i0 = leftPow - g_moveCost[pieceType][g_map[startY+1][startX]];  // 下
    
    
    if(loadNum[startY+1][startX] > -1 && (unitTeam[startY+1][startX] == 1 || unitTeam[startY+1][startX] == 4 || unitTeam[startY+1][startX] == 5) && chipTeam == 0){
    }else if(loadNum[startY+1][startX] > -1 && (unitTeam[startY+1][startX] == 0  || unitTeam[startY+1][startX] == 4 || unitTeam[startY+1][startX] == 5) && chipTeam == 1){
    }else if(loadNum[startY+1][startX] > -1 && (unitTeam[startY+1][startX] == 3) && chipTeam == 2){
    }else if(loadNum[startY+1][startX] > -1 && unitTeam[startY+1][startX] != chipTeam){
        i0 = 0;
    }
    if( aMap[startY+1][startX] < i0 ){
        [self checkRange:startX startY:startY + 1 leftPow:i0 pieceType:pieceType aMap:aMap];
    }
    
    
    i0 = leftPow - g_moveCost[pieceType][g_map[startY][startX-1]];  // 右
    
    
    if(loadNum[startY][startX-1] > -1 && (unitTeam[startY][startX-1] == 1 || unitTeam[startY][startX-1] == 4 || unitTeam[startY][startX-1] == 5) && chipTeam == 0){
    }else if(loadNum[startY][startX-1] > -1 && (unitTeam[startY][startX-1] == 0  || unitTeam[startY][startX-1] == 4 || unitTeam[startY][startX-1] == 5) && chipTeam == 1){
    }else if(loadNum[startY][startX-1] > -1 && (unitTeam[startY][startX-1] == 3) && chipTeam == 2){
    }else if(loadNum[startY][startX-1] > -1 && unitTeam[startY][startX-1] != chipTeam){
        i0 = 0;
    }
    if( aMap[startY][startX-1] < i0 ){
        [self checkRange:startX - 1 startY:startY leftPow:i0 pieceType:pieceType aMap:aMap];
    }
    
    
    i0 = leftPow - g_moveCost[pieceType][g_map[startY][startX+1]];  // 左
    
    
    if(loadNum[startY][startX+1] > -1 && (unitTeam[startY][startX+1] == 1 || unitTeam[startY][startX+1] == 4 || unitTeam[startY][startX+1] == 5) && chipTeam == 0){
    }else if(loadNum[startY][startX+1] > -1 && (unitTeam[startY][startX+1] == 0  || unitTeam[startY][startX+1] == 4 || unitTeam[startY][startX+1] == 5) && chipTeam == 1){
    }else if(loadNum[startY][startX+1] > -1 && (unitTeam[startY][startX+1] == 3) && chipTeam == 2){
    }else if(loadNum[startY][startX+1] > -1 && unitTeam[startY][startX+1] != chipTeam){
        i0 = 0;
    }
    if( aMap[startY][startX+1] < i0 ){
        [self checkRange:startX + 1 startY:startY leftPow:i0 pieceType:pieceType aMap:aMap];
    }
    
}


-(void)LookupSummonRange:(int)startX startY:(int)startY aPiece:(UNITCHIP*)aPiece turnSide:(BOOL)turnSide
{
    
    for(int i = 0;i<=chipWidth;i++){
        for(int j = 0;j<=chipHeight;j++){
            g_summonRange[i][j] = 999;
            g_summonRangeDelta[i][j] = 999;
        }
    }
    
    for(int i = 1;i<=chipWidth;i++){
        for(int j = 1;j<=chipHeight;j++){
            g_summonRange[i][j] = 0;
            g_summonRangeDelta[i][j] = 0;
        }
    }
    
    for(int chipType = 0;chipType < 1024;chipType++){
        g_attackCost[0][chipType] = 1;
    }
    
    //0 リク　1宙 2海 3空
    //0 草原 1荒地
    
    ATTACK *aTop = aPiece->A;
    for(int i = 0;i < crCAL;i++){
        aPiece->A = aPiece->A->next;
    }
    
    g_summonRange[startY][startX] = 1;
    g_summonRangeDelta[startY][startX] = 0;
    //attackMaxNum = aPiece->A->rangeB+1;
    
    //[self excludePiece:turnSide fillInt:99];
    // 敵方のコマを迂回させるため、マップ移動最大値を詰め込む
    [self checkSummonRange:startX startY:startY leftPow:2 pieceType:0 aMap:g_summonRange aPiece:aPiece];
    g_summonRange[startY][startX] = 0;
    g_summonRangeDelta[startY][startX] = 0;
    
    for(int i = 0;i<=chipWidth;i++){
        for(int j = 0;j<=chipHeight;j++){
            if(g_summonRangeDelta[i][j] > 0) g_summonRange[i][j] = 0;
        }
    }
    
    aPiece->A = aTop;
    
    //[self excludePiece:turnSide fillInt:0];
    // 敵方のコマの位置を移動可能範囲から除外する
    
}

-(void)checkSummonRange:(int)startX startY:(int)startY leftPow:(int)leftPow pieceType:(int)pieceType aMap:(int[][1002])aMap aPiece:(UNITCHIP*)aPiece{
    int  i0;
    
    if(startX < 0) startX = 0;
    if(startY < 0) startY = 0;
    
    aMap[startY][startX] = leftPow;    // 残り射程の長さ
    
    i0 = leftPow - 1;  // 上
    if( aMap[startY-1][startX] < i0 ){
        [self checkSummonRange:startX startY:startY - 1 leftPow:i0 pieceType:pieceType aMap:aMap aPiece:aPiece];
    }
    
    i0 = leftPow - 1;  // 下
    if( aMap[startY+1][startX] < i0 ){
        [self checkSummonRange:startX startY:startY + 1 leftPow:i0 pieceType:pieceType aMap:aMap aPiece:aPiece];
    }
    
    i0 = leftPow - 1;  // 右
    if( aMap[startY][startX-1] < i0 ){
        [self checkSummonRange:startX - 1 startY:startY leftPow:i0 pieceType:pieceType aMap:aMap aPiece:aPiece];
    }
    
    i0 = leftPow - 1;  // 左
    if( aMap[startY][startX+1] < i0 ){
        [self checkSummonRange:startX + 1 startY:startY leftPow:i0 pieceType:pieceType aMap:aMap aPiece:aPiece];
    }
    
}


-(void)LookupAttackRange:(int)startX startY:(int)startY aPiece:(UNITCHIP*)aPiece turnSide:(BOOL)turnSide
{
    
    for(int i = 0;i<=chipWidth;i++){
        for(int j = 0;j<=chipHeight;j++){
            g_attackRange[i][j] = 999;
            g_attackRangeDelta[i][j] = 999;
        }
    }
    
    for(int i = 1;i<=chipWidth;i++){
        for(int j = 1;j<=chipHeight;j++){
            g_attackRange[i][j] = 0;
            g_attackRangeDelta[i][j] = 0;
        }
    }
    
    for(int chipType = 0;chipType < 1024;chipType++){
        g_attackCost[0][chipType] = 1;
    }
    
    //0 リク　1宙 2海 3空
    //0 草原 1荒地
    enum{
        MOVETYPE_RIKU,
        MOVETYPE_CHU,
        MOVETYPE_UMI,
        MOVETYPE_SORA,
    };
    
    ATTACK *aTop = aPiece->A;
    for(int i = 0;i < crCAL;i++){
        aPiece->A = aPiece->A->next;
    }
    
    g_attackRange[startY][startX] = aPiece->A->rangeB;
    g_attackRangeDelta[startY][startX] = aPiece->A->rangeA;
    attackMaxNum = aPiece->A->rangeB+1;
    
    //[self excludePiece:turnSide fillInt:99];
    // 敵方のコマを迂回させるため、マップ移動最大値を詰め込む
    if(aPiece->A->rangeB >= 1 && aPiece->A->rangeA >= 0){
        [self checkAttackRange:startX startY:startY leftPow:aPiece->A->rangeB+1 pieceType:0 aMap:g_attackRange aPiece:aPiece];
        [self checkAttackRange:startX startY:startY leftPow:aPiece->A->rangeA pieceType:1 aMap:g_attackRangeDelta aPiece:aPiece];
        g_attackRange[startY][startX] = 0;
        g_attackRangeDelta[startY][startX] = 0;
        
        for(int i = 0;i<=chipWidth;i++){
            for(int j = 0;j<=chipHeight;j++){
                if(g_attackRangeDelta[i][j] > 0) g_attackRange[i][j] = 0;
            }
        }
        
        if(aPiece->A->rangeA == 0) g_attackRange[startY][startX] = 10;
        
    }else{
        [self checkAttackRange:startX startY:startY leftPow:aPiece->A->rangeA+1 pieceType:1 aMap:g_attackRange aPiece:aPiece];
        g_attackRange[startY][startX] = 0;
        if(aPiece->A->rangeA == 0) g_attackRange[startY][startX] = 10;
    }
    
    aPiece->A = aTop;
    
    //[self excludePiece:turnSide fillInt:0];
    // 敵方のコマの位置を移動可能範囲から除外する
    
}

-(void)LookupAttackRange2:(int)startX startY:(int)startY aPiece:(LOADCHIP*)aPiece turnSide:(BOOL)turnSide
{
    
    for(int i = 0;i<=chipWidth;i++){
        for(int j = 0;j<=chipHeight;j++){
            g_attackRange[i][j] = 999;
            g_attackRangeDelta[i][j] = 999;
        }
    }
    
    for(int i = 1;i<=chipWidth;i++){
        for(int j = 1;j<=chipHeight;j++){
            g_attackRange[i][j] = 0;
            g_attackRangeDelta[i][j] = 0;
        }
    }
    
    for(int chipType = 0;chipType < 1024;chipType++){
        g_attackCost[0][chipType] = 1;
    }
    
    //0 リク　1宙 2海 3空
    //0 草原 1荒地
    enum{
        MOVETYPE_RIKU,
        MOVETYPE_CHU,
        MOVETYPE_UMI,
        MOVETYPE_SORA,
    };
    
    ATTACK *aTop = aPiece->A;
    for(int i = 0;i < crCAL;i++){
        aPiece->A = aPiece->A->next;
    }
    
    g_attackRange[startY][startX] = aPiece->A->rangeB;
    g_attackRangeDelta[startY][startX] = aPiece->A->rangeA;
    attackMaxNum = aPiece->A->rangeB+1;
    
    //[self excludePiece:turnSide fillInt:99];
    // 敵方のコマを迂回させるため、マップ移動最大値を詰め込む
    if(aPiece->A->rangeB > 1 && aPiece->A->rangeA >= 0){
        [self checkAttackRange2:startX startY:startY leftPow:aPiece->A->rangeB+1 pieceType:0 aMap:g_attackRange aPiece:aPiece];
        [self checkAttackRange2:startX startY:startY leftPow:aPiece->A->rangeA pieceType:1 aMap:g_attackRangeDelta aPiece:aPiece];
        g_attackRange[startY][startX] = 0;
        g_attackRangeDelta[startY][startX] = 0;
        
        for(int i = 0;i<=chipWidth;i++){
            for(int j = 0;j<=chipHeight;j++){
                if(g_attackRangeDelta[i][j] > 0) g_attackRange[i][j] = 0;
            }
        }
        
        if(aPiece->A->rangeA == 0) g_attackRange[startY][startX] = 10;
        
    }else{
        [self checkAttackRange2:startX startY:startY leftPow:aPiece->A->rangeA+1 pieceType:1 aMap:g_attackRange aPiece:aPiece];
        g_attackRange[startY][startX] = 0;
        if(aPiece->A->rangeA == 0) g_attackRange[startY][startX] = 10;
    }
    
    aPiece->A = aTop;
    
    //[self excludePiece:turnSide fillInt:0];
    // 敵方のコマの位置を移動可能範囲から除外する
    
}

-(void)checkAttackRange:(int)startX startY:(int)startY leftPow:(int)leftPow pieceType:(int)pieceType aMap:(int[][1002])aMap aPiece:(UNITCHIP*)aPiece{
    int  i0;
    
    int chipTeam;
    if(Uselected) chipTeam = Uselected->team;
    
    if(startX < 0) startX = 0;
    if(startY < 0) startY = 0;
    
    aMap[startY][startX] = leftPow;    // 残り射程の長さ
    i0 = leftPow - 1;  // 上
    /*if(unitTeam[startY][startX] == chipTeam){
     aMap[startY][startX] = 0;
     }*/
    
    if( aMap[startY-1][startX] < i0 ){
        [self checkAttackRange:startX startY:startY - 1 leftPow:i0 pieceType:pieceType aMap:aMap aPiece:aPiece];
    }
    
    i0 = leftPow - 1;  // 下
    if( aMap[startY+1][startX] < i0 ){
        [self checkAttackRange:startX startY:startY + 1 leftPow:i0 pieceType:pieceType aMap:aMap aPiece:aPiece];
    }
    
    i0 = leftPow - 1;  // 右
    if( aMap[startY][startX-1] < i0 ){
        [self checkAttackRange:startX - 1 startY:startY leftPow:i0 pieceType:pieceType aMap:aMap aPiece:aPiece];
    }
    
    i0 = leftPow - 1;  // 左
    if( aMap[startY][startX+1] < i0 ){
        [self checkAttackRange:startX + 1 startY:startY leftPow:i0 pieceType:pieceType aMap:aMap aPiece:aPiece];
    }
    
}

-(void)checkAttackRange2:(int)startX startY:(int)startY leftPow:(int)leftPow pieceType:(int)pieceType aMap:(int[][1002])aMap aPiece:(LOADCHIP*)aPiece{
    int  i0;
    
    if(startX < 0) startX = 0;
    if(startY < 0) startY = 0;
    
    aMap[startY][startX] = leftPow;    // 残り射程の長さ
    
    i0 = leftPow - 1;  // 上
    if( aMap[startY-1][startX] < i0 ){
        [self checkAttackRange2:startX startY:startY - 1 leftPow:i0 pieceType:pieceType aMap:aMap aPiece:aPiece];
    }
    
    i0 = leftPow - 1;  // 下
    if( aMap[startY+1][startX] < i0 ){
        [self checkAttackRange2:startX startY:startY + 1 leftPow:i0 pieceType:pieceType aMap:aMap aPiece:aPiece];
    }
    
    i0 = leftPow - 1;  // 右
    if( aMap[startY][startX-1] < i0 ){
        [self checkAttackRange2:startX - 1 startY:startY leftPow:i0 pieceType:pieceType aMap:aMap aPiece:aPiece];
    }
    
    i0 = leftPow - 1;  // 左
    if( aMap[startY][startX+1] < i0 ){
        [self checkAttackRange2:startX + 1 startY:startY leftPow:i0 pieceType:pieceType aMap:aMap aPiece:aPiece];
    }
    
}


-(void)checkRangeAttack:(int)startX startY:(int)startY leftPow:(int)leftPow pieceType:(int)pieceType aMap:(int[][1002])aMap aPiece:(UNITCHIP*)aPiece i:(int)i{
    
    int  i0;
    
    if(startX < 0) startX = 0;
    if(startY < 0) startY = 0;
    
    aMap[startY][startX] = leftPow;    // 残り射程の長さ
    
    i0 = leftPow - 1;  // 上
    if( aMap[startY-1][startX] < i0 ){
        [self checkRangeAttack:startX startY:startY - 1 leftPow:i0 pieceType:pieceType aMap:aMap aPiece:aPiece i:i];
    }
    
    i0 = leftPow - 1;  // 下
    if( aMap[startY+1][startX] < i0 ){
        [self checkRangeAttack:startX startY:startY + 1 leftPow:i0 pieceType:pieceType aMap:aMap aPiece:aPiece i:i];
    }
    
    i0 = leftPow - 1;  // 右
    if( aMap[startY][startX-1] < i0 ){
        [self checkRangeAttack:startX - 1 startY:startY leftPow:i0 pieceType:pieceType aMap:aMap aPiece:aPiece i:i];
    }
    
    i0 = leftPow - 1;  // 左
    if( aMap[startY][startX+1] < i0 ){
        [self checkRangeAttack:startX + 1 startY:startY leftPow:i0 pieceType:pieceType aMap:aMap aPiece:aPiece i:i];
    }
}



-(void)LookupAttackRangeExtent:(int)startX startY:(int)startY aPiece:(UNITCHIP*)aPiece turnSide:(BOOL)turnSide
{
    
    for(int i = 0;i<=chipWidth;i++){
        for(int j = 0;j<=chipHeight;j++){
            g_attackRangeExtent[i][j] = 999;
        }
    }
    
    for(int i = 1;i<=chipWidth;i++){
        for(int j = 1;j<=chipHeight;j++){
            g_attackRangeExtent[i][j] = 0;
        }
    }
    
    for(int chipType = 0;chipType < 1024;chipType++){
        g_attackCost[0][chipType] = 1;
    }
    
    //0 リク　1宙 2海 3空
    //0 草原 1荒地
    enum{
        MOVETYPE_RIKU,
        MOVETYPE_CHU,
        MOVETYPE_UMI,
        MOVETYPE_SORA,
    };
    
    ATTACK *aTop = aPiece->A;
    for(int i = 0;i < crCAL;i++){
        aPiece->A = aPiece->A->next;
    }
    
    g_attackRangeExtent[startY][startX] = aPiece->A->extent;
    attackMaxNum = aPiece->A->extent;
    
    //[self excludePiece:turnSide fillInt:99];
    // 敵方のコマを迂回させるため、マップ移動最大値を詰め込む
    
    
    [self checkAttackRangeExtent:startX startY:startY leftPow:aPiece->A->extent+1 pieceType:1 aMap:g_attackRangeExtent aPiece:aPiece];
    
    aPiece->A = aTop;
    
    //[self excludePiece:turnSide fillInt:0];
    // 敵方のコマの位置を移動可能範囲から除外する
    
}

-(void)checkAttackRangeExtent:(int)startX startY:(int)startY leftPow:(int)leftPow pieceType:(int)pieceType aMap:(int[][1002])aMap aPiece:(UNITCHIP*)aPiece{
    int  i0;
    
    int chipTeam;
    if(Uselected) chipTeam = Uselected->team;
    
    if(startX < 0) startX = 0;
    if(startY < 0) startY = 0;
    
    aMap[startY][startX] = leftPow;    // 残り射程の長さ
    i0 = leftPow - 1;  // 上
    /*if(unitTeam[startY][startX] == chipTeam){
     aMap[startY][startX] = 0;
     }*/
    
    if( aMap[startY-1][startX] < i0 ){
        [self checkAttackRangeExtent:startX startY:startY - 1 leftPow:i0 pieceType:pieceType aMap:aMap aPiece:aPiece];
    }
    
    i0 = leftPow - 1;  // 下
    if( aMap[startY+1][startX] < i0 ){
        [self checkAttackRangeExtent:startX startY:startY + 1 leftPow:i0 pieceType:pieceType aMap:aMap aPiece:aPiece];
    }
    
    i0 = leftPow - 1;  // 右
    if( aMap[startY][startX-1] < i0 ){
        [self checkAttackRangeExtent:startX - 1 startY:startY leftPow:i0 pieceType:pieceType aMap:aMap aPiece:aPiece];
    }
    
    i0 = leftPow - 1;  // 左
    if( aMap[startY][startX+1] < i0 ){
        [self checkAttackRangeExtent:startX + 1 startY:startY leftPow:i0 pieceType:pieceType aMap:aMap aPiece:aPiece];
    }
    
}

-(void)LookupAttackRangeExtent2:(int)startX startY:(int)startY aPiece:(LOADCHIP*)aPiece turnSide:(BOOL)turnSide
{
    
    for(int i = 0;i<=chipWidth;i++){
        for(int j = 0;j<=chipHeight;j++){
            g_attackRangeExtent[i][j] = 999;
        }
    }
    
    for(int i = 1;i<=chipWidth;i++){
        for(int j = 1;j<=chipHeight;j++){
            g_attackRangeExtent[i][j] = 0;
        }
    }
    
    for(int chipType = 0;chipType < 1024;chipType++){
        g_attackCost[0][chipType] = 1;
    }
    
    //0 リク　1宙 2海 3空
    //0 草原 1荒地
    enum{
        MOVETYPE_RIKU,
        MOVETYPE_CHU,
        MOVETYPE_UMI,
        MOVETYPE_SORA,
    };
    
    ATTACK *aTop = aPiece->A;
    for(int i = 0;i < crCAL;i++){
        aPiece->A = aPiece->A->next;
    }
    
    g_attackRangeExtent[startY][startX] = aPiece->A->extent;
    attackMaxNum = aPiece->A->extent;
    
    //[self excludePiece:turnSide fillInt:99];
    // 敵方のコマを迂回させるため、マップ移動最大値を詰め込む
    
    
    [self checkAttackRangeExtent2:startX startY:startY leftPow:aPiece->A->extent pieceType:1 aMap:g_attackRange aPiece:aPiece];
    g_attackRangeExtent[startY][startX] = 0;
    
    aPiece->A = aTop;
    
    //[self excludePiece:turnSide fillInt:0];
    // 敵方のコマの位置を移動可能範囲から除外する
    
}

-(void)checkAttackRangeExtent2:(int)startX startY:(int)startY leftPow:(int)leftPow pieceType:(int)pieceType aMap:(int[][1002])aMap aPiece:(LOADCHIP*)aPiece{
    int  i0;
    
    int chipTeam;
    if(Uselected) chipTeam = Uselected->team;
    
    if(startX < 0) startX = 0;
    if(startY < 0) startY = 0;
    
    aMap[startY][startX] = leftPow;    // 残り射程の長さ
    i0 = leftPow - 1;  // 上
    /*if(unitTeam[startY][startX] == chipTeam){
     aMap[startY][startX] = 0;
     }*/
    
    if( aMap[startY-1][startX] < i0 ){
        [self checkAttackRangeExtent2:startX startY:startY - 1 leftPow:i0 pieceType:pieceType aMap:aMap aPiece:aPiece];
    }
    
    i0 = leftPow - 1;  // 下
    if( aMap[startY+1][startX] < i0 ){
        [self checkAttackRangeExtent2:startX startY:startY + 1 leftPow:i0 pieceType:pieceType aMap:aMap aPiece:aPiece];
    }
    
    i0 = leftPow - 1;  // 右
    if( aMap[startY][startX-1] < i0 ){
        [self checkAttackRangeExtent2:startX - 1 startY:startY leftPow:i0 pieceType:pieceType aMap:aMap aPiece:aPiece];
    }
    
    i0 = leftPow - 1;  // 左
    if( aMap[startY][startX+1] < i0 ){
        [self checkAttackRangeExtent2:startX + 1 startY:startY leftPow:i0 pieceType:pieceType aMap:aMap aPiece:aPiece];
    }
    
}

-(void)makeEnemyAI{
    
    for(int g = 0;g <= chipWidth;g++){
        for(int h = 0; h <= chipHeight;h++){
            g_attackRangeBeta [g][h] = 0;
        }
    }
    [self LookupMovableRange:unitBreak->y startY:unitBreak->x aPiece:&unitBreak->C turnSide:YES];
    
    
    for (int x = 0; x <= chipWidth;x++) {
        for(int y = 0; y <= chipHeight;y++){
            
            if(g_selectRange[x][y] > 0 && g_selectRange[x][y] != 999 ){
                
                ATTACK *UAT;
                UA = unitBreak->C.A;
                UAT = unitBreak->C.A;
                double mostDmg = 0;
                
                
                if(!UAT) return;
                crCAL1 = 0;
                while (unitBreak->C.A) {
                    double mpcost = floor(unitBreak->C.A->MP + unitBreak->C.A->pMP*unitBreak->C.S_M.MP/100 + 0.5);
                    
                    double vigcost = unitBreak->C.A->vigor;
                    
                    if(UA->rangeB <= unitBreak->C.A->rangeB && mpcost <= unitBreak->C.S_C.MP && vigcost <= unitBreak->C.S_C.vigor && mostDmg < unitBreak->C.A->totalD){
                        mostDmg = unitBreak->C.A->totalD;
                        
                        UA = unitBreak->C.A;
                    }
                    
                    unitBreak->C.A = unitBreak->C.A->next;
                }unitBreak->C.A = UAT;
                
                
                
                if(UA)
                    if(UA->rangeB <= 0) {
                        UA = unitBreak->C.A;
                        UA->rangeB = 1;
                        crCAL1 = 0;
                    }
                
                if(UA->extent > 0){
                    cpuAtkExtendFlag = true;
                }else{
                    cpuAtkExtendFlag = false;
                }
                
                while (unitBreak->C.A && UA != unitBreak->C.A) {
                    unitBreak->C.A = unitBreak->C.A->next;
                    crCAL1++;
                }unitBreak->C.A = UAT;
                
                unitBreak->atkRange = UA->rangeB;
                
                for(int g = 0;g <= chipWidth;g++){
                    for(int h = 0; h <= chipHeight;h++){
                        g_attackRangeAlpha [g][h] = 0;
                    }
                }
                
                [self checkAttackRange:y startY:x leftPow:UA->rangeB+1 pieceType:unitBreak->C.S_C.typeMONS aMap:g_attackRangeAlpha aPiece:&unitBreak->C];
                
                for (int j = 0; j <= chipWidth;j++) {
                    for(int k = 0;k <= chipHeight;k++){
                        if(g_attackRangeBeta[j][k] < g_attackRangeAlpha[j][k]) g_attackRangeBeta[j][k] = g_attackRangeAlpha[j][k];
                    }
                }
            }
        }
    }
    
}


//-------------------------------------------------------------------searchRute
-(void)searchRoute{
    int i0;
    
    // ルートテンポラリとルートバッファの初期化
    for( i0 = 0; i0 < 2100; i0++ )
    { g_tmpRoute[i0][0] = 0; g_tmpRoute[i0][1] = 0; g_moveRoute[i0][0] = 0;
        g_moveRoute[i0][1] = 0; }
    
    for(int i = 0;i < 2100;i++){// テンポラリマップのゼロリセット
        for(int j = 0;j< 2100;j++){
            g_tmpMap[i][j] = 0;
        }
    }
    g_stackPointer = 0;	             // スタックポインタ初期化
    g_shallowDepth = 1002;   //「最も浅いスタック」を持たせるために、// 最も深い値を与えておく
    
    [self checkRoute:g_cursol_x startY:g_cursol_y];
    
    // 経路をテンポラリマップに書き込む
    i0 = 0;
    g_moveCount = 0;
    while( i0 < g_shallowDepth)
    {
        g_tmpMap[g_moveRoute[i0][1]][g_moveRoute[i0][0]] = 1;
        
        i0++;
    }
}

//-------------------------------------------------------------------checkRout
-(void)checkRoute:(int)startX startY:(int)startY{
    int i0 = 0;
    
    g_tmpMap[startY][startX]=1;
    g_tmpRoute[g_stackPointer][0] = startX;
    g_tmpRoute[g_stackPointer][1] = startY;
    g_stackPointer++;
    
    // ターゲットに到達したとき、スタック深度が今までより浅かったらそれを保存する
    if((( g_target_x == startX )&&( g_target_y == startY )&&( g_stackPointer < g_shallowDepth )))
    {
        g_shallowDepth = g_stackPointer;  // 最浅スタック深度更新
        int  j0 = 0;
        for( j0 = 0; j0 < g_shallowDepth; j0++ ) {
            g_moveRoute[j0][0] = g_tmpRoute[j0][0];
            g_moveRoute[j0][1] = g_tmpRoute[j0][1];
        }
    }
    
    // 再帰法で移動ルートを探し出す
    // 配列の添え字と関数の引数が逆になっていることに要注意
    i0 = g_selectRange[startY][startX];
    if(g_selectRange[startY-1][startX] > 0)
        if(( g_selectRange[startY-1][startX]   < i0 )&&(g_tmpMap[startY-1][startX] == 0 )
           ){
            [self checkRoute:startX startY:startY -1];
        }   // 上
    if(g_selectRange[startY+1][startX] > 0)
        if(( g_selectRange[startY+1][startX]  < i0 )&&(g_tmpMap[startY+1][startX] == 0 )
           ){
            [self checkRoute:startX startY:startY +1];
        }   // 下
    if(g_selectRange[startY][startX-1] > 0)
        if(( g_selectRange[startY][startX-1]  < i0 )&&(g_tmpMap[startY][startX-1] == 0 )
           ){
            [self checkRoute:startX-1 startY:startY];
        }   // 右
    if(g_selectRange[startY][startX+1] > 0)
        if(( g_selectRange[startY][startX+1]  < i0 )&&(g_tmpMap[startY][startX+1] == 0 )
           ){
            [self checkRoute:startX+1 startY:startY];
        }   // 左
    
    g_stackPointer--;                // スタックから捨てる
    //g_tmpMap[startY][startX] = 0;    // 別経路探索のため
    
}


//-------------------------------------------------------------------searchRute
-(void)searchRoute2{
    int i0;
    
    // ルートテンポラリとルートバッファの初期化
    for( i0 = 0; i0 < 2100; i0++ )
    { g_tmpRoute2[i0][0] = 0; g_tmpRoute2[i0][1] = 0; g_moveRoute2[i0][0] = 0;
        g_moveRoute2[i0][1] = 0; }
    
    for(int i = 0;i < 2100;i++){// テンポラリマップのゼロリセット
        for(int j = 0;j< 2100;j++){
            g_tmpMap2[j][i] = 0;
        }
    }
    g_stackPointer = 0;	             // スタックポインタ初期化
    g_shallowDepth = 1002;   //「最も浅いスタック」を持たせるために、// 最も深い値を与えておく
    
    [self checkRoute:g_cursol_x startY:g_cursol_y];
    
    // 経路をテンポラリマップに書き込む
    i0 = 0;
    g_moveCount = 0;
    while( i0 < g_shallowDepth)
    {
        g_tmpMap2[g_moveRoute2[i0][1]][g_moveRoute2[i0][0]] = 1;
        
        i0++;
    }
}

//-------------------------------------------------------------------checkRout
-(void)checkRoute2:(int)startX startY:(int)startY{
    int i0 = 0;
    
    g_tmpMap2[startY][startX]=1;
    g_tmpRoute2[g_stackPointer][0] = startX;
    g_tmpRoute2[g_stackPointer][1] = startY;
    g_stackPointer++;
    
    // ターゲットに到達したとき、スタック深度が今までより浅かったらそれを保存する
    if((( g_target_x == startX )&&( g_target_y == startY )&&( g_stackPointer < g_shallowDepth ))/*|| ((cpuTargX == startX ) && (cpuTargY == startY))*/)
    {
        g_shallowDepth = g_stackPointer;  // 最浅スタック深度更新
        int  j0 = 0;
        for( j0 = 0; j0 < g_shallowDepth; j0++ ) {
            g_moveRoute2[j0][0] = g_tmpRoute2[j0][0];
            g_moveRoute2[j0][1] = g_tmpRoute2[j0][1];
        }
    }
    
    // 再帰法で移動ルートを探し出す
    // 配列の添え字と関数の引数が逆になっていることに要注意
    i0 = g_selectRange[startY][startX];
    if(g_selectRange[startY-1][startX] > 0)
        if(( g_selectRange[startY-1][startX]   < i0 )&&(g_tmpMap2[startY-1][startX] == 0 )
           ){
            [self checkRoute:startX startY:startY -1];
        }   // 上
    if(g_selectRange[startY+1][startX] > 0)
        if(( g_selectRange[startY+1][startX]  < i0 )&&(g_tmpMap2[startY+1][startX] == 0 )
           ){
            [self checkRoute:startX startY:startY +1];
        }   // 下
    if(g_selectRange[startY][startX-1] > 0)
        if(( g_selectRange[startY][startX-1]  < i0 )&&(g_tmpMap2[startY][startX-1] == 0 )
           ){
            [self checkRoute:startX-1 startY:startY];
        }   // 右
    if(g_selectRange[startY][startX+1] > 0)
        if(( g_selectRange[startY][startX+1]  < i0 )&&(g_tmpMap2[startY][startX+1] == 0 )
           ){
            [self checkRoute:startX+1 startY:startY];
        }   // 左
    
    g_stackPointer--;                // スタックから捨てる
    //g_tmpMap[startY][startX] = 0;    // 別経路探索のため
    
}


-(void)modeCPUturn{
    
    enum{
        
        MODE_CPU_IDLE,
        MODE_CPU_SEARCH,
        MODE_CPU_MOVE,
        MODE_CPU_ATTACK,
        MODE_CPU_BATTLE,
        MODE_CPU_BUILD,
        MODE_CPU_EMPLOY,
        MODE_CPU_STANBY
    };
    
    
    static int cpuMODE = MODE_CPU_IDLE;
    
    switch (cpuMODE) {
        case MODE_CPU_IDLE:
            
            if(stopByFSVmenuFlag)
                return;
            
            if(coolTime)
                return;
            
            
            if(stanbyFlag)
                return;
            
            if(unitMoveEndFlag){
                pushStanbyFlag = true;
                UA = NULL;
                cpuIsAttackingFlag = false;
            }
            
            if(setBattleModeFlag)
                return;
            
            if(messageDialog)
                return;
            

            
            if(endGameCondition)
                return;
            if(battleFlag || battleRdy || battleSetUp)
                return;
            
            
            wtRdy = true;
            wtRdy2 = true;
            
            
            unitMoveEndFlag = false;
            cpuAtkExtendFlag = false;
            cpuAtkExtendFlag2 = false;
            extentBattleFlag2 = false;
            CPUAttackFlag = false;
            CPUAttackFlag2 = false;
            if(cpuAImodeflag && unitBreak->C.nameID)
                cpuMODE = MODE_CPU_SEARCH;
            possionX = unitBreak->x;
            possionY = unitBreak->y;
            currentPosX = possionX;
            currentPosY = possionY;
            Uselected = unitBreak;
            break;
        case MODE_CPU_SEARCH:
            wtMovedFlag = false;
            wtAttackedFlag = false;
            pushStanbyFlag = false;
            if(!Utarget)
                crCAL = crCAL1 = 0;
            [self makeEnemyAI];
            [self cpuSearchEnemy];
            /*
            if(Utarget) NSLog(@"Utarg %d", Utarget->number);
            else NSLog(@"Utarg NULL");
             */
            cpuModeMOVEflag = true;
            [self scrollPoint:NSMakePoint((wtPx-8)*32, (wtPy-8)*32)];
            if(unitNoMoveStanbyFlag){
                static int waitTimer = 20;
                cpuModeATTACKflag = true;
                if (waitTimer > 0) {
                    waitTimer--;
                    return;
                }else{
                    waitTimer = 20;
                    unitNoMoveFlag = true;
                    U = UTop;
                    
                    while (U->number != wtUnitNum) {
                        U = U->next;
                    }
                    
                    if(!wtMovedFlag && !wtAttackedFlag && unitNoMoveFlag){
                        U->C.S_C.WT = floor(U->C.S_M.WT/4 + 0.5);
                    }else if(wtMovedFlag && wtAttackedFlag){
                        U->C.S_C.WT =  floor(U->C.S_M.WT + 0.5);
                    }else if(wtMovedFlag){
                        U->C.S_C.WT =  floor(U->C.S_M.WT/2 + 0.5);
                    }else if(wtAttackedFlag){
                        U->C.S_C.WT =  floor(U->C.S_M.WT/2 + 0.5);
                    }
                    
                    
                    
                    B = BTop;
                    while (B) {
                        if(B->x == wtPx && B->y == wtPy && B->C.capture){
                            buildCaptureFlag = true;
                            unitMoveEndFlag = true;
                        }
                        B = B->next;
                    }B = BTop;
                    
                    cpuModeMOVEflag = false;
                    cpuModeATTACKflag = false;
                    moveFlag = false;
                    CPUAttackFlag = false;
                    CPUAttackFlag2 = false;
                    wtMovedFlag = false;
                    unitMoveEndFlag = true;
                    
                    unitNoMoveStanbyFlag = false;
                    
                    
                    /*
                    wtRdy = false;
                    wtRdy2 = false;
                    */
                    pushStanbyFlag = true;
                    unitMoveEndFlag = true;
                    
                    cpuModeMOVEflag = false;
                    cpuModeATTACKflag = false;
                    cpuAImodeflag = false;
                    moveFlag = false;
                    stanbyFlag = true;
                    //wtMovedFlag = true;
                    CPUAttackFlag = false;
                    CPUAttackFlag2 = false;
                    unitNoMoveFlag = false;
                    cpuModeBATTLEendFlag = false;
                    cpuMODE = MODE_CPU_IDLE;
                    UA = NULL;
                    
                }
                
                return;
            }
            wtMovedFlag = true;
            cpuMODE = MODE_CPU_MOVE;
            if(unitNoMoveFlag){
                wtMovedFlag = false;
                cpuModeATTACKflag = true;
                CPUAttackFlag = true;
                cpuMODE = MODE_CPU_ATTACK;
            }else{
                
            }
            break;
        case MODE_CPU_MOVE:
            moveFlag = true;
            cpuModeATTACKflag = true;
            wtMovedFlag = true;
            
            if ([self cpuMoveFunc] && unitMoveEndFlag) {
                cpuMODE = MODE_CPU_ATTACK;
                //NSLog(@"%d", g_moveRoute[0][0]);
            }
           // NSLog(@"test[%d,%d][%d,%d]", unitBreak->x, unitBreak->y, possionX, possionY);
           // NSLog(@"test[%d]", unitNoMoveFlag);
            possionX = g_target_y;
            possionY = g_target_x;
            if(unitNoMoveFlag){
                if(CPUAttackFlag  && Utarget){
                    cpuMODE = MODE_CPU_ATTACK;
                }else{
                    cpuMODE = MODE_CPU_BUILD;
                }
            }
            
            break;
        case MODE_CPU_ATTACK:
            
            if(!Utarget){
                cpuMODE = MODE_CPU_BUILD;
                CPUAttackFlag = false;
                return;
            }
            
            if(!CPUAttackFlag){
                cpuMODE = MODE_CPU_BUILD;

                return;
            }else{
                //unitNoMoveFlag = false;
                CPUAttackFlag = true;
                unitCPUAttackFlag = true;
                cpuModeBATTLEendFlag = false;
                cpuMODE = MODE_CPU_BATTLE;
                oopsCnt = 25;
                return;
            }
            break;
        case MODE_CPU_BATTLE:
            battleFlag = true;
            attackingWait = true;
            
            if(!Utarget){
                CPUAttackFlag = false;
                cpuAtkExtendFlag = false;
                battleFlag = false;
            }
            
            if(cpuModeBATTLEendFlag){
                
                
                if(cpuModeBATTLEendFlag){
                    
                    static int waitTimer0 = 20;
                    
                    if (waitTimer0 > 0) {
                        waitTimer0--;
                        return;
                    }else{
                        waitTimer0 = 20;
                        
                    pushStanbyFlag = true;
                    
                    cpuModeMOVEflag = false;
                    cpuModeATTACKflag = false;
                    cpuAImodeflag = false;
                    moveFlag = false;
                    //stanbyFlag = true;
                    wtMovedFlag = true;
                    CPUAttackFlag2 = false;
                    battleWindowFlag = true;
                    
                    cpuModeBATTLEendFlag = false;
                    cpuOMFGmoveATKfixFlag = false;
                    cpuMODE = MODE_CPU_EMPLOY;
                    }
                }
                
                return;
            }
            else if((CPUAttackFlag && unitMoveEndFlag )|| CPUAttackFlag2){
                
                static int waitTimer = 20;
                
                if (waitTimer > 0) {
                    waitTimer--;
                    return;
                }else{
                    waitTimer = 20;
                    [self scrollPoint:NSMakePoint((wtPx-8)*32, (wtPy-8)*32)];
                    wtAttackedFlag = true;
                    if(!cpuAtkExtendFlag){
                        CPUAttackSubmitFlag = true;
                        battleWindowFlag = true;
                        cpuModeBATTLEflag = true;
                        
                        CPUAttackFlag2 = false;
                    }else{
                        CPUAttackSubmitFlag = true;
                        battleWindowFlag = false;
                        cpuModeBATTLEflag = true;
                        CPUAttackFlag2 = false;
                        cpuAtkExtendFlag = false;
                        cpuAtkExtendFlag2 = true;
                        cpuOMFGmoveATKfixFlag = true;
                    }
                }
            }else if((CPUAttackFlag && !unitMoveEndFlag)){
                
                static int waitTimer = 20;
                
                if (waitTimer > 0) {
                    waitTimer--;
                    return;
                }else{
                    waitTimer = 20;
                    wtAttackedFlag = true;
                    if(!cpuAtkExtendFlag){
                        CPUAttackSubmitFlag = true;
                        battleWindowFlag = true;
                        cpuModeBATTLEflag = true;
                        
                        CPUAttackFlag2 = false;
                    }else{
                        CPUAttackSubmitFlag = true;
                        battleWindowFlag = false;
                        cpuModeBATTLEflag = true;
                        CPUAttackFlag2 = false;
                        cpuAtkExtendFlag = false;
                        cpuAtkExtendFlag2 = true;
                        cpuOMFGmoveATKfixFlag = true;
                    }
                }
                
                
                return;
            }
            
            cpuMODE = MODE_CPU_EMPLOY;
            
            break;
        case MODE_CPU_BUILD:
            
            if(!MF[MFselectedRow+1].MS.buildAllowedFlag){
                cpuMODE = MODE_CPU_EMPLOY;
                return;
            }
            
            B = BTop;
            while (B) {
                if(B->x == possionX && B->y == possionY)
                    break;
                B = B->next;
            }
            
            SKILL *ST = unitBreak->C.S;
            
            int UT = 0;
            
            if(unitBreak->team == 0){
                UT = 0;
            }else if(unitBreak->team == 2){
                UT = 1;
            }else if(unitBreak->team == 4){
                UT = 2;
            }
            
            if(cpuBuildDoneFlag){
                if(unitNoMoveFlag){
                    
                    while(unitBreak->C.S){
                        if(unitBreak->C.S->type == 1){
                            for(int i = 0;unitBreak->C.S->list[i] > 0;i++){
                                if(i == ST6type){
                                    P[UT].resource -= BC[unitBreak->C.S->list[i]-1].Csupply;
                                    P[UT].food -= BC[unitBreak->C.S->list[i]-1].Cfood;
                                    P[UT].money -= BC[unitBreak->C.S->list[i]-1].Cmoney;
                                    ST6type = 0;
                                    wtAttackedFlag = true;
                                }
                            }
                        }
                        unitBreak->C.S = unitBreak->C.S->next;
                    }unitBreak->C.S = ST;
                    
                    
                B->C.invisible = false;
                cpuBuildDoneFlag = false;
                cpuMODE = MODE_CPU_EMPLOY;
            }else if(wtMovedFlag){
                
                while(unitBreak->C.S){
                    if(unitBreak->C.S->type == 1){
                        for(int i = 0;unitBreak->C.S->list[i] > 0;i++){
                            if(i == ST6type){
                                P[UT].resource -= BC[unitBreak->C.S->list[i]-1].Csupply;
                                P[UT].food -= BC[unitBreak->C.S->list[i]-1].Cfood;
                                P[UT].money -= BC[unitBreak->C.S->list[i]-1].Cmoney;
                                ST6type = 0;
                                wtAttackedFlag = true;
                            }
                        }
                    }
                    unitBreak->C.S = unitBreak->C.S->next;
                }unitBreak->C.S = ST;
                //NSLog(@"BTop %@", BTop->C.name);
                B->C.invisible = false;
                cpuBuildDoneFlag = false;
                cpuMODE = MODE_CPU_EMPLOY;
            }else if(unitMoveEndFlag){
                
                while(unitBreak->C.S){
                    if(unitBreak->C.S->type == 1){
                        for(int i = 0;unitBreak->C.S->list[i] > 0;i++){
                            if(i == ST6type){
                                P[UT].resource -= BC[unitBreak->C.S->list[i]-1].Csupply;
                                P[UT].food -= BC[unitBreak->C.S->list[i]-1].Cfood;
                                P[UT].money -= BC[unitBreak->C.S->list[i]-1].Cmoney;
                                ST6type = 0;
                                wtAttackedFlag = true;
                            }
                        }
                    }
                    unitBreak->C.S = unitBreak->C.S->next;
                }unitBreak->C.S = ST;
                
                B->C.invisible = false;
                cpuBuildDoneFlag = false;
                cpuMODE = MODE_CPU_EMPLOY;
            }
                
                B = BTop;
                return;
            }
            B = BTop;
            cpuMODE = MODE_CPU_EMPLOY;
            break;
        case MODE_CPU_EMPLOY:
            if(!MF[MFselectedRow+1].MS.employAllowedFlag){
                cpuMODE = MODE_CPU_STANBY;
                return;
            }
            
            [self cpuEmployment];
            cpuMODE = MODE_CPU_STANBY;
            break;
        case MODE_CPU_STANBY:
            
            
            
            if(battleFlag){
                wtRdy3 = true;
                return;
            }
            
            if(!CPUAttackFlag){
                U = UTop;
                
                while (U->number != wtUnitNum) {
                    U = U->next;
                }
                
                if(!wtMovedFlag && !wtAttackedFlag && unitNoMoveFlag){
                    U->C.S_C.WT = floor(U->C.S_M.WT/4 + 0.5);
                }else if(wtMovedFlag && wtAttackedFlag){
                    U->C.S_C.WT =  floor(U->C.S_M.WT + 0.5);
                }else if(wtMovedFlag){
                    U->C.S_C.WT =  floor(U->C.S_M.WT/2 + 0.5);
                }else if(wtAttackedFlag){
                    U->C.S_C.WT =  floor(U->C.S_M.WT/2 + 0.5);
                }
                
                U = UTop;
                
                
                wtRdy = false;
                wtRdy2 = false;
                wtRdy3 = false;
                stanbyFlag = true;
                
                pushStanbyFlag = true;
                unitMoveEndFlag = true;
                
                cpuModeMOVEflag = false;
                cpuModeATTACKflag = false;
                cpuAImodeflag = false;
                moveFlag = false;
                stanbyFlag = true;
                wtMovedFlag = true;
                CPUAttackFlag = false;
                CPUAttackFlag2 = false;
                unitNoMoveFlag = false;
                cpuModeBATTLEendFlag = false;
                cpuMODE = MODE_CPU_IDLE;
                UA = NULL;
                return;
            }
            
            
            //おまんちん
            U = UTop;
            while (U->number != wtUnitNum) {
                U = U->next;
            }
            
            if(!wtMovedFlag && !wtAttackedFlag && unitNoMoveFlag){
                U->C.S_C.WT = floor(U->C.S_M.WT/4 + 0.5);
            }else if(wtMovedFlag && wtAttackedFlag){
                U->C.S_C.WT =  floor(U->C.S_M.WT + 0.5);
            }else if(wtMovedFlag){
                U->C.S_C.WT =  floor(U->C.S_M.WT/2 + 0.5);
            }else if(wtAttackedFlag){
                U->C.S_C.WT =  floor(U->C.S_M.WT/2 + 0.5);
            }
            
            U = UTop;
            
            
            wtRdy = false;
            wtRdy2 = false;
            wtRdy3 = false;
            
            pushStanbyFlag = true;
            

            cpuModeMOVEflag = false;
            cpuModeATTACKflag = false;
            cpuAImodeflag = false;
            moveFlag = false;
            stanbyFlag = true;
            wtMovedFlag = true;
            unitNoMoveFlag = false;
            cpuModeBATTLEendFlag = false;
            cpuMODE = MODE_CPU_IDLE;
            //if(Utarget) NSLog(@"Utarg2 %d", Utarget->number);
            break;
        default:
            cpuMODE = MODE_CPU_IDLE;
            break;
    }
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
}



-(void)cpuEmployment{

    B = BTop;
    while(B){
    
        if(unitNum[B->x][B->y] < 0 && unitBreak->team == B->team){
            
            BUILDCHIP B0 = BC[buildNum[B->x][B->y]];
            RESEARCH *Rtop = B0.R;
            UNITCHIP *BU;
            
            int UT = 0;
            
            if(unitBreak->team == 0){
                UT = 0;
            }else if(unitBreak->team == 2){
                UT = 1;
            }else if(unitBreak->team == 4){
                UT = 2;
            }
            
            if(!B0.GuildFlag){
            while(B0.R){
                BU = B0.R->U;
                BRU = BU;
                if(B->makeLv >= B0.R->Lv && unitNum[B->x][B->y] < 0){
                    
                    int rdmCnt = rand()%100;
                    
                    if(BU && rdmCnt > 60){
                        if(BU->S_M.cSupply <= P[UT].resource &&
                           BU->S_M.cFood <= P[UT].food &&
                           BU->S_M.cMoney <= P[UT].money){
                            
                            
                            P[UT].resource -= BU->S_M.cSupply;
                            P[UT].food -= BU->S_M.cFood;
                            P[UT].money -= BU->S_M.cMoney;
                            
                            unitNum[B->x][B->y] = BU->chipNumb;
                            unitTeam[B->x][B->y] = B->team;
                            possionX = B->x;
                            possionY = B->y;
                            [self addUnitStatusFix];
                            break;
                        }
                    }
                }
                
                    B0.R = B0.R->next;
            }B0.R = Rtop;
            }else{
                
                bool EmadeNonGuildFlag = false;
                int k = 0;
                while(B0.R){
                    BU = B0.R->U;
                    BRU = BU;
                    if(B->makeLv >= B0.R->Lv && unitNum[B->x][B->y] < 0){
                        
                        int rdmCnt = rand()%100;
                        
                        if(BU && rdmCnt > 60){
                            if(BU->S_M.cSupply <= P[UT].resource &&
                               BU->S_M.cFood <= P[UT].food &&
                               BU->S_M.cMoney <= P[UT].money){
                                
                                
                                P[UT].resource -= BU->S_M.cSupply;
                                P[UT].food -= BU->S_M.cFood;
                                P[UT].money -= BU->S_M.cMoney;
                                
                                unitNum[B->x][B->y] = BU->chipNumb;
                                unitTeam[B->x][B->y] = B->team;
                                possionX = B->x;
                                possionY = B->y;
                                [self addUnitStatusFix];
                                EmadeNonGuildFlag = true;
                                break;
                            }
                        }
                    }
                    
                    B0.R = B0.R->next;
                    k++;
                }B0.R = Rtop;
            
                MAPSCRIPT MS = MF[MFselectedRow+1].MS;
                
                if(!EmadeNonGuildFlag){
                
                    possionX = B->x;
                    possionY = B->y;
                    
                    if((buildTeam[possionX][possionY] == 0 || buildTeam[possionX][possionY] == 1)){
                        
                        int a = MS.guildListRegistNum12 - MS.guildListRegistNum11;
                        
                        if(!guildRE1){
                            Gnum1 = 0;
                            if(a > 0)
                                Gnum1 = MS.guildListRegistNum11 + arc4random()%(MS.guildListRegistNum12 - MS.guildListRegistNum11+1);
                            else
                                Gnum1 = MS.guildListRegistNum12;
                            
                            if(Gnum1 > GCnum1+1)
                                Gnum1 = GCnum1;
                        }
                        int n = 0;
                        int j = 0;
                        guildc = 0;
                        saveGuildList = calloc((GCnum1+1), sizeof(int));
                        if(!guildRE1) GuildDisp1 = calloc(Gnum1, sizeof(int));
                        for(int i = 0;i < Gnum1;i++){
                            
                            if(!guildRE1){
                                n = [fieldScene chooseGuildList:GuildChosen1 gcnum:GCnum1];
                                if(n == -1)
                                    break;
                                *(GuildDisp1 + i) = *(GuildChosen1 + n);
                            }
                            
                            if(*(GuildDisp1 + i) <= 0)
                                break;
                            j++;
                        }
                        if(n == -1)
                            break;
                        
                        j = arc4random()%(j);
                        
                        BRUindex = 0;
                        for (int i = 0; UC[*(GuildDisp1 + j - k)-1].nameID != UC[i].nameID && i < UCN;i++) {
                            BRUindex++;
                        }BRU = &UC[BRUindex];
                        
                        guildRE1 = true;
                    }else if((buildTeam[possionX][possionY] == 2 || buildTeam[possionX][possionY] == 3)){
                        
                        int a = MS.guildListRegistNum22 - MS.guildListRegistNum21;
                        
                        if(!guildRE2){
                            Gnum2 = 0;
                            if(a > 0)
                                Gnum2 = MS.guildListRegistNum21 + arc4random()%(a+1);
                            else
                                Gnum2 = MS.guildListRegistNum22;
                            
                            if(Gnum2 > GCnum2+1)
                                Gnum2 = GCnum2;
                        }
                        int n = 0;
                        int j = 0;
                        guildc = 0;
                        saveGuildList = calloc((GCnum2+1), sizeof(int));
                        if(!guildRE2) GuildDisp2 = calloc(Gnum2, sizeof(int));
                        for(int i = 0;i < Gnum2;i++){
                            if(!guildRE2){
                                n = [fieldScene chooseGuildList:GuildChosen2 gcnum:GCnum2];
                                if(n == -1)
                                    break;
                                *(GuildDisp2 + i) = *(GuildChosen2 + n);
                            }
                            
                            if(*(GuildDisp2 + i) <= 0)
                                break;
                            j++;
                        }
                        if(n == -1)
                            break;
                        
                        j = arc4random()%(j);
                        
                        BRUindex = 0;
                        for (int i = 0; UC[*(GuildDisp2 + j - k)-1].nameID != UC[i].nameID && i < UCN;i++) {
                            BRUindex++;
                        }BRU = &UC[BRUindex];
                        
                        guildRE2 = true;
                    } 
                
                int rdmCnt = rand()%100;
                    
                    if(BRU && rdmCnt > 50)
                    if(BRU->S_M.cSupply <= P[UT].resource &&
                       BRU->S_M.cFood <= P[UT].food &&
                       BRU->S_M.cMoney <= P[UT].money){
                        
                        
                        P[UT].resource -= BRU->S_M.cSupply;
                        P[UT].food -= BRU->S_M.cFood;
                        P[UT].money -= BRU->S_M.cMoney;
                        
                        unitNum[B->x][B->y] = BRU->chipNumb;
                        unitTeam[B->x][B->y] = B->team;
                        [self addUnitStatusFix];
                        break;
                    }
                }
                
            
            }
        }
        B = B->next;
    }B = BTop;
}

-(void)addUnitStatusFix{
    //おまんちん
    registerNum++;
    int omgCnt = 0;
    U = UTop;
    while (U->next) {omgCnt++;
        U = U->next;
    }
    U->next = calloc(1, sizeof(UNIT));
    U = U->next;
    U->next = NULL;
    if(omgCnt == 0) U = UTop;
    U->number = registerNum;
    
    for(int i = 0;i < UCN;i++){
        if([U->C.nameID isEqualToString:UC[i].nameID])
            U->chipNumber = i;
    }
    
    U->chipNumber = unitNum[possionX][possionY];
    U->chipNumberL = loadNum[possionX][possionY];
    U->C.chipNumb = unitNum[possionX][possionY];
    U->CL.chipNumb = loadNum[possionX][possionY];
    U->x = possionX;
    U->y = possionY;
    U->C = *BRU;
    if(unitTeam[possionX][possionY] == 0 || unitTeam[possionX][possionY] == 1){
        U->team = 0;
        if(unitTeam[possionX][possionY] == 1){
            U->joinArmyFromNext = true;
            U->persuasion = true;
        }
        if(MF[MFselectedRow+1].MS.playerSet1 == 2){
            U->CPU = true;
        }
    }
    if(unitTeam[possionX][possionY] == 2 || unitTeam[possionX][possionY] == 3){
        U->team = 2;
        if(unitTeam[possionX][possionY] == 3){
            U->joinArmyFromNext = true;
            U->persuasion = true;
        }
        if(MF[MFselectedRow+1].MS.playerSet2 == 2){
            U->CPU = true;
        }
    }
    if(unitTeam[possionX][possionY] == 4 || unitTeam[possionX][possionY] == 5){
        U->team = 1;
        if(unitTeam[possionX][possionY] == 5){
            U->joinArmyFromNext = true;
            U->persuasion = true;
        }
        U->CPU = true;
    }
    if(unitTeam[possionX][possionY] == -1){
        U->team = -1;
        if(unitTeam[possionX][possionY] == 0){
            U->joinArmyFromNext = false;
            U->persuasion = true;
        }
        U->CPU = true;
    }
    [self SetUnitStatusFix:unitNum[possionX][possionY]];
    unitColorInitFlag = true;
    U = UTop;
}

-(void)SetUnitStatusFix:(int)UN{
    
    U->C = UC[UN];
    U->C.S_C.vigor = 100;
    
    ATTACK *Atop;
    ATTACK *AtopE1;
    ATTACK *AtopE2;
    ATTACK *UAtop;
    Atop = UC[UN].A;
    AtopE1 = UC[UN].eHandL.A;
    AtopE2 = UC[UN].eHandR.A;
    U->C.A = calloc(1, sizeof(ATTACK));
    UAtop = U->C.A;
    
    bool ow1 = false;
    bool ow2 = false;
    
    while(UC[UN].eHandR.A != NULL){ow1 = true;
        *U->C.A = *UC[UN].eHandR.A;
        U->C.A->next = calloc(1, sizeof(ATTACK));
        U->C.A->next->next = NULL;
        if(UC[UN].eHandR.A->next != NULL) U->C.A = U->C.A->next;
        UC[UN].eHandR.A = UC[UN].eHandR.A->next;
        U->C.attackListNum++;
    }
    UC[UN].eHandR.A = AtopE2;
    
    
    if(ow1) {
        U->C.A = U->C.A->next;
        ow1 = false;
    }
    while(UC[UN].eHandL.A != NULL){ow2 = true;
        *U->C.A = *UC[UN].eHandL.A;
        U->C.A->next = calloc(1, sizeof(ATTACK));
        U->C.A->next->next = NULL;
        if(UC[UN].eHandL.A->next != NULL) U->C.A = U->C.A->next;
        UC[UN].eHandL.A = UC[UN].eHandL.A->next;
        U->C.attackListNum++;
    }
    UC[UN].eHandL.A = AtopE1;
    
    if(ow2) {
        U->C.A = U->C.A->next;
        ow2 = false;
    }
    while(UC[UN].A != NULL){
        *U->C.A = *UC[UN].A;
        U->C.A->next = calloc(1, sizeof(ATTACK));
        U->C.A->next->next = NULL;
        if(UC[UN].A->next != NULL) U->C.A = U->C.A->next;
        UC[UN].A = UC[UN].A->next;
    }
    U->C.A->next = NULL;
    UC[UN].A = Atop;
    U->C.A = UAtop;
    if(U->C.A) if(!U->C.A->name)
        U->C.A = NULL;
    
}

-(void)cpuSearchEnemy{
    //おまんちん
    if(!unitBreak->C.nameID) return;
    
    moveFlag = false;
    attackFlag = false;
    stanbyFlag = false;
    unitMoveEndFlag = false;
    possionX = unitBreak->x;
    possionY = unitBreak->y;
    
    UCselected = UC[unitNum[unitBreak->x][unitBreak->y]];
    LCselected = LC[loadNum[unitBreak->x][unitBreak->y]];
    
    if(unitBreak->chipNumber >= 0) [self LookupMovableRange:unitBreak->y startY:unitBreak->x aPiece:&UC[unitNum[unitBreak->x][unitBreak->y]] turnSide:YES];
    if(unitBreak->chipNumberL >= 0) [self LookupMovableRange2:unitBreak->y startY:unitBreak->x aPiece:&LC[loadNum[unitBreak->x][unitBreak->y]] turnSide:YES];
    
    for (int x = 0; x <= chipWidth; x++) {
        for (int y = 0; y <= chipHeight; y++) {
            g_targUnit[x][y] = 0;
        }
    }
    
    for (int x = 0; x <= chipWidth; x++) {
        for (int y = 0; y <= chipHeight; y++) {
            g_entireUnit[x][y] = 0;
        }
    }
    
    UNIT *UN = U;
    for (int x = 0; x <= chipWidth; x++) {
        for (int y = 0; y <= chipHeight; y++) {
            
            
            U = UTop;
            while(U){
                if(U->y == y && U->x == x){
                    g_entireUnit[x][y] = 1;
                }
                U = U->next;
            }U = UTop;
        }
    }
    
    for (int x = 0; x <= chipWidth; x++) {
        for (int y = 0; y <= chipHeight; y++) {
            
            
            U = UTop;
            while(U){
                if(g_attackRangeBeta[x][y] > 0 && U->y == y && U->x == x){
                    g_targUnit[x][y] = 1;
                }
                U = U->next;
            }U = UTop;
        }
    }
    
    
    
    AUN[1] = unitBreak->number;
    Utarget = NULL;
    CPUAttackFlag = false;
    CPUAttackFlag2 = false;
    eval_point = 0;
    U = UTop;
    //おまんちん

    
    
    while (U) {
        
        for (int x = 0; x <= chipWidth; x++) {
            for (int y = 0; y <= chipHeight; y++) {
                g_attackRangeTheta[x][y] = 0;
            }
        }
        [self checkRangeAttack:U->y startY:U->x leftPow:unitBreak->atkRange+1 pieceType:U->C.S_C.typeMONS aMap:g_attackRangeTheta aPiece:&U->C i:unitBreak->atkRange+1 ];
        
        for (int i = 1;i <= chipWidth;i++) {
            for(int k = 1;k <= chipHeight;k++){
                if(g_attackRangeTheta[i][k] > 0)
                g_attackRangeTheta[i][k] =  unitBreak->atkRange+1 - g_attackRangeTheta[i][k];
            }
        }
        
        
        ATTACK *AT = unitBreak->C.A;
        for(int i = 0;i < crCAL1;i++){
            AT = AT->next;
        }
        
        while (1) {
            if(g_attackRangeTheta[unitBreak->x][unitBreak->y] > 0 && !U->dead && AT->D->sort == 1){
                
                if(unitBreak->team == 2){
                    if(U->team == 2 && unitBreak->team == 2){
                        
                    }else{
                        break;
                        
                    }
                }
                
                if(unitBreak->team == 0 || unitBreak->team == 1){
                    if(((U->team == 1 && unitBreak->team == 0) || (U->team == 0 && unitBreak->team == 1) ||
                        (U->team == 0 && unitBreak->team == 0) || (U->team == 1 && unitBreak->team == 1))
                       ){
                        
                    }else{
                        break;
                        
                    }
                }
                
                //NSLog(@"HP %g HPH %g", U->C.S_C.HP, U->C.S_M.HP*70/100);
                if(AT->D->sort == 1 && U->C.S_C.HP <= U->C.S_M.HP*70/100){
                    
                }else{
                    break;
                }
                
                AUN[1] = unitBreak->number;
                DUN[1] = U->number;
                Utarget = U;
                unitBreak->atkRange = g_attackRangeTheta[unitBreak->x][unitBreak->y];
                g_target_x = unitBreak->y;
                g_target_y = unitBreak->x;
                unitNoMoveFlag = true;
                CPUAttackFlag = true;
                CPUAttackFlag2 = true;
                cpuIsAttackingFlag = true;
                U = UTop;
                CPUmostDmgChoice = true;
                goto w000p;
            }
            break;
        }
        
        
        if(!U->dead && AT->D->sort == 1){
            
            if(unitBreak->team == 2){
                if(U->team == 2 && unitBreak->team == 2){
                    
                }else{
                    
                    goto w00p2;
                    
                }
            }
            
            if(unitBreak->team == 0 || unitBreak->team == 1){
                if(((U->team == 1 && unitBreak->team == 0) || (U->team == 0 && unitBreak->team == 1) ||
                   (U->team == 0 && unitBreak->team == 0) || (U->team == 1 && unitBreak->team == 1))
                   ){
                    
                }else{
                    
                    goto w00p2;
                    
                }
            }
            
            
            // NSLog(@"HP %g HPH %g", U->C.S_C.HP, U->C.S_M.HP*70/100);
            if(U->C.S_C.HP <= U->C.S_M.HP*70/100){
                
            }else{
                goto w00p2;
            }
            
            for (int x = 1; x <= chipWidth; x++) {
                for (int y = 1; y <= chipHeight; y++) {
                    if(g_attackRangeTheta[x][y] > 0 && g_selectRange[x][y] > 0 && g_entireUnit[x][y] == 0
                       && g_attackRangeTheta[x][y] == unitBreak->atkRange){
                        
                        
                        int point = (unitBreak->atkRange - g_attackRangeBeta[x][y])*20 + g_selectRange[x][y]*50;
                        
                        if(eval_point < point){
                            eval_point = point;
                            Utarget = U;
                            unitBreak->atkRange = g_attackRangeTheta[x][y];
                            g_target_x = y;
                            g_target_y = x;
                            //攻撃移動回復役
                            CPUAttackFlag = true;
                            AUN[1] = unitBreak->number;
                            DUN[1] = U->number;
                        }
                        
                    }
                    
                }
                
                
            }
        }
        
    w00p2:
        U = U->next;
    }
    
    ATTACK *AT = unitBreak->C.A;
    for(int i = 0;i < crCAL1;i++){
        AT = AT->next;
    }
    
    if(!Utarget){
        [self healBreak];//回復の対象がいない時、回復以外にする
    }else if(Utarget){
        U = UTop;
        CPUmostDmgChoice = true;
        goto w000p;
    }
    
    
    U = UTop;
    
    while (U) {
        
        for (int x = 0; x <= chipWidth; x++) {
            for (int y = 0; y <= chipHeight; y++) {
                g_attackRangeTheta[x][y] = 0;
            }
        }
        [self checkRangeAttack:U->y startY:U->x leftPow:unitBreak->atkRange+1 pieceType:U->C.S_C.typeMONS aMap:g_attackRangeTheta aPiece:&U->C i:unitBreak->atkRange+1 ];
        
        for (int i = 1;i <= chipWidth;i++) {
            for(int k = 1;k <= chipHeight;k++){
                if(g_attackRangeTheta[i][k] > 0)
                g_attackRangeTheta[i][k] =  unitBreak->atkRange+1 - g_attackRangeTheta[i][k];
            }
        }
        
        ATTACK *AT = unitBreak->C.A;
        for(int i = 0;i < crCAL1;i++){
            AT = AT->next;
        }
        
        while (1) {
            if(g_attackRangeTheta[unitBreak->x][unitBreak->y] > 0 && !U->dead &&
               unitBreak->team != U->team && AT->D->sort != 1){
                
                if(unitBreak->team == 0)
                    if(U->team == 1)
                        break;
                if(unitBreak->team == 1)
                    if(U->team == 0)
                        break;
                
                
                AUN[1] = unitBreak->number;
                DUN[1] = U->number;
                bool rangeChanged = false;
                if(unitBreak->atkRange != g_attackRangeTheta[unitBreak->x][unitBreak->y]){
                
                    rangeChanged = true;
                }
                    
                    
                unitBreak->atkRange = g_attackRangeTheta[unitBreak->x][unitBreak->y];
                Utarget = U;
                g_target_x = unitBreak->y;
                g_target_y = unitBreak->x;
                unitNoMoveFlag = true;
                CPUAttackFlag = true;
                CPUAttackFlag2 = true;
                cpuIsAttackingFlag = true;
                
                if(rangeChanged){
                    [self atkSelectionFix];
                }
                goto w000p;
            }
            break;
        }
        
        
        if(!U->dead && unitBreak->team != U->team && unitBreak->C.A->D->sort != 1){
            
            if(unitBreak->team == 0)
                if(U->team == 1)
                    goto w00p;
            if(unitBreak->team == 1)
                if(U->team == 0)
                    goto w00p;
            
            for (int x = 1; x <= chipWidth; x++) {
                for (int y = 1; y <= chipHeight; y++) {
                    if(g_attackRangeTheta[x][y] > 0 && g_selectRange[x][y] > 0 && g_entireUnit[x][y] == 0
                       && g_attackRangeTheta[x][y] == unitBreak->atkRange){
                        
                        
                        int point = (unitBreak->atkRange - g_attackRangeBeta[x][y])*20 + g_selectRange[x][y]*50;
                        
                        if(eval_point < point){
                            eval_point = point;
                            Utarget = U;
                            
                            bool rangeChanged = false;
                            if(unitBreak->atkRange != g_attackRangeTheta[x][y]){
                                
                                rangeChanged = true;
                            }
                            
                            unitBreak->atkRange = g_attackRangeTheta[x][y];
                            
                           
                            
                            if(rangeChanged){
                                [self atkSelectionFix];
                            }
                            
                            g_target_x = y;
                            g_target_y = x;
                            //NSLog(@"%d", g_entireUnit[x][y]);
                            //攻撃移動
                            CPUAttackFlag = true;
                            AUN[1] = unitBreak->number;
                            DUN[1] = U->number;
                        }
                        
                    }
                    
                }
                
                
            }
        }
        
    w00p:
        U = U->next;
    }U = UTop;
    
    
    if(Utarget){
    w000p:
        if(!Utarget)
            goto w00t;
        for (int x = 0; x <= chipWidth; x++) {
            for (int y = 0; y <= chipHeight; y++) {
                g_attackRangeTheta[x][y] = 0;
            }
        }
        [self checkRangeAttack:Utarget->y startY:Utarget->x leftPow:unitBreak->atkRange+1 pieceType:U->C.S_C.typeMONS aMap:g_attackRangeTheta aPiece:&U->C i:unitBreak->atkRange+1 ];
        
        
        for (int i = 1;i <= chipWidth;i++) {
            for(int k = 1;k <= chipHeight;k++){
                if(g_attackRangeTheta[i][k] > 0)
                g_attackRangeTheta[i][k] =  unitBreak->atkRange+1 - g_attackRangeTheta[i][k];
            }
        }
        
        
        if(g_attackRangeTheta[g_target_y][g_target_x] != unitBreak->atkRange){
            Utarget = NULL;
            goto FUCKYOU;
        }
        
        
        for (int k = 0; k <= chipWidth; k++) {
            for (int g = 0; g <= chipHeight; g++) {
                g_enemyRange[k][g] = 0;
            }
        }
        
        //[self checkEnemyRange:unitBreak->atkRange+1 cntNum:0 tX:Utarget->x tY:Utarget->y aMap:g_enemyRange];
        
        //unitBreak->atkRange = unitBreak->atkRange+1 - g_enemyRange[g_target_x][g_target_y];
        
        
        
        if(UA){
            if(UA->extent > 0){
                if(1){
                    U = UTop;
                    int i = 1;
                    while(U && AUN[1] > i){i++;
                        U = U->next;
                    }
                    crCAL = crCAL1;
                    attackExceptNumber = U->number;
                    if(U->chipNumberL < 0){
                        
                        [self LookupAttackRangeExtent:Utarget->y startY:Utarget->x aPiece:&U->C turnSide:YES];
                        U = UTop;
                    }else {
                        
                        [self LookupAttackRangeExtent2:Utarget->y startY:Utarget->x aPiece:&U->CL turnSide:YES];
                    }
                    U = UTop;
                    
                }
                
                attackExtentFlag2 = true;
                [self cpuATKextentFunc];
                atkExtentFlag = true;
                cpuAtkExtendFlag = true;
            }else{
                atkExtentFlag = false;
            }
        }
        crCAL = crCAL1;
        
        
        //NSLog(@"UtargNUm %d", Utarget->number);
        return;
    }
    FUCKYOU:{}
    enum{
        MC_ANTEI,
        MC_FUANTEI,
        MC_CHIKURIN,
        MC_MIZUBA,
        MC_ASASE,
        MC_NAIBU
    };
    
    enum{
        BC_ANTEI,
        BC_CHIKURIN,
        BC_ASASE,
        BC_SONOTA
    };
    
    
    
    if(!Utarget){
    w00t:{}
        eval_point = 999;
        g_target_x = 0;
        g_target_y = 0;
        
        U = UTop;
        while (U) {
            
            if(!U->dead && U->team != unitBreak->team){
                if(unitBreak->team == 0)
                    if(U->team == 1)
                        goto w0000p;
                if(unitBreak->team == 1)
                    if(U->team == 0)
                        goto w0000p;
                
                for (int x = 1; x <= chipWidth; x++) {
                    for (int y = 1; y <= chipHeight;y++) {
                        if(g_selectRange[x][y] > 0 && g_entireUnit[x][y] == 0){
                            int dist = abs(x - U->x) + abs(y - U->y);
                            
                            
                            if(buildNum[x][y] >= 0){
                                if((buildTeam[x][y] == 0 || buildTeam[x][y] == 1) && unitBreak->team == 0)
                                    break;
                                if((buildTeam[x][y] == 2 || buildTeam[x][y] == 3) && unitBreak->team == 2)
                                    break;
                                if((buildTeam[x][y] == 4 || buildTeam[x][y] == 5) && unitBreak->team == 1)
                                    break;
                                if((buildTeam[x][y] == 0 || buildTeam[x][y] == 1) && unitBreak->team == 1)
                                    break;
                                
                                dist = 999;
                                g_target_x = y;
                                g_target_y = x;
                                U = UTop;
                                U = UN;
                                possionX = g_target_y;
                                possionY = g_target_x;
                                
                                if(unitBreak->team == 0){
                                    buildTeam[x][y] = 0;
                                }
                                if(unitBreak->team == 1){
                                    buildTeam[x][y] = 4;
                                }
                                if(unitBreak->team == 2){
                                    buildTeam[x][y] = 2;
                                }
                                if(g_target_x == unitBreak->y && g_target_y == unitBreak->x){
                                    unitNoMoveStanbyFlag = true;
                                }
                                return;
                            }
                            
                            int rdmCnt;
                            
                            rdmCnt = rand()%100;
                            
                            SKILL *ST = unitBreak->C.S;
                            if(g_selectRange[x][y] > 0 && g_entireUnit[x][y] == 0)
                            while(unitBreak->C.S){
                                if(unitBreak->C.S->type == 1){
                            if(rdmCnt > 20)
                                for(int i = 0;unitBreak->C.S->list[i] > 0;i++){
                                    if(BC[unitBreak->C.S->list[i]-1].type == BC_CHIKURIN){
                                        if(MC[chipNum[g_target_y][g_target_x]].type == MC_CHIKURIN && buildNum[g_target_y][g_target_x] < 0){
                                            
                                            
                                            int rdmCnt2;
                                            
                                            rdmCnt2 = rand()%100;
                                            if(rdmCnt2 > 40) continue;
                                            
                                            int UT = 0;
                                            
                                            if(unitBreak->team == 0){
                                                UT = 0;
                                            }else if(unitBreak->team == 2){
                                                UT = 1;
                                            }else if(unitBreak->team == 1){
                                                UT = 2;
                                            }
                                            
                                            if(BC[unitBreak->C.S->list[i]-1].Csupply <= P[UT].resource &&
                                               BC[unitBreak->C.S->list[i]-1].Cfood <= P[UT].food &&
                                               BC[unitBreak->C.S->list[i]-1].Cmoney <= P[UT].money
                                               ){
                                                
                                                if(unitBreak->team == 0){
                                                    buildTeam[g_target_y][g_target_x] = 0;
                                                }
                                                if(unitBreak->team == 1){
                                                    buildTeam[g_target_y][g_target_x] = 4;
                                                }
                                                if(unitBreak->team == 2){
                                                    buildTeam[g_target_y][g_target_x] = 2;
                                                }
                                                
                                                dist = 999;
                                                //NSLog(@"[%d, %d]", g_target_x, g_target_y);
                                                //g_target_x = x;
                                                //g_target_y = y;
                                                U = UTop;
                                                U = UN;
                                                possionX = g_target_y;
                                                possionY = g_target_x;
                                                
                                                buildNum[possionX][possionY] = BC[unitBreak->C.S->list[i]-1].chipNumb;
                                                buildTeam[possionX][possionY] = unitBreak->team;
                                                /*
                                                P[UT].resource -= BC[unitBreak->C.S->list[i]-1].Csupply;
                                                P[UT].food -= BC[unitBreak->C.S->list[i]-1].Cfood;
                                                P[UT].money -= BC[unitBreak->C.S->list[i]-1].Cmoney;
                                                */
                                                
                                                //[FS addBuildStatus];
                                                cpuBuildDoneFlag = true;
                                                [self addBuildStatusfix];
                                                ST6type = i;
                                                unitBreak->C.S = ST;
                                                if(g_target_x == unitBreak->y && g_target_y == unitBreak->x){
                                                    unitNoMoveStanbyFlag = true;
                                                }
                                                return;
                                            }
                                        }
                                        
                                    }
                                }
                            
                                
                            rdmCnt = rand()%100;
                                
                                }
                                unitBreak->C.S = unitBreak->C.S->next;
                            }
                            unitBreak->C.S = ST;
                            if(eval_point > dist && g_entireUnit[x][y] == 0){
                                eval_point = dist;
                                g_target_x = y;
                                g_target_y = x;
                            }
                        }
                    }
                }
                
            }
        w0000p:{}
            U = U->next;
        }
        
        
        
        
        
        
        
        
        
        U = UTop;
    }
    
    U = UN;
    
    if(g_target_x == unitBreak->y && g_target_y == unitBreak->x){
        unitNoMoveStanbyFlag = true;
    }
    
    if(g_target_x == 0 && g_target_y == 0){
        g_target_x = unitBreak->y;
        g_target_y = unitBreak->x;
    }
    
    possionX = g_target_y;
    possionY = g_target_x;
    
    SKILL *S6T = unitBreak->C.S;
    
    while(unitBreak->C.S){
        if(unitBreak->C.S->type == 1){
            //FieldScene *FS = [[FieldScene alloc] init];//これが原因
            int rdmCnt;
            
            rdmCnt = rand()%100;
            
            if(rdmCnt > 20)
                for(int i = 0;unitBreak->C.S->list[i] > 0;i++){
                    if(BC[unitBreak->C.S->list[i]-1].type == BC_ANTEI){
                        if(MC[chipNum[possionX][possionY]].type == MC_ANTEI && buildNum[possionX][possionY] < 0){
                           
                            int rdmCnt2;
                            rdmCnt2 = rand()%100;
                            if(rdmCnt2 > 40) continue;
                            
                            
                            int UT = 0;
                            
                            if(unitBreak->team == 0){
                                UT = 0;
                            }else if(unitBreak->team == 2){
                                UT = 1;
                            }else if(unitBreak->team == 1){
                                UT = 2;
                            }
                            
                            if(BC[unitBreak->C.S->list[i]-1].Csupply <= P[UT].resource &&
                               BC[unitBreak->C.S->list[i]-1].Cfood <= P[UT].food &&
                               BC[unitBreak->C.S->list[i]-1].Cmoney <= P[UT].money
                               ){
                                if(unitBreak->team == 0){
                                    buildTeam[possionX][possionY] = 0;
                                }
                                if(unitBreak->team == 1){
                                    buildTeam[possionX][possionY] = 4;
                                }
                                if(unitBreak->team == 2){
                                    buildTeam[possionX][possionY] = 2;
                                }
                                buildNum[possionX][possionY] = BC[unitBreak->C.S->list[i]-1].chipNumb;
                                /*
                                P[UT].resource -= BC[unitBreak->C.S->list[i]-1].Csupply;
                                P[UT].food -= BC[unitBreak->C.S->list[i]-1].Cfood;
                                P[UT].money -= BC[unitBreak->C.S->list[i]-1].Cmoney;
                               */
                               //[FS addBuildStatus];
                                cpuBuildDoneFlag = true;
                                 [self addBuildStatusfix];
                                ST6type = i;
                                unitBreak->C.S = S6T;
                                if(g_target_x == unitBreak->y && g_target_y == unitBreak->x){
                                    unitNoMoveStanbyFlag = true;
                                }
                                return;
                            }
                        }
                    }
                }
            
            rdmCnt = rand()%100;
            
            if(rdmCnt > 20)
                for(int i = 0;unitBreak->C.S->list[i] > 0;i++){
                    if(BC[unitBreak->C.S->list[i]-1].type == BC_CHIKURIN){
                        if(MC[chipNum[possionX][possionY]].type == MC_CHIKURIN && buildNum[possionX][possionY] < 0){
                            
                            
                            int rdmCnt2;
                            
                            rdmCnt2 = rand()%100;
                            if(rdmCnt2 > 40) continue;
                            
                            
                            int UT = 0;
                            
                            if(unitBreak->team == 0){
                                UT = 0;
                            }else if(unitBreak->team == 2){
                                UT = 1;
                            }else if(unitBreak->team == 1){
                                UT = 2;
                            }
                            
                            if(BC[unitBreak->C.S->list[i]-1].Csupply <= P[UT].resource &&
                               BC[unitBreak->C.S->list[i]-1].Cfood <= P[UT].food &&
                               BC[unitBreak->C.S->list[i]-1].Cmoney <= P[UT].money
                               ){
                                
                                if(unitBreak->team == 0){
                                    buildTeam[possionX][possionY] = 0;
                                }
                                if(unitBreak->team == 1){
                                    buildTeam[possionX][possionY] = 4;
                                }
                                if(unitBreak->team == 2){
                                    buildTeam[possionX][possionY] = 2;
                                }
                                
                                buildNum[possionX][possionY] = BC[unitBreak->C.S->list[i]-1].chipNumb;
                                buildTeam[possionX][possionY] = unitBreak->team;
                                /*
                                P[UT].resource -= BC[unitBreak->C.S->list[i]-1].Csupply;
                                P[UT].food -= BC[unitBreak->C.S->list[i]-1].Cfood;
                                P[UT].money -= BC[unitBreak->C.S->list[i]-1].Cmoney;
                                */
                                //[FS addBuildStatus];
                                cpuBuildDoneFlag = true;
                                 [self addBuildStatusfix];
                                ST6type = i;
                                unitBreak->C.S = S6T;
                                if(g_target_x == unitBreak->y && g_target_y == unitBreak->x){
                                    unitNoMoveStanbyFlag = true;
                                }
                                return;
                            }
                        }
                        
                    }
                }
            
            rdmCnt = rand()%100;
            
            if(rdmCnt > 20)
                for(int i = 0;unitBreak->C.S->list[i] > 0;i++){
                    if(BC[unitBreak->C.S->list[i]-1].type == BC_ASASE){
                        if(MC[chipNum[possionX][possionY]].type == MC_ASASE && buildNum[possionX][possionY] < 0){
                            
                            int rdmCnt2;
                            
                            rdmCnt2 = rand()%100;
                            if(rdmCnt2 > 40) continue;
                            
                            int UT = 0;
                            
                            if(unitBreak->team == 0){
                                UT = 0;
                            }else if(unitBreak->team == 2){
                                UT = 1;
                            }else if(unitBreak->team == 1){
                                UT = 2;
                            }
                            
                            if(BC[unitBreak->C.S->list[i]-1].Csupply <= P[UT].resource &&
                               BC[unitBreak->C.S->list[i]-1].Cfood <= P[UT].food &&
                               BC[unitBreak->C.S->list[i]-1].Cmoney <= P[UT].money
                               ){
                                
                                if(unitBreak->team == 0){
                                    buildTeam[possionX][possionY] = 0;
                                }
                                if(unitBreak->team == 1){
                                    buildTeam[possionX][possionY] = 4;
                                }
                                if(unitBreak->team == 2){
                                    buildTeam[possionX][possionY] = 2;
                                }
                                
                                buildNum[possionX][possionY] = BC[unitBreak->C.S->list[i]-1].chipNumb;
                                buildTeam[possionX][possionY] = unitBreak->team;
                                /*
                                P[UT].resource -= BC[unitBreak->C.S->list[i]-1].Csupply;
                                P[UT].food -= BC[unitBreak->C.S->list[i]-1].Cfood;
                                P[UT].money -= BC[unitBreak->C.S->list[i]-1].Cmoney;
                                */
                                //[FS addBuildStatus];
                                cpuBuildDoneFlag = true;
                                 [self addBuildStatusfix];
                                ST6type = i;
                                unitBreak->C.S = S6T;
                                if(g_target_x == unitBreak->y && g_target_y == unitBreak->x){
                                    unitNoMoveStanbyFlag = true;
                                }
                                return;
                            }
                        }
                    }
                }
        }
        unitBreak->C.S = unitBreak->C.S->next;
    }
    unitBreak->C.S = S6T;
    
    if(g_target_x == unitBreak->y && g_target_y == unitBreak->x){
        unitNoMoveStanbyFlag = true;
    }
}

-(void)atkSelectionFix{
    //おまんちん
    
    if(!Utarget)
    {
        return;
    }
    
    for(int g = 0;g <= chipWidth;g++){
        for(int h = 0; h <= chipHeight;h++){
            g_attackRangeBeta [g][h] = 0;
        }
    }
    [self LookupMovableRange:unitBreak->y startY:unitBreak->x aPiece:&unitBreak->C turnSide:YES];
    
    
    for (int x = 0; x <= chipWidth;x++) {
        for(int y = 0; y <= chipHeight;y++){
            
            if(g_selectRange[x][y] > 0 && g_selectRange[x][y] != 999 ){
                
                ATTACK *UAT;
                UA = unitBreak->C.A;
                UAT = unitBreak->C.A;
                
                
                
                if(!UAT) return;
                
                static double mostDmg = 0;
                static int mostDmgNum = 0;
                static int mostDmgCnt = 0;
                if(unitBreak->C.A) {
                    
                    while (unitBreak->C.A){
                        
                        double theDmg = 0;
                    double mpCost = floor(unitBreak->C.A->MP + unitBreak->C.A->pMP*unitBreak->C.S_M.MP/100 + 0.5);
                    
                    double vigcost = unitBreak->C.A->vigor;
                    
                    double urSupposedToGet;
                    
                    if(unitBreak->C.A) urSupposedToGet = pow(8, log(3+unitBreak->C.A->totalD/16));
                    
                    double asItIs;
                    
                    if(Utarget) asItIs = 1/log(3+Utarget->C.S_C.DEF/64);
                    
                    
                    double oopsIsRight = 0;
                    
                    if(unitBreak->C.A){
                        if(unitBreak->C.A->melee){
                            oopsIsRight = unitBreak->C.S_C.MEL;
                        }else
                            oopsIsRight = unitBreak->C.S_C.MIS;
                    }
                    oopsIsRight = oopsIsRight/100;
                    
                    mpCost = unitBreak->C.A->MP + unitBreak->C.A->pMP*unitBreak->C.S_M.MP/100 + 0.5;
                    
                    if(!Utarget->C.aura && unitBreak->C.A->D){
                        if(unitBreak->C.A->D->type == 0) theDmg = ((unitBreak->C.S_C.ATK*unitBreak->C.S_C.HP/unitBreak->C.S_M.HP+urSupposedToGet*unitBreak->C.S_C.vigor/100)*oopsIsRight
                                                             - Utarget->C.S_C.DEF*Utarget->C.S_C.HP/Utarget->C.S_M.HP/2*Utarget->C.S_C.vigor/100)*asItIs;
                        if(unitBreak->C.A->D->type == 1) theDmg = ((unitBreak->C.S_C.DEF*unitBreak->C.S_C.HP/unitBreak->C.S_M.HP+urSupposedToGet*unitBreak->C.S_C.vigor/100)*oopsIsRight
                                                             - Utarget->C.S_C.ATK*Utarget->C.S_C.HP/Utarget->C.S_M.HP/2*Utarget->C.S_C.vigor/100)*asItIs;
                        if(unitBreak->C.A->D->type == 2) theDmg = ((unitBreak->C.S_C.ACU*unitBreak->C.S_C.HP/unitBreak->C.S_M.HP+urSupposedToGet*unitBreak->C.S_C.vigor/100)*oopsIsRight
                                                             - Utarget->C.S_C.EVA*Utarget->C.S_C.HP/Utarget->C.S_M.HP/2*Utarget->C.S_C.vigor/100)*asItIs;
                        if(unitBreak->C.A->D->type == 3) theDmg = ((unitBreak->C.S_C.EVA*unitBreak->C.S_C.HP/unitBreak->C.S_M.HP+urSupposedToGet*unitBreak->C.S_C.vigor/100)*oopsIsRight
                                                             - Utarget->C.S_C.ACU*Utarget->C.S_C.HP/Utarget->C.S_M.HP/2*Utarget->C.S_C.vigor/100)*asItIs;
                        if(unitBreak->C.A->D->type == 4) theDmg = ((unitBreak->C.S_C.CAP*unitBreak->C.S_C.HP/unitBreak->C.S_M.HP+urSupposedToGet*unitBreak->C.S_C.vigor/100)*oopsIsRight
                                                             - Utarget->C.S_C.CAP*Utarget->C.S_C.HP/Utarget->C.S_M.HP/2*Utarget->C.S_C.vigor/100)*asItIs;
                        if(unitBreak->C.A->D->type == 5) theDmg = unitBreak->C.A->totalD;
                    }else if(unitBreak->C.A->D){
                        double val = val = 1/log(3+Utarget->C.S_C.MP/64);
                        if(unitBreak->C.A->D->type == 0) theDmg = ((unitBreak->C.S_C.ATK*unitBreak->C.S_C.HP/unitBreak->C.S_M.HP+urSupposedToGet*unitBreak->C.S_C.vigor/100)*oopsIsRight
                                                             - Utarget->C.S_C.DEF*Utarget->C.S_C.HP/Utarget->C.S_M.HP/2*Utarget->C.S_C.vigor/100)*asItIs*val;
                        if(unitBreak->C.A->D->type == 1) theDmg = ((unitBreak->C.S_C.DEF*unitBreak->C.S_C.HP/unitBreak->C.S_M.HP+urSupposedToGet*unitBreak->C.S_C.vigor/100)*oopsIsRight
                                                             - Utarget->C.S_C.ATK*Utarget->C.S_C.HP/Utarget->C.S_M.HP/2*Utarget->C.S_C.vigor/100)*asItIs*val;
                        if(unitBreak->C.A->D->type == 2) theDmg = ((unitBreak->C.S_C.ACU*unitBreak->C.S_C.HP/unitBreak->C.S_M.HP+urSupposedToGet*unitBreak->C.S_C.vigor/100)*oopsIsRight
                                                             - Utarget->C.S_C.EVA*Utarget->C.S_C.HP/Utarget->C.S_M.HP/2*Utarget->C.S_C.vigor/100)*asItIs*val;
                        if(unitBreak->C.A->D->type == 3) theDmg = ((unitBreak->C.S_C.EVA*unitBreak->C.S_C.HP/unitBreak->C.S_M.HP+urSupposedToGet*unitBreak->C.S_C.vigor/100)*oopsIsRight
                                                             - Utarget->C.S_C.ACU*Utarget->C.S_C.HP/Utarget->C.S_M.HP/2*Utarget->C.S_C.vigor/100)*asItIs*val;
                        if(unitBreak->C.A->D->type == 4) theDmg = ((unitBreak->C.S_C.CAP*unitBreak->C.S_C.HP/unitBreak->C.S_M.HP+urSupposedToGet*unitBreak->C.S_C.vigor/100)*oopsIsRight
                                                             - Utarget->C.S_C.CAP*Utarget->C.S_C.HP/Utarget->C.S_M.HP/2*Utarget->C.S_C.vigor/100)*asItIs*val;
                        if(unitBreak->C.A->D->type == 5) theDmg = unitBreak->C.A->totalD*val;
                    }
                    double val2 = log(3+Utarget->C.S_C.MP/64);
                    if(unitBreak->C.aura){
                        theDmg = theDmg*val2;
                    }
                        if(unitBreak->C.A->D){
                            if(unitBreak->C.A->D->fix == 2){
                                theDmg = theDmg/2 + (unitBreak->C.S_C.HIT/2*unitBreak->C.S_C.HP/unitBreak->C.S_M.HP+urSupposedToGet*unitBreak->C.S_C.vigor/100)*oopsIsRight;
                                
                                if(unitBreak->C.A->D->type == 0) theDmg -=  (Utarget->C.S_C.DEF/2*Utarget->C.S_C.HP/Utarget->C.S_M.HP/2*Utarget->C.S_C.vigor/100)*asItIs;
                                if(unitBreak->C.A->D->type == 1) theDmg -=  (Utarget->C.S_C.ATK/2*Utarget->C.S_C.HP/Utarget->C.S_M.HP/2*Utarget->C.S_C.vigor/100)*asItIs;
                                if(unitBreak->C.A->D->type == 2) theDmg -=  (Utarget->C.S_C.EVA/2*Utarget->C.S_C.HP/Utarget->C.S_M.HP/2*Utarget->C.S_C.vigor/100)*asItIs;
                                if(unitBreak->C.A->D->type == 3) theDmg -=  (Utarget->C.S_C.ACU/2*Utarget->C.S_C.HP/Utarget->C.S_M.HP/2*Utarget->C.S_C.vigor/100)*asItIs;
                                if(unitBreak->C.A->D->type == 4) theDmg -=  (Utarget->C.S_C.CAP/2*Utarget->C.S_C.HP/Utarget->C.S_M.HP/2*Utarget->C.S_C.vigor/100)*asItIs;
                                
                                
                            }else if(unitBreak->C.A->D->fix == 1){
                                theDmg = theDmg/2 + ((unitBreak->C.S_C.ATK/2+unitBreak->C.S_C.HIT/2)/2*unitBreak->C.S_C.HP/unitBreak->C.S_M.HP+urSupposedToGet*unitBreak->C.S_C.vigor/100)*oopsIsRight;
                                
                                if(unitBreak->C.A->D->type == 0) theDmg -=  (Utarget->C.S_C.DEF/2*Utarget->C.S_C.HP/Utarget->C.S_M.HP/2*Utarget->C.S_C.vigor/100)*asItIs;
                                if(unitBreak->C.A->D->type == 1) theDmg -=  (Utarget->C.S_C.ATK/2*Utarget->C.S_C.HP/Utarget->C.S_M.HP/2*Utarget->C.S_C.vigor/100)*asItIs;
                                if(unitBreak->C.A->D->type == 2) theDmg -=  (Utarget->C.S_C.EVA/2*Utarget->C.S_C.HP/Utarget->C.S_M.HP/2*Utarget->C.S_C.vigor/100)*asItIs;
                                if(unitBreak->C.A->D->type == 3) theDmg -=  (Utarget->C.S_C.ACU/2*Utarget->C.S_C.HP/Utarget->C.S_M.HP/2*Utarget->C.S_C.vigor/100)*asItIs;
                                if(unitBreak->C.A->D->type == 4) theDmg -=  (Utarget->C.S_C.CAP/2*Utarget->C.S_C.HP/Utarget->C.S_M.HP/2*Utarget->C.S_C.vigor/100)*asItIs;
                                
                            }else if(unitBreak->C.A->D->fix == 0){
                                
                            }
                        }
                    
                    theDmg = [self dmgResistFix:theDmg];
                    
                        //NSLog(@"%@:%g", unitBreak->C.A->name, theDmg);
                    if(unitBreak->C.A->rangeB >= unitBreak->atkRange && unitBreak->C.A->rangeA <= unitBreak->atkRange && mpCost <= unitBreak->C.S_C.MP && vigcost <= unitBreak->C.S_C.vigor){
                        
                        if(mostDmg <= theDmg){
                            mostDmg = theDmg;
                            mostDmgNum = mostDmgCnt;
                            CPUmostDmgChoice = true;
                        }
                        
                    }mostDmgCnt++;
                    
                        unitBreak->C.A = unitBreak->C.A->next;
                    }unitBreak->C.A = UAT;
                    
                }unitBreak->C.A = UAT;
                
                for(int i = 0;i < mostDmgNum;i++){
                    unitBreak->C.A = unitBreak->C.A->next;
                }
                UA = unitBreak->C.A;
                
                
                if(UA)
                    if(UA->rangeB <= 0) {
                        UA = unitBreak->C.A;
                        UA->rangeB = 1;
                        crCAL1 = 0;
                    }
                
                if(UA->extent > 0){
                    cpuAtkExtendFlag = true;
                }else{
                    cpuAtkExtendFlag = false;
                }
                
                mostDmg = 0;
                mostDmgNum = 0;
                mostDmgCnt = 0;
                
                unitBreak->C.A = UAT;
                crCAL1 = 0;
                while (unitBreak->C.A && UA != unitBreak->C.A) {
                    unitBreak->C.A = unitBreak->C.A->next;
                    crCAL1++;
                }
                unitBreak->C.A = UAT;
                
                crCAL = crCAL1;
                
                //unitBreak->atkRange = UA->rangeB;
                //NSLog(@"unitBreak->atkRange %d", unitBreak->atkRange);
                
            }
        }
    }

}

-(double)dmgResistFix:(double)DMG{
    
    
    int sd[22];
    
    sd[0] = Utarget->C.R_C.blow + Utarget->C.R_F.blow;
    sd[1] = Utarget->C.R_C.slash + Utarget->C.R_F.slash;
    sd[2] = Utarget->C.R_C.stub + Utarget->C.R_F.stub;
    sd[3] = Utarget->C.R_C.arrow + Utarget->C.R_F.arrow;
    sd[4] = Utarget->C.R_C.gun + Utarget->C.R_F.gun;
    sd[5] = Utarget->C.R_C.shell + Utarget->C.R_F.shell;
    
    sd[6] = Utarget->C.R_C.flame + Utarget->C.R_F.flame;
    sd[7] = Utarget->C.R_C.cold + Utarget->C.R_F.cold;
    sd[8] = Utarget->C.R_C.electoric + Utarget->C.R_F.electoric;
    sd[9] = Utarget->C.R_C.air + Utarget->C.R_F.air;
    sd[10] = Utarget->C.R_C.water + Utarget->C.R_F.water;
    sd[11] = Utarget->C.R_C.gas + Utarget->C.R_F.gas;
    sd[12] = Utarget->C.R_C.holy + Utarget->C.R_F.holy;
    sd[13] = Utarget->C.R_C.dark + Utarget->C.R_F.dark;
    sd[14] = Utarget->C.R_C.explosion + Utarget->C.R_F.explosion;
    sd[15] = Utarget->C.R_C.blood + Utarget->C.R_F.blood;
    
    sd[16] = Utarget->C.R_C.paralysis + Utarget->C.R_F.paralysis;
    sd[17] = Utarget->C.R_C.confusion + Utarget->C.R_F.confusion;
    sd[18] = Utarget->C.R_C.poison + Utarget->C.R_F.poison;
    sd[19] = Utarget->C.R_C.sleep + Utarget->C.R_F.sleep;
    sd[20] = Utarget->C.R_C.charm + Utarget->C.R_F.charm;
    sd[21] = Utarget->C.R_C.silent + Utarget->C.R_F.silent;
    
    
    
    for(int i = 0;i <= 21;i++)
        sd[i] &= ~(sd[i] >> 31);
    
       if(Utarget->C.A->D){
        if(unitBreak->C.A->D->seed == 0) DMG = DMG * sd[0]/100;
        if(unitBreak->C.A->D->seed == 1) DMG = DMG * sd[1]/100;
        if(unitBreak->C.A->D->seed == 2) DMG = DMG * sd[2]/100;
        if(unitBreak->C.A->D->seed == 3) DMG = DMG * sd[3]/100;
        if(unitBreak->C.A->D->seed == 4) DMG = DMG * sd[4]/100;
        if(unitBreak->C.A->D->seed == 5) DMG = DMG * sd[5]/100;
        
        if(unitBreak->C.A->D->seed == 6) DMG = DMG * sd[6]/100;
        if(unitBreak->C.A->D->seed == 7) DMG = DMG * sd[7]/100;
        if(unitBreak->C.A->D->seed == 8) DMG = DMG * sd[8]/100;
        if(unitBreak->C.A->D->seed == 9) DMG = DMG * sd[9]/100;
        if(unitBreak->C.A->D->seed == 10) DMG = DMG * sd[10]/100;
        if(unitBreak->C.A->D->seed == 11) DMG = DMG * sd[11]/100;
        if(unitBreak->C.A->D->seed == 12) DMG = DMG * sd[12]/100;
        if(unitBreak->C.A->D->seed == 13) DMG = DMG * sd[13]/100;
        if(unitBreak->C.A->D->seed == 14) DMG = DMG * sd[14]/100;
        if(unitBreak->C.A->D->seed == 15) DMG = DMG * sd[15]/100;
        
        if(unitBreak->C.A->D->seed == 16) DMG = DMG * sd[16]/100;
        if(unitBreak->C.A->D->seed == 17) DMG = DMG * sd[17]/100;
        if(unitBreak->C.A->D->seed == 18) DMG = DMG * sd[18]/100;
        if(unitBreak->C.A->D->seed == 19) DMG = DMG * sd[19]/100;
        if(unitBreak->C.A->D->seed == 20) DMG = DMG * sd[20]/100;
        if(unitBreak->C.A->D->seed == 21) DMG = DMG * sd[21]/100;
    }
    return DMG;
}

-(void)healBreak{

    for(int g = 0;g <= chipWidth;g++){
        for(int h = 0; h <= chipHeight;h++){
            g_attackRangeBeta [g][h] = 0;
        }
    }
    [self LookupMovableRange:unitBreak->y startY:unitBreak->x aPiece:&unitBreak->C turnSide:YES];
    
    
    for (int x = 0; x <= chipWidth;x++) {
        for(int y = 0; y <= chipHeight;y++){
            
            if(g_selectRange[x][y] > 0 && g_selectRange[x][y] != 999 ){
                
                ATTACK *UAT;
                UA = unitBreak->C.A;
                UAT = unitBreak->C.A;
                
                
                
                if(!UAT) return;
                crCAL1 = 0;
                while (unitBreak->C.A) {
                    double mpcost = floor(unitBreak->C.A->MP + unitBreak->C.A->pMP*unitBreak->C.S_M.MP/100 + 0.5);
                    
                    double vigcost = unitBreak->C.A->vigor;
                    
                    if(UA->rangeB <= unitBreak->C.A->rangeB && mpcost <= unitBreak->C.S_C.MP && vigcost <= unitBreak->C.S_C.vigor){
                        
                        if(unitBreak->C.A->D){
                            
                        if(unitBreak->C.A->D->sort == 1){
                            unitBreak->C.A = unitBreak->C.A->next;
                            continue;
                        }
                            
                        }else{
                            unitBreak->C.A = unitBreak->C.A->next;
                            continue;
                        }
                        UA = unitBreak->C.A;
                    }
                    
                    unitBreak->C.A = unitBreak->C.A->next;
                }unitBreak->C.A = UAT;
                
                
                
                if(UA)
                    if(UA->rangeB <= 0) {
                        UA = unitBreak->C.A;
                        UA->rangeB = 1;
                        crCAL1 = 0;
                    }
                
                if(UA->extent > 0){
                    cpuAtkExtendFlag = true;
                }else{
                    cpuAtkExtendFlag = false;
                }
                
                while (unitBreak->C.A && UA != unitBreak->C.A) {
                    unitBreak->C.A = unitBreak->C.A->next;
                    crCAL1++;
                }unitBreak->C.A = UAT;
                
                unitBreak->atkRange = UA->rangeB;
                //NSLog(@"unitBreak->atkRange %d", unitBreak->atkRange);
                for(int g = 0;g <= chipWidth;g++){
                    for(int h = 0; h <= chipHeight;h++){
                        g_attackRangeAlpha [g][h] = 0;
                    }
                }
                
                [self checkAttackRange:y startY:x leftPow:UA->rangeB+1 pieceType:unitBreak->C.S_C.typeMONS aMap:g_attackRangeAlpha aPiece:&unitBreak->C];
                
                for (int j = 0; j <= chipWidth;j++) {
                    for(int k = 0;k <= chipHeight;k++){
                        if(g_attackRangeBeta[j][k] < g_attackRangeAlpha[j][k]) g_attackRangeBeta[j][k] = g_attackRangeAlpha[j][k];
                    }
                }
            }
        }
    }
}
-(void)addBuildStatusfix{
    
    registerNumB++;
    
    if(registerNumB == 1){
        B = calloc(1, sizeof(BUILD));
        BTop = B;
    }
    
    B = BTop;
    while (B->next) {
        B = B->next;
    }
    if(registerNumB != 1){
        B->next = calloc(1, sizeof(BUILD));
        if(registerNumB == 2)
            BTop = B;
        B = B->next;
    }
    B->next = NULL;
    B->number = registerNumB;
    
    
    B->chipNumber = BC[buildNum[possionX][possionY]].chipNumb;
    B->x = possionX;
    B->y = possionY;
    B->C = BC[buildNum[possionX][possionY]];
    B->img = [BC[buildNum[possionX][possionY]].img retain];
    unitColorInitFlag = true;
    
    if(cpuBuildDoneFlag){
        B->C.invisible = true;
    }
    
    if(buildTeam[possionX][possionY] == 0 || buildTeam[possionX][possionY] == 1){
        B->team = 0;
        if(unitTeam[possionX][possionY] == 0){
            U->joinArmyFromNext = true;
            U->persuasion = true;
        }
    }
    if(buildTeam[possionX][possionY] == 2 || buildTeam[possionX][possionY] == 3){
        B->team = 2;
    }
    if(buildTeam[possionX][possionY] == 4 || buildTeam[possionX][possionY] == 5){
        B->team = 1;
    }
    if(buildTeam[possionX][possionY] == -1){
        B->team = -1;
        
    }
    
    B = BTop;
}


-(bool)cpuMoveFunc{
    
    static int waitTimer = 20;
    
    if (waitTimer > 0) {
        waitTimer--;
        return false;
    }else{
        waitTimer = 20;
    }
    
    g_cursol_x = unitBreak->y;
    g_cursol_y = unitBreak->x;
    
    if(moveFlag && g_selectRange[possionX][possionY] > 0){
        
        [self searchRoute];
        
        for(int i = 0;i<=chipWidth;i++){
            for(int j = 0;j<=chipHeight;j++){
                g_map[i][j] = chipNum[i][j];
                g_selectRange[i][j] = 0;
            }
        }
        moveFlag = false;
        stanbyFlag = true;
        wtPx = g_target_y;
        wtPy = g_target_x;
        wtMovedFlag = true;
        B = BTop;
        while (B) {
            if(B->x == wtPx && B->y == wtPy && B->C.capture){
                buildCaptureFlag = true;
            }
            B = B->next;
        }B = BTop;
        
    }
    
    
    
    attackFlag = false;
    stanbyFlag = true;
    menuDisplayFlag = false;
    Uselected = unitBreak;
    return true;
}

-(void)cpuATKextentFunc{
    
    
    U = UTop;
    
    if(attackExtentFlag2 && g_attackRangeExtent[Utarget->x][Utarget->y] > 0){
        attackExtentFlag2 = false;
        attackFlag = false;
        cpuAtkExtendFlag3 = true;
        for (int i = 0;i < 255;i++) {
            DUN[i] = -1;
        }
        
        int Unum = 0;
        
        
        while (U) {
            Unum++;
            U = U->next;
        }U = UTop;
        
        while(U->number != AUN[1]){
            U = U->next;
        }
        UNIT *AUNU = U;
        
        U = UTop;
        int z = 0;
        static bool okflag = true;
        while(U){
            for (int i = 0;i < 1002;i++) {
                for (int k = 0;k < 1002;k++) {
                    objeR[i][k] = 0;
                }
            }
            if(U->chipNumberL < 0){
                [self checkAttackRangeExtent:Utarget->y startY:Utarget->x leftPow:AUNU->C.A->extent+1 pieceType:1 aMap:g_attackRangeExtent aPiece:&AUNU->C];
            }else {
                [self checkAttackRangeExtent:Utarget->y startY:Utarget->x leftPow:AUNU->C.A->extent+1 pieceType:1 aMap:g_attackRangeExtent aPiece:&AUNU->C];
            }
            
            int Cnum = 0;
            
            for(int bx=1;bx<=chipWidth;bx++){
                for(int by=1;by<=chipHeight;by++){
                    if(g_attackRangeExtent[bx][by] != 999 && g_attackRangeExtent[bx][by] > 0){
                        
                        if(g_attackRangeExtent[U->x][U->y] > 0 && attackExceptNumber != U-> number){
                            Cnum++;
                            if(Unum < Cnum) goto lolzOMFG;
                            
                            
                            
                            
                            
                            if(UP)
                            {
                                if(!UPT){
                                    UPT = UP;
                                }
                                
                                UP = UPT;
                                while (UP) {
                                    if(UP->x == U->x && UP->y == U->y){
                                        
                                        break;
                                    }else{
                                        okflag = true;
                                    }
                                    
                                    UP = UP->next;
                                }
                                
                            }
                            UP = UPT;
                            
                            if(!UP) UP = calloc(1, sizeof(UNITPOINT));
                            else if(UP){
                                while(UP->next) UP = UP->next;
                            }
                            if(okflag){
                                z++;
                                UP->x = U->x;
                                UP->y = U->y;
                                UP->next = calloc(1, sizeof(UNITPOINT));
                                okflag = false;
                                DUN[z] = U->number;
                                
                            }
                        }
                        
                    }
                }
            }
            
        lolzOMFG:
            UP = NULL;
            UPT = NULL;
            
            U = U->next;
        }U = UTop;
        okflag = true;
        //NSLog(@"%d", DUN[0]);
        return;
    }else if(attackExtentFlag2){
        attackExtentFlag2 = false;
        attackFlag = false;
        cpuAtkExtendFlag3 = false;
    }
    
    
    
    
    
    
}


-(void)checkStep:(int)cnsPow tX:(int)startX tY:(int)startY type:(int)pieceType aMap:(int[][1002])aMap{
    
    int i0;
    
    aMap[startY][startX] = cnsPow;
    
    i0 = cnsPow + g_moveCost[pieceType][g_map[startY-1][startX]];
    if(aMap[startY-1][startX] > i0) [self checkStep:i0 tX:startX tY:startY-1 type:pieceType aMap:aMap];
    
    i0 = cnsPow + g_moveCost[pieceType][g_map[startY+1][startX]];
    if(aMap[startY+1][startX] > i0) [self checkStep:i0 tX:startX tY:startY+1 type:pieceType aMap:aMap];
    
    i0 = cnsPow + g_moveCost[pieceType][g_map[startY][startX-1]];
    if(aMap[startY][startX-1] > i0) [self checkStep:i0 tX:startX-1 tY:startY type:pieceType aMap:aMap];
    
    i0 = cnsPow + g_moveCost[pieceType][g_map[startY][startX+1]];
    if(aMap[startY][startX+1] > i0) [self checkStep:i0 tX:startX+1 tY:startY type:pieceType aMap:aMap];
    
    
}

-(void)checkEnemyRange:(int)cnsPow cntNum:(int)cntNum tX:(int)startX tY:(int)startY aMap:(int[][1002])aMap{
    
    int i0;
    
    aMap[startY][startX] = cnsPow;
    //NSLog(@"[%d,%d]%d\n", startY, startX, cnsPow);
    i0 = cnsPow - 1;
    if(aMap[startY-1][startX] < i0)
        [self checkEnemyRange:i0 cntNum:cnsPow tX:startX tY:startY-1 aMap:aMap];
    
    i0 = cnsPow - 1;
    if(aMap[startY+1][startX] < i0)
        [self checkEnemyRange:i0 cntNum:cnsPow tX:startX tY:startY+1 aMap:aMap];
    
    i0 = cnsPow - 1;
    if(aMap[startY][startX-1] < i0)
        [self checkEnemyRange:i0 cntNum:cnsPow tX:startX-1 tY:startY aMap:aMap];
    
    i0 = cnsPow - 1;
    if(aMap[startY][startX+1] < i0)
        [self checkEnemyRange:i0 cntNum:cnsPow tX:startX+1 tY:startY aMap:aMap];
    
    
}


-(void)mouseUp:(NSEvent *)theEvent{
    
}

-(void)loadMesh:(NSMutableArray *)theMapString index:(int)index{
    
    
}


- (void)drawRect:(NSRect)dirtyRect
{
    
    if(cpuModeMOVEflag && !unitMoveEndFlag && !cpuIsAttackingFlag)
        for (int x = 1; x <= chipWidth;x++) {
            for(int y = 1;y <= chipHeight;y++){
                
                if(g_selectRange[x][y] > 0 && !cpuOMFGmoveATKfixFlag){
                    [self DrawImage:chipMove x:(x-1)*32 y:(y-1)*32 cx:0 cy:0 f:0.8];
                    
                }
                
            }
        }
    
    
    
    int bx, by;
    for(bx=1;bx<=chipWidth;bx++){
        for(by=1;by<=chipHeight;by++){
            //[self DrawImage:chip x:(bx-1)*32-1 y:(by-1)*32 cx:bx cy:by f:1.0];
            [self DrawImage:MC[chipNum[bx][by]].img x:(bx-1)*32 y:(by-1)*32 cx:bx cy:by f:1.0];
            if(buildNum[bx][by] >= 0) {
                
                
                //[self DrawImage:BC[buildNum[bx][by]].img x:(bx-1)*32 y:(by-1)*32 cx:bx cy:by f:1.0];
                
                B = BTop;
                while (B) {
                    if(B->x == bx && B->y == by) break;
                    B = B->next;
                }
                if(B && !B->C.invisible) [self DrawImage:B->img x:(bx-1)*32 y:(by-1)*32 cx:bx cy:by f:1.0];
                B = BTop;
                
            }
            
            if(g_selectRange[bx][by] > 0 && moveFlag){
                [self DrawImage:chipMove x:(bx-1)*32 y:(by-1)*32 cx:bx cy:by f:0.8];
                /*
                switch (g_selectRange[by][bx]) {
                    case 1:
                        [self DrawImage:n1 x:bx*32 y:by*32 cx:bx cy:by f:1];
                        break;
                    case 2:
                        [self DrawImage:n2 x:bx*32 y:by*32 cx:bx cy:by f:1];
                        break;
                    case 3:
                        [self DrawImage:n3 x:bx*32 y:by*32 cx:bx cy:by f:1];
                        break;
                    case 4:
                        [self DrawImage:n4 x:bx*32 y:by*32 cx:bx cy:by f:1];
                        break;
                    case 5:
                        [self DrawImage:n5 x:bx*32 y:by*32 cx:bx cy:by f:1];
                        break;
                    case 6:
                        [self DrawImage:n6 x:bx*32 y:by*32 cx:bx cy:by f:1];
                        break;
                    case 7:
                        [self DrawImage:n7 x:bx*32 y:by*32 cx:bx cy:by f:1];
                        break;
                    case 8:
                        [self DrawImage:n8 x:bx*32 y:by*32 cx:bx cy:by f:1];
                        break;
                    case 9:
                        [self DrawImage:n9 x:bx*32 y:by*32 cx:bx cy:by f:1];
                        break;
                    case 10:
                        [self DrawImage:n10 x:bx*32 y:by*32 cx:bx cy:by f:1];
                        break;
                    case 11:
                        [self DrawImage:n11 x:bx*32 y:by*32 cx:bx cy:by f:1];
                        break;
                    case 12:
                        [self DrawImage:n12 x:bx*32 y:by*32 cx:bx cy:by f:1];
                        break;
                    case 13:
                        [self DrawImage:n13 x:bx*32 y:by*32 cx:bx cy:by f:1];
                        break;
                    case 14:
                        [self DrawImage:n14 x:bx*32 y:by*32 cx:bx cy:by f:1];
                        break;
                    case 15:
                        [self DrawImage:n15 x:bx*32 y:by*32 cx:bx cy:by f:1];
                        break;
                    case 16:
                        [self DrawImage:n16 x:bx*32 y:by*32 cx:bx cy:by f:1];
                        break;
                    case 17:
                        [self DrawImage:n17 x:bx*32 y:by*32 cx:bx cy:by f:1];
                        break;
                    case 18:
                        [self DrawImage:n18 x:bx*32 y:by*32 cx:bx cy:by f:1];
                        break;
                    case 19:
                        [self DrawImage:n19 x:bx*32 y:by*32 cx:bx cy:by f:1];
                        break;
                    case 20:
                        [self DrawImage:n20 x:bx*32 y:by*32 cx:bx cy:by f:1];
                        break;
                        
                    default:
                        break;
                }
                 */
            }
            
            if(g_attackRange[bx][by] > 0 && attackFlag){
                [self DrawImage:chipAttack x:(bx-1)*32 y:(by-1)*32 cx:bx cy:by f:0.8];
            }
            
            
             if((g_attackRangeExtent[bx][by] > 0 && attackExtentFlag)){
             [self DrawImage:chipAttack x:(bx-1)*32 y:(by-1)*32 cx:bx cy:by f:0.8];
             }
            
            if(g_summonRange[bx][by] > 0 && summonFlag){
                [self DrawImage:chipSummon x:(bx-1)*32 y:(by-1)*32 cx:bx cy:by f:0.8];
            }
            
            if(unitNum[bx][by] >= 0 || loadNum[bx][by] >= 0) {
                //[self DrawImage:UC[unitNum[bx][by]].img x:(bx-1)*32 y:(by-1)*32 cx:bx cy:by f:1.0];
                
                
                U = UTop;
                while (U) {
                    if(U->x == bx && U->y == by) break;
                    U = U->next;
                }
                if(U)
                    [self DrawImage:U->img x:(bx-1)*32 y:(by-1)*32 cx:bx cy:by f:1.0];
                U = UTop;
                
            }
        }
    }
    
    if((cpuModeATTACKflag && !unitMoveEndFlag && !cpuIsAttackingFlag))
        for (int x = 1; x <= chipWidth;x++) {
            for(int y = 1;y <= chipHeight;y++){
                
                if(g_attackRangeBeta[x][y] > 0 && !cpuOMFGmoveATKfixFlag){
                    [self DrawImage:chipSelect x:(x-1)*32 y:(y-1)*32 cx:0 cy:0 f:0.6];
                    /*
                    switch(g_attackRangeBeta[y][x]){
                        case 1:
                           [self DrawImage:n1 x:(y-1)*32 y:(x-1)*32 cx:0 cy:0 f:0.6];
                            break;
                        case 2:
                            [self DrawImage:n2 x:(y-1)*32 y:(x-1)*32 cx:0 cy:0 f:0.6];
                            break;
                        case 3:
                            [self DrawImage:n3 x:(y-1)*32 y:(x-1)*32 cx:0 cy:0 f:0.6];
                            break;
                        case 4:
                            [self DrawImage:n4 x:(y-1)*32 y:(x-1)*32 cx:0 cy:0 f:0.6];
                            break;
                        case 5:
                            [self DrawImage:n5 x:(y-1)*32 y:(x-1)*32 cx:0 cy:0 f:0.6];
                            break;
                        case 6:
                            [self DrawImage:n6 x:(y-1)*32 y:(x-1)*32 cx:0 cy:0 f:0.6];
                            break;
                        case 7:
                            [self DrawImage:n7 x:(y-1)*32 y:(x-1)*32 cx:0 cy:0 f:0.6];
                            break;
                        case 8:
                            [self DrawImage:n8 x:(y-1)*32 y:(x-1)*32 cx:0 cy:0 f:0.6];
                            break;
                        case 9:
                            [self DrawImage:n9 x:(y-1)*32 y:(x-1)*32 cx:0 cy:0 f:0.6];
                            break;
                        case 10:
                            [self DrawImage:n10 x:(y-1)*32 y:(x-1)*32 cx:0 cy:0 f:0.6];
                            break;
                    
                    
                    
                    }
                 */
                }
                
            }
        }
    /*
    if((cpuModeATTACKflag && !unitMoveEndFlag && !cpuIsAttackingFlag && Utarget))
        for (int x = 1; x <= chipWidth;x++) {
            for(int y = 1;y <= chipHeight;y++){
                
                
                for (int x = 0; x <= chipWidth; x++) {
                    for (int y = 0; y <= chipHeight; y++) {
                        g_attackRangeTheta[y][x] = 0;
                    }
                }
                [self checkRangeAttack:Utarget->y startY:Utarget->x leftPow:unitBreak->atkRange+1 pieceType:U->C.S_C.typeMONS aMap:g_attackRangeTheta aPiece:&U->C i:unitBreak->atkRange+1 ];
                
                for (int i = 0;i < chipWidth;i++) {
                    for(int k = 0;k < chipHeight;k++){
                        if(g_attackRangeTheta[i][k] > 0)
                        g_attackRangeTheta[i][k] =  unitBreak->atkRange+1 - g_attackRangeTheta[i][k];
                    }
                }
                
                if(g_attackRangeTheta[y][x] > 0 && !cpuOMFGmoveATKfixFlag){
                    [self DrawImage:chipSelect x:(y-1)*32 y:(x-1)*32 cx:0 cy:0 f:0.6];
                    
                     switch(g_attackRangeTheta[y][x]){
                     case 1:
                     [self DrawImage:n1 x:(y-1)*32 y:(x-1)*32 cx:0 cy:0 f:0.6];
                     break;
                     case 2:
                     [self DrawImage:n2 x:(y-1)*32 y:(x-1)*32 cx:0 cy:0 f:0.6];
                     break;
                     case 3:
                     [self DrawImage:n3 x:(y-1)*32 y:(x-1)*32 cx:0 cy:0 f:0.6];
                     break;
                     case 4:
                     [self DrawImage:n4 x:(y-1)*32 y:(x-1)*32 cx:0 cy:0 f:0.6];
                     break;
                     case 5:
                     [self DrawImage:n5 x:(y-1)*32 y:(x-1)*32 cx:0 cy:0 f:0.6];
                     break;
                     case 6:
                     [self DrawImage:n6 x:(y-1)*32 y:(x-1)*32 cx:0 cy:0 f:0.6];
                     break;
                     case 7:
                     [self DrawImage:n7 x:(y-1)*32 y:(x-1)*32 cx:0 cy:0 f:0.6];
                     break;
                     case 8:
                     [self DrawImage:n8 x:(y-1)*32 y:(x-1)*32 cx:0 cy:0 f:0.6];
                     break;
                     case 9:
                     [self DrawImage:n9 x:(y-1)*32 y:(x-1)*32 cx:0 cy:0 f:0.6];
                     break;
                     case 10:
                     [self DrawImage:n10 x:(y-1)*32 y:(x-1)*32 cx:0 cy:0 f:0.6];
                     break;
                     
                     
                     
                     }
                    
                }
                
            }
        }
    */
    
    if(cpuIsAttackingFlag || (UA && unitMoveEndFlag)){
        for (int x = 1; x <= chipWidth;x++) {
            for(int y = 1;y <= chipHeight;y++){
                if(g_attackRangeExtent[y][x] > 0)
                    [self DrawImage:chipAttack x:(y-1)*32 y:(x-1)*32 cx:0 cy:0 f:0.6];
            }
            
            
        }
    }
    /*
    for (int x = 1; x <= chipWidth;x++) {
        for(int y = 1;y <= chipHeight;y++){
            if(g_attackRangeTheta[x][y] > 0)
                [self DrawImage:chipAttack x:(x-1)*32 y:(y-1)*32 cx:0 cy:0 f:0.6];
        }
    }
    */
    /*
     if(cpuModeATTACKflag)
     for (int x = 0; x <= chipWidth;x++) {
     for(int y = 0 ;y <= chipHeight;y++){
     if(g_targUnit[y][x] > 0)
     [self DrawImage:chipAttack x:(y-1)*32 y:(x-1)*32 cx:bx cy:by f:1.0];
     }
     }
     */
    /*
     if(cpuModeATTACKflag)
     for (int x = 0; x <= chipWidth;x++) {
     for(int y = 0 ;y <= chipHeight;y++){
     if(g_visibleRange[y][x] > 0)
     [self DrawImage:chipMove x:(y-1)*32 y:(x-1)*32 cx:bx cy:by f:1.0];
     
     
     }
     }*/
    /*
    for (int x = 0; x <= chipWidth;x++) {
        for(int y = 0 ;y <= chipHeight;y++){
            if(g_attackRangeBeta[y][x] > 0)
            [self DrawImage:chipAttack x:(y-1)*32 y:(x-1)*32 cx:bx cy:by f:1.0];
        }
    }*/
    
    //[self DrawImage:UCselected.img x:currentPosX-32 y:currentPosY-32 cx:0 cy:0 f:1.0];
    if(Uselected && unitMoveBugFixFlag)
        [self DrawImage:Uselected->img x:currentPosX-32 y:currentPosY-32 cx:0 cy:0 f:1.0];
    
    
    [self DrawImage:chipSelect x:(possionX-1)*32 y:(possionY-1)*32 cx:0 cy:0 f:1.0];
    
    
    //if(cpuCursolMode) [self DrawImage:chipSelect x:(g_target_y-1)*32 y:(g_target_x-1)*32 cx:0 cy:0 f:1.0];
    
    if(chipTargetFlag) [self DrawImage:chipTarget x:(wtPx-1)*32 y:(wtPy-1)*32 cx:0 cy:0 f:1.0];
    
    if(Utarget && (cpuIsAttackingFlag || (UA && unitMoveEndFlag)))
        [self DrawImage:chipUtarg x:(Utarget->x-1)*32 y:(Utarget->y-1)*32 cx:bx cy:by f:1.0];
    //[self DrawImage:chipSelect x:(2-1)*32 y:(1-1)*32 cx:0 cy:0 f:1.0];
    
    /*
     for(bx=1;bx<=chipWidth;bx++){
     for(by=1;by<=chipHeight;by++){
     
     if(waypR[bx][by] != 999 && waypR[bx][by] > 0){
     [self DrawImage:chip x:(bx-1)*32 y:(by-1)*32 cx:bx cy:by f:0.7];
     
     }
     }
     
     }*/
    
    
    
    if(FieldSceneInitFlag){
        FieldSceneInitFlag = false;
        
        NSRect seRect = NSMakeRect(0, 0, chipWidth*32, chipHeight*32);
        [self setFrame:seRect];
    }
    
}





@end







@implementation FieldSideView


-(void)mouseDown:(NSEvent *)theEvent{

    stopByFSVmenuFlag = true;
    
    [fieldScene displaySideMenu];
    
}

@end






















