//
//  MapEditor.h
//  Awars III
//
//  Created by Killery on 2012/12/06.
//  Copyright (c) 2012年 Killery. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "MapChipList.h"
#import "BuildChipList.h"
#import "ChipView.h"
#import "SeedView.h"
#import "MapView.h"
#import "LoadChipList.h"

bool loadChipSideFlag;

NSString *CEIMG;
int EIMGN;

int MapChipMax;
int BuildChipMax;
int UnitChipMax;
int LoadChipMax;

int MapChipListIndex;
int BuildChipListIndex;
int UnitChipListIndex;
int LoadChipListIndex;

bool saveMapChipFlag;
bool loadMapChipFlag;
bool mapSizeChangedFlag;
bool initMapChipNumbFlag;
bool loadMapListSubmitFlag;
bool saveMapListSubmitFlag;

int postHeight;
int postWidth;

int MFselectedRow;
NSString *saveMapDataName;


bool EEGCslctFlag;
bool EEGCslctFlag2;
int EEGCslctCnt;
int etValueCnt;

int EDtextImageRow;

int EEGC1row;
int EEGC2row;

int eventListRow;

bool eventPosFlag;

NSInteger ELrow;
NSInteger EDrow;
int squareCnt;
bool editFlag;
bool insertFlag;

NSInteger EDselRow;

bool mapLoadFlagForMSD;
bool mapLoadFlagForMSD2;


bool Suicchi[9999];
bool SuicchiONOFFsentakuflag;
bool SuicchiSentakuflag;
int HensuuNum;
NSString *Hensuu[65000];
int HensuuMin;
int HensuuMax;
NSString *HensuuName[65000];
int EDvarHensuSet1Row;
int EDvarHensuSet2Row;
bool hensuuFlag;

bool selectionDBLclickFlag;
bool suicchiDBLslickFlag;
bool timerDBLslickFlag;
bool labelDBLclickFlag;
bool labeljumpDBLclickFlag;
bool memoDBLclickFlag;
bool appearDBLclickFlag;
bool dissappearDBLclickFlag;

int *ichijihensuS1;

bool EDproceedFlag;

bool EQmodeFlag;

bool battleSetMode;
int playerSet1;
int playerSet2;
bool scenarioSetMode;
int scenarioNumbCrnt;
int scenarioNumbNext;
bool employAllowedFlag;
bool buildAllowedFlag;
bool summonAllowedFlag;


NSRect scCenter;
NSInteger headerFrame;

bool EDappearFlag;
bool EDappearPosFlag;
int EDappearListRow;
int EDappearListRow2;

bool EDdissappearFlag;
bool EDdissappearPosFlag;
int EDdissappearListRow;

int EDBGMListRow;
int EDSEListRow;

int bgmNum;
int seNum;

bool EDbranchFlag;
bool EDbranchBH1Flag;
bool EDbranchBH2Flag;
int EDbranchBUrow;
int EDbranchBProw;
int EDbranchBOrow;
int EDbranchBBrow;
bool EDbranchUnitFlag;
bool EDbranchPlaceFlag;
bool EDbranchPlaceTenFlag;
bool EDbranchPlaceHaniFlag;
bool EDbranchPlaceHani2Flag;
bool EDbranchPlaceHani3Flag;
bool EDbranchPlaceKukeiFlag;
bool EDbranchPlaceKukei2Flag;
bool EDbranchObjeFlag;
bool EDbranchBuildFlag;

bool EDresourceflag;
bool EDresourceflag1;
bool EDresourceflag2;
bool EDresourceflag3;

bool EDstatusFlag;
int EDstatusRow1;
int EDstatusRow2;
int EDstatusRow3;
bool EDstatusS1Flag;
bool EDstatusS2Flag;
bool EDstatusS3Flag;

bool fuckingRetardedBtnPushed1;

int fileNumb;

int eventGuildListRow;
bool eventGUildListFlag;

bool oopsIsRightFlag;

NSTimer *timeMapEditor;

@interface MapEditor : NSObject
{
    
    
    IBOutlet NSImageView *topIV;
    IBOutlet NSTextField *topName;
    IBOutlet NSTextField *topHealth;
    
    IBOutlet NSButtonCell *EDSWON;
    IBOutlet NSButtonCell *EDSWOFF;
    IBOutlet NSTextField *EDSWTF;
    IBOutlet NSWindow *EDSwitchWindow2;
    
    
    
    
    IBOutlet NSTextField *EDeventTimeTF1;
    IBOutlet NSTextField *EDeventTimeTF2;
    IBOutlet NSPopUpButton *EDeventTrigger;
    IBOutlet NSButton *EDeventTriggerDeley;
    
    IBOutlet NSTextField *TFcurrentChipIndex;
    
    IBOutlet NSPanel *PMCL;
    IBOutlet NSPanel *PBCL;
    IBOutlet NSPanel *PUCL;
    IBOutlet NSPanel *PLCL;
    
    IBOutlet NSWindow *MapEditorWindow;
    NSPoint windowPoint;
    
    IBOutlet NSWindow *TitleWindow;
    
    IBOutlet NSPanel *mapSizeWindow;
    IBOutlet NSTextField *mapSizeHeight;
    IBOutlet NSTextField *mapSizeWidth;
    
    
    IBOutlet NSPanel *loadMapWindow;
    NSMutableArray *loadMapListMA;
    IBOutlet NSArrayController *loadMapListAC;
    IBOutlet NSTableView *loadMapListTV;
    
    IBOutlet NSPanel *saveMapWindow;
    NSMutableArray *saveMapListMA;
    IBOutlet NSArrayController *saveMapListAC;
    IBOutlet NSTableView *saveMapListTV;
    IBOutlet NSTextField *saveMapTF;
    
    
    
    IBOutlet NSWindow *eventWindow;
    NSMutableArray *eventListMA;
    IBOutlet NSArrayController *eventListAC;
    IBOutlet NSTableView *eventListTV;
    
    IBOutlet NSButton *eventCheckBtn;
    IBOutlet NSPopUpButton *eventPopupBtn;
    NSMutableArray *eventPosMA;
    IBOutlet NSArrayController *eventPosAC;
    IBOutlet NSTableView *eventPosTV;
    
    IBOutlet NSPopUpButton *eventPlayerSetPUB1;
    IBOutlet NSPopUpButton *eventPlayerSetPUB2;
    IBOutlet NSButton *eventBattleDetailBtn;
    
    
    IBOutlet NSWindow *eventEndGameCondition;
    IBOutlet NSPopUpButton *EPUB1;
    IBOutlet NSPopUpButton *EPUB2;
    NSMutableArray *EEGC1MA;
    IBOutlet NSArrayController *EEGC1AC;
    IBOutlet NSTableView *EEGC1TV;
    NSMutableArray *EEGC2MA;
    IBOutlet NSArrayController *EEGC2AC;
    IBOutlet NSTableView *EEGC2TV;
    
    IBOutlet NSTextField *EEGCstr;
    
    NSMutableArray *EEGC01MA;
    IBOutlet NSArrayController *EEGC01AC;
    IBOutlet NSTableView *EEGC01TV;
    IBOutlet NSTextField *EEGC01str;
    IBOutlet NSTextField *EEGC012str;
    
    NSMutableArray *EEGC02MA;
    IBOutlet NSArrayController *EEGC02AC;
    IBOutlet NSTableView *EEGC02TV;
    IBOutlet NSTextField *EEGC02str;
    IBOutlet NSTextField *EEGC022str;
    
    short EEGCflag;
    
    IBOutlet NSWindow *eventDetailWindow;
    NSMutableArray *eventDetailListMA;
    IBOutlet NSArrayController *eventDetailListAC;
    IBOutlet NSTableView *eventDetailListTV;
    
    NSMutableArray *EDswitch1MA;
    IBOutlet NSArrayController *EDswitch1AC;
    IBOutlet NSTableView *EDswitch1TV;
    
    NSMutableArray *EDswitch2MA;
    IBOutlet NSArrayController *EDswitch2AC;
    IBOutlet NSTableView *EDswitch2TV;
    
    NSMutableArray *EDvariableMA;
    IBOutlet NSArrayController *EDvariableAC;
    IBOutlet NSTableView *EDvariableTV;
    IBOutlet NSTextField *EDvariableTF;
    
    IBOutlet NSPopUpButton *EDitemPUB;
    IBOutlet NSPopUpButton *EDunitPUB;
    
    IBOutlet NSTextField *EDnameTF;
    IBOutlet NSButton *EDswitch1Btn;
    IBOutlet NSButton *EDswitch2Btn;
    IBOutlet NSButton *EDvariableBtn;
    IBOutlet NSButton *EDitemBtn;
    IBOutlet NSButton *EDunitBtn;
    
    IBOutlet NSWindow *eventDetailSelectionWindow;
    
    IBOutlet NSWindow *EDtextWindow;
    IBOutlet NSTextField *EDtextName;
    IBOutlet NSTextField *EDtextString;
    IBOutlet NSImageView *EDtextImage;
    
    IBOutlet NSWindow *EDtextImageWindow;
    NSMutableArray *EDtextImageMA;
    IBOutlet NSArrayController *EDtextImageAC;
    IBOutlet NSTableView *EDtextImageTV;
    IBOutlet NSButtonCell *EDtextImageButton1;
    IBOutlet NSButtonCell *EDtextImageButton2;
    IBOutlet NSButtonCell *EDtextImageButton3;
    NSInteger EDtextImageButtonValue;
    
    IBOutlet NSWindow *EDselectionWindow;
    NSMutableArray *EDselectionMA;
    IBOutlet NSArrayController *EDselectionAC;
    IBOutlet NSTableView *EDselectionTV;
    bool EDselectionEditing;
    IBOutlet NSTextField *EDselectionTF;
    IBOutlet NSTextField *EDselectionTF2;
    
    
    IBOutlet NSWindow *EDvalueWindow;
    
    NSMutableArray *EDvalueMA;
    IBOutlet NSArrayController *EDvalueAC;
    IBOutlet NSTableView *EDvalueTV;
 
    
    IBOutlet NSWindow *EDswitchWindow;
    IBOutlet NSTextField *EDswitchTF;
    
    IBOutlet NSWindow *EDvarWindow;
    NSMutableArray *EDvarMA;
    IBOutlet NSArrayController *EDvarAC;
    IBOutlet NSTableView *EDvarTV;
    IBOutlet NSTextField *EDvarTF1;
    IBOutlet NSTextField *EDvarTF2;
    IBOutlet NSButtonCell *EDvarButtonT;
    IBOutlet NSButtonCell *EDvarButtonI;
    IBOutlet NSButtonCell *EDvarButton1;
    IBOutlet NSButtonCell *EDvarButton2;
    IBOutlet NSButtonCell *EDvarButton3;
    IBOutlet NSButtonCell *EDvarButton4;
    IBOutlet NSButtonCell *EDvarButton5;
    IBOutlet NSButtonCell *EDvarButton6;
    IBOutlet NSButtonCell *EDvarButtonA;
    IBOutlet NSButtonCell *EDvarButtonB;
    IBOutlet NSButtonCell *EDvarButtonC;
    IBOutlet NSButtonCell *EDvarButtonD;
    IBOutlet NSButtonCell *EDvarButtonE;
    IBOutlet NSButtonCell *EDvarButtonF;
    IBOutlet NSButtonCell *EDvarButtonG;
    IBOutlet NSTextField *EDvarTeisu;
    NSMutableArray *EDvarHensuMA;
    IBOutlet NSArrayController *EDvarHensuAC;
    IBOutlet NSTableView *EDvarHensuTV;
    IBOutlet NSTextField *EDvarRansu1;
    IBOutlet NSTextField *EDvarRansu2;
    IBOutlet NSPopUpButton *EDvarItem;
    IBOutlet NSPopUpButton *EDvarUnit1;
    IBOutlet NSPopUpButton *EDvarUnit2;
    IBOutlet NSPopUpButton *EDvarEtc;
    
    IBOutlet NSWindow *EDvarSetWindow;
    NSMutableArray *EDvarHensuSet1MA;
    IBOutlet NSArrayController *EDvarHensuSet1AC;
    IBOutlet NSTableView *EDvarHensuSet1TV;
    NSMutableArray *EDvarHensuSet2MA;
    IBOutlet NSArrayController *EDvarHensuSet2AC;
    IBOutlet NSTableView *EDvarHensuSet2TV;
    IBOutlet NSTextField *EDvarMax;
    IBOutlet NSTextField *EDvarName;
    

    IBOutlet NSWindow *EDtimerWindow;
    IBOutlet NSButtonCell *EDtimerButton1;
    IBOutlet NSButtonCell *EDtimerButton2;
    IBOutlet NSTextField *EDtimerTF1;
    IBOutlet NSTextField *EDtimerTF2;
    
    IBOutlet NSWindow *EDtermsWindow;
    
    
    
    
    
    
    
    
    
    
    IBOutlet NSWindow *EDlabelWindow;
    IBOutlet NSTextField *EDlabelTF;
    
    IBOutlet NSWindow *EDlabelJumpWindow;
    IBOutlet NSTextField *EDlabelJumpTF;
    
    IBOutlet NSWindow *EDmemoWindow;
    IBOutlet NSTextField *EDmemoTF;
    
    IBOutlet NSWindow *EDresourceWindow;
    IBOutlet NSButton *EDresourceBtn1;
    IBOutlet NSButton *EDresourceBtn2;
    IBOutlet NSButton *EDresourceBtn3;
    IBOutlet NSButtonCell *EDresourceButton1;
    IBOutlet NSButtonCell *EDresourceButton2;
    IBOutlet NSButtonCell *EDresourceButton3;
    IBOutlet NSButtonCell *EDresourceButton4;
    IBOutlet NSButtonCell *EDresourceButton5;
    IBOutlet NSButtonCell *EDresourceButton6;
    IBOutlet NSButtonCell *EDresourceButtonS1;
    IBOutlet NSButtonCell *EDresourceButtonS2;
    IBOutlet NSButtonCell *EDresourceButtonS3;
    IBOutlet NSButtonCell *EDresourceButtonS4;
    IBOutlet NSButtonCell *EDresourceButtonS5;
    IBOutlet NSButtonCell *EDresourceButtonS6;
    IBOutlet NSTextField *EDresourceTF1;
    IBOutlet NSTextField *EDresourceTF2;
    IBOutlet NSTextField *EDresourceTF3;
    NSMutableArray *EDresourceMA1;
    IBOutlet NSArrayController *EDresourceAC1;
    IBOutlet NSTableView *EDresourceTV1;
    NSMutableArray *EDresourceMA2;
    IBOutlet NSArrayController *EDresourceAC2;
    IBOutlet NSTableView *EDresourceTV2;
    NSMutableArray *EDresourceMA3;
    IBOutlet NSArrayController *EDresourceAC3;
    IBOutlet NSTableView *EDresourceTV3;
    IBOutlet NSTextField *EDresourceTeam;
    
    IBOutlet NSWindow *EDitemWindow;
    
    
    
    
    
    
    IBOutlet NSWindow *EDmemberWindow;
    
    
    
    
    
    
    IBOutlet NSWindow *EDhpWindow;
    IBOutlet NSButtonCell *EDhpButton1;
    IBOutlet NSButtonCell *EDhpButton2;
    IBOutlet NSButtonCell *EDhpButtonA;
    IBOutlet NSButtonCell *EDhpButtonB;
    IBOutlet NSTextField *EDhpTF;
    NSMutableArray *EDhp1MA;
    IBOutlet NSArrayController *EDhp1AC;
    IBOutlet NSTableView *EDhp1TV;
    NSMutableArray *EDhp2MA;
    IBOutlet NSArrayController *EDhp2AC;
    IBOutlet NSTableView *EDhp2TV;
    
    IBOutlet NSWindow *EDmpWindow;
    IBOutlet NSButtonCell *EDmpButton1;
    IBOutlet NSButtonCell *EDmpButton2;
    IBOutlet NSButtonCell *EDmpButtonA;
    IBOutlet NSButtonCell *EDmpButtonB;
    IBOutlet NSTextField *EDmpTF;
    NSMutableArray *EDmp1MA;
    IBOutlet NSArrayController *EDmp1AC;
    IBOutlet NSTableView *EDmp1TV;
    NSMutableArray *EDmp2MA;
    IBOutlet NSArrayController *EDmp2AC;
    IBOutlet NSTableView *EDmp2TV;
    
    IBOutlet NSWindow *EDstatus;
    IBOutlet NSPopUpButton *EDstpubA;
    IBOutlet NSButtonCell *EDstButtonA11;
    IBOutlet NSButtonCell *EDstButtonA12;
    IBOutlet NSButtonCell *EDstButtonA13;
    IBOutlet NSButtonCell *EDstButtonA21;
    IBOutlet NSButtonCell *EDstButtonA22;
    IBOutlet NSTextField *EDstTFA;
    NSMutableArray *EDstA1MA;
    IBOutlet NSArrayController *EDstA1AC;
    IBOutlet NSTableView *EDstA1TV;
    NSMutableArray *EDstA2MA;
    IBOutlet NSArrayController *EDstA2AC;
    IBOutlet NSTableView *EDstA2TV;
    
    IBOutlet NSPopUpButton *EDstpubB;
    IBOutlet NSButtonCell *EDstButtonB11;
    IBOutlet NSButtonCell *EDstButtonB12;
    IBOutlet NSButtonCell *EDstButtonB13;
    IBOutlet NSButtonCell *EDstButtonB21;
    IBOutlet NSButtonCell *EDstButtonB22;
    IBOutlet NSTextField *EDstTFB;
    NSMutableArray *EDstB1MA;
    IBOutlet NSArrayController *EDstB1AC;
    IBOutlet NSTableView *EDstB1TV;
    NSMutableArray *EDstB2MA;
    IBOutlet NSArrayController *EDstB2AC;
    IBOutlet NSTableView *EDstB2TV;
    
    IBOutlet NSButtonCell *EDTimerSet1A;
    IBOutlet NSButtonCell *EDTimerSet1B;
    IBOutlet NSButtonCell *EDTimerSet2A;
    IBOutlet NSButtonCell *EDTimerSet2B;
    IBOutlet NSButtonCell *EDTimerSet3A;
    IBOutlet NSButtonCell *EDTimerSet3B;
    IBOutlet NSTextField *EDTimerTF1;
    IBOutlet NSTextField *EDTimerTF2;
    
    
    IBOutlet NSWindow *EDAppearWindow;
    NSMutableArray *EDAppear1MA;
    IBOutlet NSArrayController *EDAppear1AC;
    IBOutlet NSTableView *EDAppear1TV;
    NSMutableArray *EDAppear2MA;
    IBOutlet NSArrayController *EDAppear2AC;
    IBOutlet NSTableView *EDAppear2TV;
    IBOutlet NSButtonCell *EDAppearBC1;
    IBOutlet NSButtonCell *EDAppearBC2;
    
    IBOutlet NSWindow *EDWaitWindow;
    IBOutlet NSTextField *EDWaitTF;
    
    IBOutlet NSWindow *EDBGMWindow;
    NSMutableArray *EDBGMMA;
    IBOutlet NSArrayController *EDBGMAC;
    IBOutlet NSTableView *EDBGMTV;
    
    IBOutlet NSWindow *EDSEWindow;
    NSMutableArray *EDSEMA;
    IBOutlet NSArrayController *EDSEAC;
    IBOutlet NSTableView *EDSETV;
    
    IBOutlet NSWindow *EDtileBackWindow;
    
    IBOutlet NSWindow *EDGameOverWindow;
    IBOutlet NSButton *EDGameOverBtn;
    IBOutlet NSTextField *EDGameOverTF;
    IBOutlet NSImageView *EDGameOverIV;
    
    IBOutlet NSWindow *EDStageClearWindow;
    IBOutlet NSButton *EDStageClearBtn;
    
    IBOutlet NSButton *EDbranchSuicchi;
    IBOutlet NSButton *EDbranchHensu;
    IBOutlet NSButton *EDbranchTeisu;
    IBOutlet NSButton *EDbranchHensu2;
    IBOutlet NSButton *EDbranchTimer;
    IBOutlet NSButton *EDbranchETC;
    NSMutableArray *EDbranchSuicchiMA;
    IBOutlet NSArrayController *EDbranchSuicchiAC;
    IBOutlet NSTableView *EDbranchSuicchiTV;
    NSMutableArray *EDbranchHensuMA;
    IBOutlet NSArrayController *EDbranchHensuAC;
    IBOutlet NSTableView *EDbranchHensuTV;
    IBOutlet NSTextField *EDbranchTeisuTF;
    NSMutableArray *EDbranchHensu2MA;
    IBOutlet NSArrayController *EDbranchHensu2AC;
    IBOutlet NSTableView *EDbranchHensu2TV;
    IBOutlet NSTextField *EDbranchTimerMinTF;
    IBOutlet NSTextField *EDbranchTimerSecTF;
    IBOutlet NSPopUpButton *EDbranchPUB11;
    IBOutlet NSPopUpButton *EDbranchPUB12;
    IBOutlet NSPopUpButton *EDbranchPUB13;
    
    IBOutlet NSTextField *EDbranchJumpLabelFalse;
    IBOutlet NSTextField *EDbranchJumpLabelTrue;
    IBOutlet NSButton *EDbranchUnitNum;
    IBOutlet NSButton *EDbranchUnitSelect;
    IBOutlet NSButton *EDbranchUnitPlace;
    IBOutlet NSButton *EDbranchUnitElect;
    IBOutlet NSButton *EDbranchUnitObje;
    IBOutlet NSButton *EDbranchUnitBuild;
    IBOutlet NSTextField *EDbranchUnitTeam;
    IBOutlet NSTextField *EDbranchUnitValue;
    NSMutableArray *EDbranchUnitMA;
    IBOutlet NSArrayController *EDbranchUnitAC;
    IBOutlet NSTableView *EDbranchUnitTV;
    NSMutableArray *EDbranchPlaceMA;
    IBOutlet NSArrayController *EDbranchPlaceAC;
    IBOutlet NSTableView *EDbranchPlaceTV;
    NSMutableArray *EDbranchObjeMA;
    IBOutlet NSArrayController *EDbranchObjeAC;
    IBOutlet NSTableView *EDbranchObjeTV;
    IBOutlet NSTextField *EDbranchObjeRange;
    NSMutableArray *EDbranchBuildMA;
    IBOutlet NSArrayController *EDbranchBuildAC;
    IBOutlet NSTableView *EDbranchBuildTV;
    IBOutlet NSPopUpButton *EDbranchPUB21;
    IBOutlet NSPopUpButton *EDbranchPUB22;

    IBOutlet NSWindow *EDbrachSuicchiWindow;
    IBOutlet NSTextField *EDbrachSuicchiTF;
    IBOutlet NSWindow *EDbrachPlaceHaniWindow;
    IBOutlet NSTextField *EDbrachPlaceHaniTF;
    
    IBOutlet NSWindow *EDdissappearWindow;
    NSMutableArray *EDdissappearMA;
    IBOutlet NSArrayController *EDdissappearAC;
    IBOutlet NSTableView *EDdissappearTV;
    IBOutlet NSWindow *EDdissappearSubmitWindow;
    
    IBOutlet NSButton *eventScenarioModeBtn;
    IBOutlet NSTextField *eventScenarioCrntTF;
    IBOutlet NSTextField *eventScenarioNextTF;
    
    
    IBOutlet NSWindow *eventGuildListWindow;

    NSMutableArray *eventGuildListMA;
    IBOutlet NSArrayController *eventGuildListAC;
    IBOutlet NSTableView *eventGuildListTV;
    IBOutlet NSTextField *eventGuildTF1;
    IBOutlet NSTextField *eventGuildTF2;
    IBOutlet NSButtonCell *eventGuildBC1;
    IBOutlet NSButtonCell *eventGuildBC2;
    IBOutlet NSButton *eventGuildBTN;
    
    
    IBOutlet NSWindow *EDhpFixWindow;
    
    IBOutlet NSPopUpButton *EDhpFixPUB;
    IBOutlet NSButtonCell *EDhpFixBC1;
    IBOutlet NSButtonCell *EDhpFixBC2;
    IBOutlet NSButtonCell *EDhpFixBC3;
    IBOutlet NSButtonCell *EDhpFixBC4;
    IBOutlet NSTextField *EDhpFixTF1;
    IBOutlet NSTextField *EDhpFixTF2;
    IBOutlet NSButton *EDhpFixBtn;
    
    NSMutableArray *EDhpFixListMA1;
    IBOutlet NSArrayController *EDhpFixListAC1;
    IBOutlet NSTableView *EDhpFixListTV1;
    NSMutableArray *EDhpFixListMA2;
    IBOutlet NSArrayController *EDhpFixListAC2;
    IBOutlet NSTableView *EDhpFixListTV2;
    NSMutableArray *EDhpFixListMA3;
    IBOutlet NSArrayController *EDhpFixListAC3;
    IBOutlet NSTableView *EDhpFixListTV3;
    
    IBOutlet NSButton *eventEmployFlagBTN;
    IBOutlet NSButton *eventBuildFlagBTN;
    IBOutlet NSButton *eventSummonFlagBTN;
    
    
    IBOutlet NSWindow *EDstatusWindow;
    IBOutlet NSPopUpButton *EDstatusPB;
    IBOutlet NSButton *EDstatusCB1;
    IBOutlet NSButton *EDstatusCB2;
    IBOutlet NSButton *EDstatusCB3;
    IBOutlet NSButton *EDstatusCB4;
    IBOutlet NSButton *EDstatusCB5;
    IBOutlet NSButton *EDstatusCB6;
    IBOutlet NSButtonCell *EDstatusBC11;
    IBOutlet NSButtonCell *EDstatusBC12;
    IBOutlet NSButtonCell *EDstatusBC13;
    IBOutlet NSButtonCell *EDstatusBC21;
    IBOutlet NSButtonCell *EDstatusBC22;
    IBOutlet NSTextField *EDstatusTF1;
    IBOutlet NSTextField *EDstatusTF2;
    NSMutableArray *EDstatusMA1;
    IBOutlet NSArrayController *EDstatusAC1;
    IBOutlet NSTableView *EDstatusTV1;
    NSMutableArray *EDstatusMA2;
    IBOutlet NSArrayController *EDstatusAC2;
    IBOutlet NSTableView *EDstatusTV2;
    NSMutableArray *EDstatusMA3;
    IBOutlet NSArrayController *EDstatusAC3;
    IBOutlet NSTableView *EDstatusTV3;
    
    
    IBOutlet NSWindow *EDequipWindow;
    IBOutlet NSButtonCell *EDequipBC1;
    IBOutlet NSButtonCell *EDequipBC2;
    IBOutlet NSButton *EDequipCB1;
    IBOutlet NSButton *EDequipCB2;
    IBOutlet NSButton *EDequipCB3;
    NSMutableArray *EDequipMA1;
    IBOutlet NSArrayController *EDequipAC1;
    IBOutlet NSTableView *EDequipTV1;
    NSMutableArray *EDequipMA2;
    IBOutlet NSArrayController *EDequipAC2;
    IBOutlet NSTableView *EDequipTV2;
    NSMutableArray *EDequipMA3;
    IBOutlet NSArrayController *EDequipAC3;
    IBOutlet NSTableView *EDequipTV3;
    
}

-(IBAction)EDequipSubmit:(id)sender;
-(IBAction)EDequipCancel:(id)sender;
-(IBAction)EDequipPlaceAdd:(id)sender;
-(IBAction)EDequipValueAdd:(id)sender;
-(IBAction)EDequipPlaceDel:(id)sender;
-(IBAction)EDequipValueDel:(id)sender;

-(IBAction)EDstatusSubmit:(id)sender;
-(IBAction)EDstatusCancel:(id)sender;
-(IBAction)EDstatusPlaceAdd:(id)sender;
-(IBAction)EDstatusValueAdd:(id)sender;
-(IBAction)EDstatusPlaceDel:(id)sender;
-(IBAction)EDstatusValueDel:(id)sender;

-(IBAction)EDhpFixPlace:(id)sender;
-(IBAction)EDhpFixValue:(id)sender;
-(IBAction)EDhpFixSubmit:(id)sender;
-(IBAction)EDhpFixCancel:(id)sender;

-(IBAction)eventGuildBtnCell:(id)sender;
-(IBAction)eventGuildBtn:(id)sender;
-(IBAction)eventGuildBtnSubmit:(id)sender;

-(IBAction)EDSWOKbtn:(id)sender;
-(IBAction)EDSWCancelbtn:(id)sender;

-(IBAction)backTitle:(id)sender;
-(IBAction)saveMap:(id)sender;
-(IBAction)loadMap:(id)sender;
-(IBAction)mapSize:(id)sender;
-(IBAction)setEvent:(id)sender;

-(IBAction)mapSizeSubmit:(id)sender;
-(IBAction)mapSizeCancel:(id)sender;

-(IBAction)loadMapSubmit:(id)sender;
-(IBAction)loadMapCancel:(id)sender;

-(IBAction)saveMapSubmit:(id)sender;
-(IBAction)saveMapCancel:(id)sender;

-(IBAction)previous:(id)sender;
-(IBAction)next:(id)sender;

-(IBAction)eventInsert:(id)sender;
-(IBAction)eventDelete:(id)sender;
-(IBAction)eventSubmit:(id)sender;

-(IBAction)EEGClight:(id)sender;
-(IBAction)EEGCdark:(id)sender;
-(IBAction)EEGC1insert:(id)sender;
-(IBAction)EEGC1delete:(id)sender;
-(IBAction)EEGC2insert:(id)sender;
-(IBAction)EEGC2delete:(id)sender;
-(IBAction)EEGCsubmit:(id)sender;
-(IBAction)EEGCcancel:(id)sender;
-(IBAction)EEGC1select:(id)sender;
-(IBAction)EEGC2select:(id)sender;


-(IBAction)eventCheckBtn:(id)sender;
-(IBAction)eventPopupBtn:(id)sender;

-(IBAction)EDclose:(id)sender;
-(IBAction)EDinsert:(id)sender;
-(IBAction)EDdelete:(id)sender;

-(IBAction)EDtext:(id)sender;
-(IBAction)EDselection:(id)sender;
-(IBAction)EDvalue:(id)sender;

-(IBAction)EDswitch:(id)sender;
-(IBAction)EDvariable:(id)sender;
-(IBAction)EDtimer:(id)sender;

-(IBAction)EDterms:(id)sender;
-(IBAction)EDlabel:(id)sender;
-(IBAction)EDlabelJump:(id)sender;
-(IBAction)EDmemo:(id)sender;

-(IBAction)EDresource:(id)sender;
-(IBAction)EDitem:(id)sender;
-(IBAction)EDmember:(id)sender;

-(IBAction)EDhp:(id)sender;
-(IBAction)EDmp:(id)sender;
-(IBAction)EDstatus:(id)sender;
-(IBAction)EDstate:(id)sender;
-(IBAction)EDskill:(id)sender;
-(IBAction)EDname:(id)sender;
-(IBAction)EDequip:(id)sender;
-(IBAction)EDattackFlagOn:(id)sender;

-(IBAction)EDmove:(id)sender;
-(IBAction)EDappear:(id)sender;
-(IBAction)EDdissapear:(id)sender;

-(IBAction)EDplace:(id)sender;
-(IBAction)EDwait:(id)sender;
-(IBAction)EDpilot:(id)sender;
-(IBAction)EDunit:(id)sender;
-(IBAction)EDbgm:(id)sender;
-(IBAction)EDbgmFadeOut:(id)sender;
-(IBAction)EDse:(id)sender;
-(IBAction)EDseStop:(id)sender;

-(IBAction)EDbattle:(id)sender;
-(IBAction)EDshop:(id)sender;
-(IBAction)EDnameInput:(id)sender;

-(IBAction)EDgameOver:(id)sender;
-(IBAction)EDstageClear:(id)sender;
-(IBAction)EDtitle:(id)sender;

-(IBAction)EDcancel:(id)sender;

-(IBAction)EDtextSubmit:(id)sender;
-(IBAction)EDtextCancel:(id)sender;
-(IBAction)EDtextImageSlct:(id)sender;

-(IBAction)EDtextImageSubmit:(id)sender;
-(IBAction)EDtextImageCancel:(id)sender;
-(IBAction)EDtextImageButton:(id)sender;

-(IBAction)EDselectionAdd:(id)sender;
-(IBAction)EDselectionDelete:(id)sender;
-(IBAction)EDselectionSubmit:(id)sender;
-(IBAction)EDselectionCancel:(id)sender;

-(IBAction)EDvalueSubmit:(id)sender;
-(IBAction)EDvalueCancel:(id)sender;

-(IBAction)EDswitchSubmit:(id)sender;
-(IBAction)EDswitchCancel:(id)sender;

-(IBAction)EDvariableSubmit:(id)sender;
-(IBAction)EDvariableCancel:(id)sender;

-(IBAction)EDtimerSubmit:(id)sender;
-(IBAction)EDtimerCancel:(id)sender;

-(IBAction)EDtermsSubmit:(id)sender;
-(IBAction)EDtermsCancel:(id)sender;

-(IBAction)EDlabelSubmit:(id)sender;
-(IBAction)EDlabelCancel:(id)sender;

-(IBAction)EDlabelJumpSubmit:(id)sender;
-(IBAction)EDlabelJumpCancel:(id)sender;

-(IBAction)EDmemoSubmit:(id)sender;
-(IBAction)EDmemoCancel:(id)sender;

-(IBAction)EDresourceSubmit:(id)sender;
-(IBAction)EDresourceCancel:(id)sender;

-(IBAction)EDhpSubmit:(id)sender;
-(IBAction)EDhpCancel:(id)sender;

-(IBAction)EDmpSubmit:(id)sender;
-(IBAction)EDmpCancel:(id)sender;

-(IBAction)setBattleModeBtn:(id)sender;
-(IBAction)playerSetBtn1:(id)sender;
-(IBAction)playerSetBtn2:(id)sender;

-(IBAction)EDTimerSetBtn1:(id)sender;
-(IBAction)EDTimerSetBtn2:(id)sender;
-(IBAction)EDTimerSetBtn3:(id)sender;

-(IBAction)EDvarSetClose:(id)sender;
-(IBAction)EDvarSetMax:(id)sender;
-(IBAction)EDvarSetSubmit:(id)sender;
-(IBAction)EDvarSetSave:(id)sender;

-(IBAction)EDappearClose:(id)sender;
-(IBAction)EDappearSubmit:(id)sender;
-(IBAction)EDappearSet:(id)sender;
-(IBAction)EDappearSave:(id)sender;

-(IBAction)EDappearAdd:(id)sender;
-(IBAction)EDappearRemove:(id)sender;

-(IBAction)EDdissappearAdd:(id)sender;
-(IBAction)EDdissappearRemove:(id)sender;
-(IBAction)EDdissappearSubmit:(id)sender;


-(IBAction)EDwaitSubmit:(id)sender;
-(IBAction)EDwaitClost:(id)sender;

-(IBAction)EDBGMSubmit:(id)sender;
-(IBAction)EDBGMClose:(id)sender;
-(IBAction)EDBGMRun:(id)sender;
-(IBAction)EDBGMStop:(id)sender;

-(IBAction)EDSESubmit:(id)sender;
-(IBAction)EDSEClose:(id)sender;
-(IBAction)EDSERun:(id)sender;
-(IBAction)EDSEStop:(id)sender;

-(IBAction)EDtitleBackSubmit:(id)sender;
-(IBAction)EDtitleBackClose:(id)sender;

-(IBAction)EDGameOverSubmit:(id)sender;
-(IBAction)EDGameOverClose:(id)sender;

-(IBAction)EDStageClearSubmit:(id)sender;
-(IBAction)EDStageClearClose:(id)sender;

-(IBAction)EDbranchSubmit:(id)sender;
-(IBAction)EDbranchClose:(id)sender;

-(IBAction)EDbranchUnitAdd:(id)sender;
-(IBAction)EDbranchUnitRemove:(id)sender;
-(IBAction)EDbranchPlaceAddTen:(id)sender;
-(IBAction)EDbranchPlaceAddHani:(id)sender;
-(IBAction)EDbranchPlaceAddkukei:(id)sender;
-(IBAction)EDbranchPlaceRemove:(id)sender;
-(IBAction)EDbranchObjeAdd:(id)sender;
-(IBAction)EDbranchObjeRemove:(id)sender;
-(IBAction)EDbranchBuildAdd:(id)sender;
-(IBAction)EDbranchBuildRemove:(id)sender;

-(IBAction)EDbranchSuicchiSubmit:(id)sender;
-(IBAction)EDbranchSuicchiClose:(id)sender;
-(IBAction)EDbranchPlaceHaniSubmit:(id)sender;

-(IBAction)EDdissapearMapSubmit:(id)sender;
-(IBAction)EDdissapearUnitSubmit:(id)sender;
-(IBAction)EDdissapearSubmitCancel:(id)sender;

-(void)saveMapTFset;
-(void)initFileDirectoryOthers;
-(void)initEventGuildList;
@end
MapEditor *mapEditor;





























