//
//  OptionMenu.h
//  Awars III
//
//  Created by 桐谷 諭史 on 2016/07/23.
//  Copyright © 2016年 Killery. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <Cocoa/Cocoa.h>
#import "Title.h"
#import "FieldScene.h"

#define DEFAULT_TNAME "Awars IV"
#define DEFAULT_TVERNAME "Version 0.7 Beta"
#define DEFAULT_TOPENINGNAME "Awars IV OP.mov"
#define DEFAULT_TBGMNAME "titleBGM.mp3"
#define DEFAULT_TIMGNAME "タイトル.png"

typedef struct _OPTIONMENU{
    
    NSString *nameTitle;
    NSString *nameVersion;
    NSString *nameOpening;
    NSString *nameBGM;
    
    int adCntIT;
    int adFixIT;
    NSImage *imgTitle;
    
    bool allowMapEditor;
    bool allowScenarioEditor;
    bool onlyOnceOpening;
    bool newOpeningIsShown;

}OPTIONMENU;

OPTIONMENU wtfom;

@interface OptionMenu : NSObject
{
    IBOutlet NSWindow *OMWindow;
    
    IBOutlet NSTextField *OMTF1;
    IBOutlet NSTextField *OMTF2;
    IBOutlet NSTextField *OMTF3;
    IBOutlet NSTextField *OMTF4;
    
    IBOutlet NSImageView *OMIV;
    
    IBOutlet NSButton *OMBTN1;
    IBOutlet NSButton *OMBTN2;
    IBOutlet NSButton *OMBTN3;
}

-(IBAction)OMsubmit:(id)sender;

-(void)loadOM;

@end
OptionMenu *optionMenu;
