//
//  OptionMenu.m
//  Awars III
//
//  Created by 桐谷 諭史 on 2016/07/23.
//  Copyright © 2016年 Killery. All rights reserved.
//

#import "OptionMenu.h"

@implementation OptionMenu

-(void)awakeFromNib{
    
    [fieldScene loadOptionMenu];
    [self loadOM];
    
    NSString *directoryPath;
    
    directoryPath = [[NSBundle mainBundle] bundlePath];
    [[NSFileManager defaultManager] changeCurrentDirectoryPath:directoryPath];
    
    
    NSString* Cpath = @"Contents/Resources/";
    [[NSFileManager defaultManager] changeCurrentDirectoryPath:Cpath];
    
    directoryPath = [[[NSBundle mainBundle] bundlePath] stringByDeletingLastPathComponent];
    [[NSFileManager defaultManager] changeCurrentDirectoryPath:directoryPath];
    
    Cpath = @"data/Movie";
    
    BOOL isDirectory;
    
    [[NSFileManager defaultManager] fileExistsAtPath:Cpath isDirectory:&isDirectory];
    
    if(!isDirectory)
        [[NSFileManager defaultManager] createDirectoryAtPath:Cpath withIntermediateDirectories:YES attributes:nil error:nil];
    
    
    [[NSFileManager defaultManager] changeCurrentDirectoryPath:Cpath];
    
    if([[NSFileManager defaultManager] fileExistsAtPath:wtfom.nameOpening])
        openingAVP = [[AVPlayer playerWithURL:[NSURL fileURLWithPath:wtfom.nameOpening]] retain];
    else
        openingAVP = NULL;
    
    directoryPath = [[[NSBundle mainBundle] bundlePath] stringByDeletingLastPathComponent];
    [[NSFileManager defaultManager] changeCurrentDirectoryPath:directoryPath];
    
    Cpath = @"data/BGM/";
    [[NSFileManager defaultManager] changeCurrentDirectoryPath:Cpath];
    
    titleBGM = [[[NSSound alloc] initWithContentsOfURL:[NSURL fileURLWithPath:wtfom.nameBGM] byReference:NO] retain];
    
    [title loadFromOM:true];
    
}

-(id)init{
    

    
    NSString *directoryPath;
    
    directoryPath = [[NSBundle mainBundle] bundlePath];
    [[NSFileManager defaultManager] changeCurrentDirectoryPath:directoryPath];
    
    
    NSString* Cpath = @"Contents/Resources/";
    [[NSFileManager defaultManager] changeCurrentDirectoryPath:Cpath];
    
    optionMenu = self;
    
    if(![[NSFileManager defaultManager] fileExistsAtPath:@OPTIONFILE_NAME]){
    wtfom.nameTitle = [@DEFAULT_TNAME retain];
    wtfom.nameVersion = [@DEFAULT_TVERNAME retain];
    wtfom.nameOpening = [@DEFAULT_TOPENINGNAME retain];
    wtfom.nameBGM = [@DEFAULT_TBGMNAME retain];
    wtfom.imgTitle = [[NSImage imageNamed:@DEFAULT_TIMGNAME] retain];
    wtfom.allowMapEditor = true;
    wtfom.allowScenarioEditor = true;
    wtfom.onlyOnceOpening = true;
    wtfom.newOpeningIsShown = false;
        
    }

    
    return self;
}

-(void)loadOM{
    
    [OMTF1 setStringValue:wtfom.nameTitle];
    [OMTF2 setStringValue:wtfom.nameVersion];
    [OMTF3 setStringValue:wtfom.nameOpening];
    [OMTF4 setStringValue:wtfom.nameBGM];
    
    [OMIV setImage:wtfom.imgTitle];
 
    [OMBTN1 setState:wtfom.allowMapEditor];
    [OMBTN2 setState:wtfom.allowScenarioEditor];
    [OMBTN3 setState:wtfom.onlyOnceOpening];
}

-(void)saveOM{
    
    NSString *postNameOpening = [wtfom.nameOpening retain];
    
    wtfom.nameTitle = [[OMTF1 stringValue] retain];
    wtfom.nameVersion = [[OMTF2 stringValue] retain];
    wtfom.nameOpening = [[OMTF3 stringValue] retain];
    wtfom.nameBGM = [[OMTF4 stringValue] retain];
    wtfom.imgTitle = [[OMIV image] retain];
    wtfom.allowMapEditor = [OMBTN1 state];
    wtfom.allowScenarioEditor = [OMBTN2 state];
    wtfom.onlyOnceOpening = [OMBTN3 state];
    
    if(![postNameOpening isEqualToString:wtfom.nameOpening])
        wtfom.newOpeningIsShown = false;
    
}


-(IBAction)OMsubmit:(id)sender{

    
    [self saveOM];
    [fieldScene saveOptionMenu];
    [fieldScene loadOptionMenu];
    [title loadFromOM:false];
    [OMWindow close];
}

@end
