//
//  StringText.h
//  Awars III
//
//  Created by Killery on 2012/12/31.
//  Copyright (c) 2012年 Killery. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "EventScene.h"
#import "ScenarioList.h"

typedef struct _SVALUE{
    struct _SVALUE *next;
    NSString *slct;
    NSString *jump;
    NSString *fName;

}SVALUE;

typedef struct _NVALUE{
    struct _NVALUE *next;
    NSString *title;
    NSString *value;
    NSString *key;
    
}NVALUE;

typedef struct _STANDIMAGE{
    
    struct _STANDIMAGE *next;
    
    NSImage *imgStand;
    NSString *name;
    int standPossition;
    int standWidth;
    int standHeight;
    int standX;
    int standY;
    
    int SEMA1row;
    int SEMA2row;
    int *SEMA3flag;
    
    bool delClear;
    bool delNew;
    
}STANDIMAGE;

typedef struct _STRING{
    struct _STRING *next;
    int index;
    NSString *name;
    NSString *string;
    
    STANDIMAGE *i;
    
    NSImage *img;
    NSString *iName;//##
    
    NSImage *imgStand;
    NSString *iNameStand;//$$
    int standPossition;
    int standWidth;
    int standHeight;
    /*
    int standX;
    int standY;
    
    int SEMA1row;
    int SEMA2row;
    int *SEMA3flag;
    */
    NSImage *imgWall;
    NSString *iNameWall;//%%
    NSString *iNameWallSort;//%%4つ目
    
    NSString *jumpName;//@@
    NSString *labelName;//&&
    NSString *namingName;//≠≠
    
    NSSound *snd;
    NSString *sndName;//¢¢
    
    NSSound *sndEff;
    NSString *sndEffName;//¢¢2つ目
    
    struct _NVALUE *N;//≠≠
    struct _SVALUE *S;//**
    
    NSMutableArray *selectionName;//**
    
    NSMutableArray *flagName;//¥¥
    
    bool wallFadeIn;
    bool wallFadeOut;
    bool wallChanged;

}STRING;

STRING *ST;

STANDIMAGE *STItop;

STANDIMAGE *SItop;
STANDIMAGE *si;
STANDIMAGE *siPost;

STANDIMAGE *STANDADD;

STRING *TXCPYStop;
STANDIMAGE *TXCPYSItop;

bool mouseClicked;
bool mouseDowned;
bool mouseHolding;

@interface StringText : NSObject
{
    NSTimer *timer;
    
    NSArray *fileDataArray;
    
    IBOutlet NSTextField *TFCname;
    IBOutlet NSTextField *TFdialog;
    IBOutlet NSImageView *IVface;
    IBOutlet NSImageView *IVwall;
    IBOutlet NSImageView *IVbackGround;
    
    STRING *STtop;
    int dialogLengh;
    int dialogNumber;
    int dialogMax;
}

-(void)AddString:(STRING**)top:(int)no;

-(void)InitStringList;
@end
StringText *stringText;



