//
//  Title.h
//  Awars III
//
//  Created by Killery on 2012/12/06.
//  Copyright (c) 2012年 Killery. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <AVFoundation/AVFoundation.h>
#import <AVKit/AVKit.h>
#import "ScenarioList.h"
#import "SaveDataList.h"
#import "MapEditor.h"
#import "OptionMenu.h"
#import "FieldScene.h"

bool galleryClickedFlag;
bool startClickedFlag;


@interface Title : NSObject
{
    NSTimer *timer;
    
    IBOutlet NSWindow* TitleWindow;
    
    IBOutlet NSWindow* StartWindow;
    IBOutlet NSWindow* ContinueWindow;
    IBOutlet NSWindow* GalleryWindow;
    IBOutlet NSWindow* OptionWindow;
    IBOutlet NSWindow* MapEditorWindow;
    IBOutlet NSWindow* ScenarioEditorWindow;
    
    IBOutlet NSImageView *IVTitle;
    NSPoint windowPoint;
    
    IBOutlet NSTextField *nameTitleTF;
    IBOutlet NSTextField *nameVerionTF;
    
    IBOutlet NSButton *mapEditorBtn;
    IBOutlet NSButton *scenarioEditorBtn;
}


-(IBAction)Start:(id)sender;
-(IBAction)Continue:(id)sender;
-(IBAction)Gallery:(id)sender;
-(IBAction)Option:(id)sender;
-(IBAction)MapEditor:(id)sender;
-(IBAction)ScenarioEditor:(id)sender;
-(IBAction)Quit:(id)sender;

-(void)loadFromOM:(bool)movON;

@end
Title *title;

@interface TitleView : NSView
{

}
@end
