//
//  LoadChipList.h
//  Awars III
//
//  Created by Killery on 2014/01/14.
//  Copyright (c) 2014年 Killery. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "MapEditor.h"
#import "UnitChipList.h"
#import "FieldScene.h"

int LCN;

int LoadChipNum;

NSInteger cil;

@interface LoadChipList : NSObject
{
    NSTimer *LCLtime;
    IBOutlet NSPanel* LCLPanel;
    IBOutlet NSPanel* LCLDetailPanel;
    IBOutlet NSPanel* LCLRegisterPanel;

    NSMutableArray *loadChipListMA;
    IBOutlet NSArrayController *loadChipListAC;
    IBOutlet NSTableView *loadChipListTV;
    
    IBOutlet NSTextField *TFname;
    IBOutlet NSTextField *TFnameR;
    IBOutlet NSTextField *TFnameID;
    
    IBOutlet NSTextField *TFhp;
    IBOutlet NSTextField *TFen;
    IBOutlet NSTextField *TFwt;

    IBOutlet NSTextField *TFmov;
    IBOutlet NSTextField *TFarm;
    IBOutlet NSTextField *TFmob;
    IBOutlet NSTextField *TFlim;
    
    IBOutlet NSTextField *TFcSupply;
    IBOutlet NSTextField *TFcFood;
    IBOutlet NSTextField *TFcMoney;
    IBOutlet NSTextField *TFcWT;

    IBOutlet NSTextField *TFloadCount;
    IBOutlet NSPopUpButton *PUPtMove;
    IBOutlet NSPopUpButton *PUPtEquip;
    IBOutlet NSPopUpButton *PUPtSize;
    
    IBOutlet NSImageView *IVimg;
    IBOutlet NSImageView *IVimgb;
    
    NSArray *fileDataArray;
    NSInteger chipNumb;
    IBOutlet NSTextField *TFchipNumb;

    IBOutlet NSPanel *commandListPanel;
    IBOutlet NSPanel *attackListPanel;
    IBOutlet NSPanel *attackEditPanel;
    
    IBOutlet NSTextField *ALTFname;
    IBOutlet NSTextField *ALTFrangeA;
    IBOutlet NSTextField *ALTFrangeB;
    IBOutlet NSTextField *ALTFextend;
    IBOutlet NSPopUpButton *ALPUBcost;
    IBOutlet NSPopUpButton *ALPUBwType;
    IBOutlet NSTextField *ALTFcost;
    IBOutlet NSTextField *ALTFcostP;
    
    IBOutlet NSTextField *ALTFbullet;
    IBOutlet NSTextField *ALTFhitCount;
    IBOutlet NSTextField *ALTFsuccessRate;
    IBOutlet NSTextField *ALTFvigor;
    IBOutlet NSTextField *ALTFhitRate;
    
    IBOutlet NSButton *ALTFtrigger;
    IBOutlet NSButton *ALTFmelee;
    IBOutlet NSButton *ALTFpass;
    IBOutlet NSButton *ALTFdmgExtent;
    
    IBOutlet NSPopUpButton *ALPUBriku;
    IBOutlet NSPopUpButton *ALPUBchu;
    IBOutlet NSPopUpButton *ALPUBumi;
    IBOutlet NSPopUpButton *ALPUBsora;
    
    IBOutlet NSTextField *ALTFcSupply;
    IBOutlet NSTextField *ALTFcFood;
    IBOutlet NSTextField *ALTFcMoney;
    IBOutlet NSTextField *ALTFcmd;
    IBOutlet NSTextField *ALTFmsg;
    
    IBOutlet NSTextField *ALTFrate;
    IBOutlet NSTextField *ALTFhit;
    IBOutlet NSTextField *ALTFatkHit;
    
    IBOutlet NSPopUpButton *ALPUBtype;
    IBOutlet NSPopUpButton *ALPUBseed;
    IBOutlet NSPopUpButton *ALPUBsort;
    IBOutlet NSTextField *ALTFdmgCount;
    IBOutlet NSTextField *ALTFdmgRate;
    
    IBOutlet NSButton *ALTFcontinuum;
    IBOutlet NSButton *ALTFabsolute;
    IBOutlet NSButton *ALTFbeam;
    IBOutlet NSButton *ALTFnoSizeFix;

}



-(IBAction)submit:(id)sender;

-(IBAction)saveLCL:(id)sender;
-(IBAction)cancelLCL:(id)sender;

-(IBAction)registLCL:(id)sender;
-(IBAction)registSaveLCL:(id)sender;
-(IBAction)registCancelLCL:(id)sender;

@end
