//
//  SaveDataList.m
//  Awars III
//
//  Created by Killery on 2013/01/09.
//  Copyright (c) 2013年 Killery. All rights reserved.
//

#import "SaveDataList.h"

@implementation SaveDataList
-(IBAction)loadButton:(id)sender{
    
    datFileLoadCompFromTitle = false;
    
    if(SDLrow < 0)
        return;
    
    sdd.name = [saveListMA[SDLrow] objectForKey:@"name"];
    datFilePath = calloc(255, sizeof(char));
    strcpy(datFilePath, [sdd.name UTF8String]);
    
    datRow = SDLrow;
    [fieldScene loadGameDataDat];

    esSceneProc = 0;
    evActive = true;
    
    saveDataLoadedFlag = true;
    startES = true;
    
    datFileLoadCompFromTitle = true;
    
    [NSApp stopModal];
    [SDLPanel close];
}
-(IBAction)backButton:(id)sender{
    [SDLPanel close];
    [NSApp stopModal];
}

-(void)awakeFromNib{


    [saveListTV setTarget:self];
    [saveListTV setAction:@selector(clickSLTV:)];
    
    saveListMA = [NSMutableArray new];
}

-(id)init{
    
    if (self) {
        time  = [NSTimer
                 scheduledTimerWithTimeInterval:0.05f
                 target:self
                 selector:@selector(EventLoop:)
                 userInfo:nil
                 repeats:YES
                 ];
        saveDataList = self;
        [self initFileDirectory];
        
        
    }
    
    return self;
}

-(void)EventLoop:(NSTimer*)time{
    SDLPpoint.x = [titleWindow frame].origin.x + 100;
    SDLPpoint.y = [titleWindow frame].origin.y + 100;
    [SDLPanel setFrameOrigin:SDLPpoint];
}

-(void)clickSLTV:(id)sender{
    
    SDLrow = (int)[saveListTV clickedRow];
    
    if(SDLrow < 0) {
        [IVsave setImage:nil];
        return;
    }
    
    NSString *directoryPath;
    directoryPath = [[[NSBundle mainBundle] bundlePath] stringByDeletingLastPathComponent];
    [[NSFileManager defaultManager] changeCurrentDirectoryPath:directoryPath];
    
    
    NSString *path = @"SaveData/";
    path = [path stringByAppendingString:SAV[SDLrow]];
    
    
    
    [IVsave setImage:sdd2[SDLrow].img];
    [IVsave setImageScaling:NSScaleToFit];
    
}

-(void)NSDataTosdd:(NSData *)data
{
    
    NSKeyedUnarchiver *decoder = [[NSKeyedUnarchiver alloc] initForReadingWithData:data];
    
    //sdd2 = [[decoder decodeObject] retain];
    
    
}

-(void)initFileDirectory{
    NSString *directoryPath;
    
    directoryPath = [[[NSBundle mainBundle] bundlePath] stringByDeletingLastPathComponent];
    [[NSFileManager defaultManager] changeCurrentDirectoryPath:directoryPath];
    
    NSString *pathDATA = @"SaveData/";
    
    NSString *fileData = nil;
    
    NSFileManager *fileManager;
    NSArray *Farray;
    NSString *filePath = @"SaveData";
    fileManager = [NSFileManager defaultManager];
    Farray = [fileManager contentsOfDirectoryAtPath:filePath error:nil];
    
    
    NSMutableArray *MA = [NSMutableArray new];
    for (int i = 0;i < [Farray count];i++) {
        if([[Farray objectAtIndex:i] isEqualToString:@"img"])
            continue;
        else if([[Farray objectAtIndex:i] isEqualToString:@".DS_Store"])
            continue;
        
        [MA addObject:[Farray objectAtIndex:i]];
        
    }
    
    saveNumb = [MA count];
    for(int i = 1; i <= saveNumb;i++) {

        SDL[i].name = [[MA objectAtIndex:i-1] retain];
    
        pathDATA = [NSString stringWithFormat:@"SaveData/%@", SDL[i].name];
        
        fileData = [NSString stringWithContentsOfFile:pathDATA encoding:NSUTF8StringEncoding error:nil];
        fileDataArray = [fileData componentsSeparatedByString:@"\n"];
        
        NSArray *items0 = [fileDataArray[0] componentsSeparatedByString:@","];
        
        SDL[i].levelName = [[items0 objectAtIndex:0] retain];
        SDL[i].scenarioName = [[items0 objectAtIndex:1] retain];
        SDL[i].mapfileName = [[items0 objectAtIndex:2] retain];
        SDL[i].scenarioNumbCrnt = [[items0 objectAtIndex:3] intValue];
        SDL[i].scenarioNumbNext = [[items0 objectAtIndex:4] intValue];
    }
    
    
    
    //NSLog(@"%@", Farray);
}

-(void)initSAV{

    NSString *directoryPath;
    
    directoryPath = [[[NSBundle mainBundle] bundlePath] stringByDeletingLastPathComponent];
    [[NSFileManager defaultManager] changeCurrentDirectoryPath:directoryPath];

    NSString *path = @"SaveData/";
    
    NSArray *ary = [[NSFileManager defaultManager] contentsOfDirectoryAtPath:path error:nil];
    
    [SAV removeAllObjects];
    for(NSString *name in ary){
        
        NSArray *arr = [name componentsSeparatedByString:@".sav"];
        
        if([arr count] > 1){
            [SAV addObject:name];
        }
    }


}

-(void)initSaveList{
    
    [self initSAV];
    
    [self willChangeValueForKey:@"saveListMA"];
    [saveListMA removeAllObjects];
    [self didChangeValueForKey:@"saveListMA"];
    
    datRow = 0;
    for(int i = 0;i < [SAV count];i++){
        NSMutableDictionary* dict = [NSMutableDictionary new];
        
        [dict setValue:SAV[i] forKey:@"name"];
        [self willChangeValueForKey:@"saveListMA"];
        [saveListMA addObject:dict];
        [self didChangeValueForKey:@"saveListMA"];
        
        datFilePath = calloc(255, sizeof(char));
        strcpy(datFilePath, [SAV[i] UTF8String]);
        [fieldScene loadStruct];
        datRow++;
    }datRow = -1;
    [saveListAC setSelectionIndex:9999];
    SDLrow = -1;
}

-(void)saveSaveList{

    NSString *directoryPath;
    
    directoryPath = [[[NSBundle mainBundle] bundlePath] stringByDeletingLastPathComponent];
    [[NSFileManager defaultManager] changeCurrentDirectoryPath:directoryPath];

    NSString *pathFOLDER = @"SaveData/";
    NSString *fileData = @"";
    
    MAPSCRIPT MS = MF[MFselectedRow+1].MS;
    
    
    fileData = [fileData stringByAppendingString:
                 [NSString stringWithFormat:@"%@,%@,%@,%d,%d\n",
                  SC[storyNumb].name, SC[storyNumb].sName[scenarioNumb], SC[storyNumb].nameMAP[scenarioNumb], MS.scenarioNumbCrnt, MS.scenarioNumbNext]];

    pathFOLDER = [pathFOLDER stringByAppendingString:[NSString stringWithFormat:@"%@",saveFileNameSDL]];
    
    [fileData writeToFile:pathFOLDER atomically:YES encoding:NSUTF8StringEncoding error:nil];

    [self initFileDirectory];
}

@end
