//
//  ScenarioList.h
//  Awars III
//
//  Created by Killery on 2013/01/09.
//  Copyright (c) 2013年 Killery. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "EventScene.h"
#import "StringText.h"
#import "FieldScene.h"
#import "Title.h"

typedef struct _SCENARIO{
    NSString *name;
    NSString *iName;
    NSImage *img;
    
    NSMutableArray *sName;
    NSMutableArray *nameSceneStart;
    NSMutableArray *nameMAP;
    NSMutableArray *nameSceneEnd;
    
    NSMutableArray *scenarioNumbCrnt;
    NSMutableArray *scenarioNumbNext;
    
    NSString *saveFileName;
    NSString *CrntLevelName;
    
}SCENARIO;

SCENARIO SC[255];
int scenarioNumb;
int storyNumb;
int SCarray;
NSInteger selectNumb;

bool SCinputEndFlag;

NSString *sNameInst;

@interface ScenarioList : NSObject
{
    NSTimer *time;
    
    IBOutlet NSWindow *titleWindow;
    
    IBOutlet NSPanel* SLPanel;
    NSPoint SLPpoint;
    
    NSMutableArray *scenarioListMA;
    IBOutlet NSArrayController *scenarioListAC;
    IBOutlet NSTableView *scenarioListTV;
    
    IBOutlet NSImageView *IVscene;
    IBOutlet NSPopUpButton *PUBscenario;
    
    NSArray *fileDataArray;
    NSInteger sceneNumb;
    
    IBOutlet NSWindow *eventSceneWindow;
    
    IBOutlet NSWindow *loadWindow;
    
    NSMutableArray *scenarioList2MA;
    IBOutlet NSArrayController *scenarioList2AC;
    IBOutlet NSTableView *scenarioList2TV;
    
    IBOutlet NSImageView *IVscene2;
    IBOutlet NSTextField *TFscene2;
}

-(IBAction)startButton:(id)sender;
-(IBAction)backButton:(id)sender;
-(IBAction)listButton:(id)sender;
-(IBAction)windowMove:(id)sender;

-(IBAction)loadButton:(id)sender;
-(IBAction)initButton:(id)sender;

-(IBAction)loadSubmitButton:(id)sender;
-(IBAction)loadCancelButton:(id)sender;

-(void)setScenarioList:(NSInteger)selectNumb;
-(void)initFileDirectory;
-(void)initScenarioList;
@end
ScenarioList *scenarioList;
